//
// **** DO NOT EDIT ****
// This file -- /builddir/build/BUILD/openrv-3.0.0-build/OpenRV-main/redhat-linux-build/src/lib/ip/IPCore/ColorVibrance_glsl.cpp -- was automatically generated
// from the file /builddir/build/BUILD/openrv-3.0.0-build/OpenRV-main/src/lib/ip/IPCore/glsl/ColorVibrance.glsl by quoteFile.
//
const char* ColorVibrance_glsl = "//\n"
"// Copyright (C) 2023  Autodesk, Inc. All Rights Reserved. \n"
"// \n"
"// SPDX-License-Identifier: Apache-2.0 \n"
"//\n"
"\n"
"vec4 ColorVibrance(const in vec4 P,\n"
"                   const in vec3 rec,\n"
"                   const in float saturation)\n"
"{\n"
"    // compute this P's saturation\n"
"    float maxV = max(P.r, max(P.g, P.b));\n"
"    float minV = min(P.r, min(P.g, P.b));\n"
"    float ps;\n"
"    float epsilon = 0.0001;\n"
"    if (abs(maxV) < epsilon) ps = 0.0;\n"
"    else ps = (maxV - minV) / maxV;\n"
"    \n"
"    // luminance\n"
"    float l = 0.299 * P.r + 0.587 * P.g + 0.114 * P.b;\n"
"    float ls = min(l, 0.25) / 0.25;\n"
"\n"
"    float s = (saturation - 1.0) * (1.0 - ps) + 1.0;\n"
"    s = (s - 1.0) * ls + 1.0;\n"
"    \n"
"    float rw709 = rec.r;\n"
"    float gw709 = rec.g;\n"
"    float bw709 = rec.b;\n"
"    \n"
"    float a = (1.0 - s) * rw709 + s;\n"
"    float b = (1.0 - s) * rw709;\n"
"    float c = (1.0 - s) * rw709;\n"
"    float d = (1.0 - s) * gw709;\n"
"    float e = (1.0 - s) * gw709 + s;\n"
"    float f = (1.0 - s) * gw709;\n"
"    float g = (1.0 - s) * bw709;\n"
"    float h = (1.0 - s) * bw709;\n"
"    float i = (1.0 - s) * bw709 + s;\n"
"    \n"
"    vec3 outC;\n"
"    outC.r = a * P.r + d * P.g + g * P.b;\n"
"    outC.g = b * P.r + e * P.g + h * P.b;\n"
"    outC.b = c * P.r + f * P.g + i * P.b;\n"
"    \n"
"    return vec4(outC, P.a);\n"
"}"
;
