//
// **** DO NOT EDIT ****
// This file -- /builddir/build/BUILD/openrv-3.0.0-build/OpenRV-main/redhat-linux-build/src/lib/ip/IPCore/Dither_glsl.cpp -- was automatically generated
// from the file /builddir/build/BUILD/openrv-3.0.0-build/OpenRV-main/src/lib/ip/IPCore/glsl/Dither.glsl by quoteFile.
//
const char* Dither_glsl = "//\n"
"// Copyright (C) 2023  Autodesk, Inc. All Rights Reserved. \n"
"// \n"
"// SPDX-License-Identifier: Apache-2.0 \n"
"//\n"
"// dither shader from pixar \n"
"\n"
"// for uniformly random input p generate uniform random number on [-1.0,1.0] \n"
"#if __VERSION__ < 150\n"
"\n"
"float rnd(vec2 p)\n"
"{ \n"
"    return 1.0 - 2.0*fract(sin(dot(p.xy ,vec2(12.9898,78.233))) * 43758.5453);\n"
"}\n"
"\n"
"#else\n"
"float rnd(vec2 p)\n"
"{ \n"
"    int n = int(p.x * 40.0 + p.y * 6400.0); \n"
"    n = (n << 13) ^ n; \n"
"    return 1.0 - float( (n * (n * n * 15731 + 789221) + 1376312589) & 0x7fffffff) / 1073741824.0; \n"
"}\n"
"\n"
"#endif\n"
"\n"
"vec4 main(const in inputImage in0,\n"
"          const in outputImage win,\n"
"          const in float scale, // 2^bits - 1, so for 8 bit disp scale == 255.0\n"
"          const in float seed)\n"
"{ \n"
"    vec2 coord = in0.st / in0.size();\n"
"\n"
"    vec4 texCol = in0();\n"
"\n"
"    vec3 c = texCol.rgb; \n"
"    float a = texCol.a;\n"
"\n"
"    // We need a 2D coordinate to compute a spatial dither. \n"
"    // \n"
"    // If we use only the screen coordinate gl_FragCoord, \n"
"    // we get a result that sticks to the screen and looks like \n"
"    // a dirty window or screen door. \n"
"    // \n"
"    // If we use only the texture coordinate, we get a result \n"
"    // that sticks to the image but looks blocky as we zoom in. \n"
"    // \n"
"    // To ameliorate these unwanted artifacts we combine both \n"
"    // screen and texture coordinates in our computation. \n"
"    // We also scale the texture coordinate to avoid streaking \n"
"    // or blocky artifacts for zoomed-in textures. \n"
"    // \n"
"    // Furthermore, since rnd() is stateless in order to take \n"
"    // advantage of parallel computation (and is really just a \n"
"    // hash function), we use slightly different perturbations \n"
"    // for each of R, G, and B components to effectively make \n"
"    // them randomly different from each other.\n"
"    //\n"
"    //  UPDATE: the dither shading happens at the end of the display pipeline\n"
"    //  where the render target is the same size as the view, so there is no\n"
"    //  point in using texture coords _and_ frag coords.  We also want the\n"
"    //  dither pattern to change when (1) the view transform changes or (2) the\n"
"    //  frame changes or (3) ?, so we accept a \"seed\" from the calling code\n"
"    //  that should incorporate all these factors.  The seed should vary\n"
"    //  between 0 and 1.\n"
"\n"
"    vec2 pr = (0.9 + 0.1 * seed) * coord.xy * 1000.1; \n"
"    vec2 pg = (0.9 + 0.1 * seed) * coord.xy * 1000.2; \n"
"    vec2 pb = (0.9 + 0.1 * seed) * coord.xy * 1000.3;\n"
"\n"
"    // Dither to N bits since driver doesn't seem to be doing this correctly. \n"
"\n"
"    // Note that we don't actually quantize here. Instead, we assume that \n"
"    // the last driver step will be to round to the nearest N bits, so we \n"
"    // simply add the dither bias centered around 0.0 and scaled to 2^N-1.\n"
"\n"
"    return vec4(c.rgb + vec3(rnd(pr), rnd(pg), rnd(pb)) * vec3(0.5) / vec3(scale), a);\n"
"}\n"
;
