//
// **** DO NOT EDIT ****
// This file -- /builddir/build/BUILD/openrv-3.0.0-build/OpenRV-main/redhat-linux-build/src/lib/ip/IPCore/LensWarpRadial_glsl.cpp -- was automatically generated
// from the file /builddir/build/BUILD/openrv-3.0.0-build/OpenRV-main/src/lib/ip/IPCore/glsl/LensWarpRadial.glsl by quoteFile.
//
const char* LensWarpRadial_glsl = "//\n"
"// Copyright (C) 2023  Autodesk, Inc. All Rights Reserved. \n"
"// \n"
"// SPDX-License-Identifier: Apache-2.0 \n"
"//\n"
"//\n"
"// Adapted from http://en.wikipedia.org/wiki/Distortion_%28optics%29\n"
"// or OpenCV http://opencv.willowgarage.com/documentation/camera_calibration_and_3d_reconstruction.html\n"
"// x corrected = x( 1 + k1 * r^2 + k2 * r^4 + k3 * r^6)\n"
"// y corrected = y( 1 + k1 * r^2 + k2 * r^4 + k3 * r^6)\n"
"// \n"
"// distortion centre, offset is specified within range [-1... 1]\n"
"//\n"
"\n"
"\n"
"vec4 LensWarpRadial (const in inputImage in0,\n"
"                     const in float k1,\n"
"                     const in float k2,\n"
"                     const in float k3,\n"
"                     const in float d,\n"
"                     const in vec2  offset,\n"
"                     const in vec2  f)\n"
"{\n"
"    vec2 cp = offset - in0.st;        // current pixel from center\n"
"\n"
"    vec2 ncp = cp / f;  	      // normalized current pixel\n"
"\n"
"    float rdest = ncp.x * ncp.x + ncp.y * ncp.y; // radius\n"
"\n"
"    // Radial distortion\n"
"    float rsrc  =  ((k3 * rdest + k2) * rdest + k1) * rdest + d; // new radius\n"
"\n"
"    vec2 op = cp - ncp * vec2(rsrc) * f;\n"
"\n"
"    return in0(op);\n"
"}\n"
"\n"
;
