//
// **** DO NOT EDIT ****
// This file -- /builddir/build/BUILD/openrv-3.0.0-build/OpenRV-main/redhat-linux-build/src/lib/ip/IPCore/SourceYVYU_glsl.cpp -- was automatically generated
// from the file /builddir/build/BUILD/openrv-3.0.0-build/OpenRV-main/src/lib/ip/IPCore/glsl/SourceYVYU.glsl by quoteFile.
//
const char* SourceYVYU_glsl = "//\n"
"// Copyright (C) 2023  Autodesk, Inc. All Rights Reserved. \n"
"// \n"
"// SPDX-License-Identifier: Apache-2.0 \n"
"//\n"
"//\n"
"//  Convert packed 8 bit YUYV to RGB\n"
"//\n"
"//  NOTE: this doesn't really work because the Y's are being\n"
"//  interpolated incorreectly. If you use 2 channels you get the\n"
"//  opposite problem of the color components interpolating between U\n"
"//  and V but the Y is interpolated correctly.\n"
"//\n"
"\n"
"vec4 SourceYVYU (const in sampler2DRect YVYU_sampler,\n"
"                 const in vec2 ST,\n"
"                 const in mat4 YUVmatrix,\n"
"                 const in vec2 offset,\n"
"                 const in vec2 YVYU_samplerSize,\n"
"                 const in float orientation)\n"
"{\n"
"    vec2 st = ST + offset;\n"
"    if (st.x < 0.0 || st.y < 0.0 || st.x >= YVYU_samplerSize.x || st.y >= YVYU_samplerSize.y)\n"
"        return vec4(0.0);\n"
"\n"
"    if (orientation == 1.0) // tl\n"
"    {\n"
"        st.y = YVYU_samplerSize.y - st.y;\n"
"    }\n"
"    else if (orientation == 2.0) // br\n"
"    {\n"
"        st.x = YVYU_samplerSize.x - st.x;\n"
"    }\n"
"    else if (orientation == 3.0) // tr\n"
"    {\n"
"        st.x = YVYU_samplerSize.x - st.x;\n"
"        st.y = YVYU_samplerSize.y - st.y;\n"
"    }\n"
"    \n"
"    vec4 c = texture(YVYU_sampler, st);\n"
"    vec4 yuv = vec4(c.y, c.x, c.z, 1.0);\n"
"    return YUVmatrix * yuv;\n"
"}\n"
"\n"
;
