//*****************************************************************************
// Copyright (c) 2024 Autodesk, Inc.
// All rights reserved.
//
// SPDX-License-Identifier: Apache-2.0
//
//*****************************************************************************

// IMPORTANT: This file (not the template) is auto-generated by qt2mu.py script.
//            The prefered way to do a fix is to handrolled it or modify the
//            qt2mu.py script. If it is not possible, manual editing is ok but
//            it could be lost in future generations.

#include <MuQt6/qtUtils.h>
#include <MuQt6/QAbstractSliderType.h>
#include <QtGui/QtGui>
#include <QtWidgets/QtWidgets>
#include <QtSvg/QtSvg>
#include <QSvgWidget>
#include <QtNetwork/QtNetwork>
#include <MuQt6/QWidgetType.h>
#include <MuQt6/QActionType.h>
#include <MuQt6/QIconType.h>
#include <Mu/BaseFunctions.h>
#include <Mu/Thread.h>
#include <Mu/Alias.h>
#include <Mu/SymbolicConstant.h>
#include <Mu/ClassInstance.h>
#include <Mu/Function.h>
#include <Mu/MemberFunction.h>
#include <Mu/MemberVariable.h>
#include <Mu/Node.h>
#include <Mu/Exception.h>
#include <Mu/ParameterVariable.h>
#include <Mu/ReferenceType.h>
#include <Mu/Value.h>
#include <MuLang/MuLangContext.h>
#include <MuLang/StringType.h>
#include <MuQt6/QSizeType.h>
#include <MuQt6/QDropEventType.h>
#include <MuQt6/QDragLeaveEventType.h>
#include <MuQt6/QEventType.h>
#include <MuQt6/QPaintEventType.h>
#include <MuQt6/QMouseEventType.h>
#include <MuQt6/QCloseEventType.h>
#include <MuQt6/QTabletEventType.h>
#include <MuQt6/QDragMoveEventType.h>
#include <MuQt6/QShowEventType.h>
#include <MuQt6/QContextMenuEventType.h>
#include <MuQt6/QKeyEventType.h>
#include <MuQt6/QFocusEventType.h>
#include <MuQt6/QMoveEventType.h>
#include <MuQt6/QResizeEventType.h>
#include <MuQt6/QVariantType.h>
#include <MuQt6/QTimerEventType.h>
#include <MuQt6/QWheelEventType.h>
#include <MuQt6/QDragEnterEventType.h>
#include <MuQt6/QHideEventType.h>

namespace Mu
{
    using namespace std;

    //----------------------------------------------------------------------
    //  INHERITABLE TYPE IMPLEMENTATION

    // destructor
    MuQt_QAbstractSlider::~MuQt_QAbstractSlider()
    {
        if (_obj)
        {
            *_obj->data<Pointer>() = Pointer(0);
            _obj->releaseExternal();
        }
        _obj = 0;
        _env = 0;
        _baseType = 0;
    }

    MuQt_QAbstractSlider::MuQt_QAbstractSlider(Pointer muobj,
                                               const CallEnvironment* ce,
                                               QWidget* parent)
        : QAbstractSlider(parent)
    {
        _env = ce;
        _obj = reinterpret_cast<ClassInstance*>(muobj);
        _obj->retainExternal();
        MuLangContext* c = (MuLangContext*)_env->context();
        _baseType = c->findSymbolOfTypeByQualifiedName<QAbstractSliderType>(
            c->internName("qt.QAbstractSlider"));
    }

    void
    MuQt_QAbstractSlider::sliderChange(QAbstractSlider::SliderChange change)
    {
        if (!_env)
        {
            QAbstractSlider::sliderChange(change);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[0];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(int(change));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSlider::sliderChange(change);
        }
    }

    void MuQt_QAbstractSlider::changeEvent(QEvent* ev)
    {
        if (!_env)
        {
            QAbstractSlider::changeEvent(ev);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[1];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, ev, "qt.QEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSlider::changeEvent(ev);
        }
    }

    bool MuQt_QAbstractSlider::event(QEvent* e)
    {
        if (!_env)
            return QAbstractSlider::event(e);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[2];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, e, "qt.QEvent"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QAbstractSlider::event(e);
        }
    }

    void MuQt_QAbstractSlider::keyPressEvent(QKeyEvent* ev)
    {
        if (!_env)
        {
            QAbstractSlider::keyPressEvent(ev);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[3];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QKeyEventType>(c, ev, "qt.QKeyEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSlider::keyPressEvent(ev);
        }
    }

    void MuQt_QAbstractSlider::timerEvent(QTimerEvent* e)
    {
        if (!_env)
        {
            QAbstractSlider::timerEvent(e);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[4];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QTimerEventType>(c, e, "qt.QTimerEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSlider::timerEvent(e);
        }
    }

    void MuQt_QAbstractSlider::wheelEvent(QWheelEvent* e)
    {
        if (!_env)
        {
            QAbstractSlider::wheelEvent(e);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[5];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QWheelEventType>(c, e, "qt.QWheelEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSlider::wheelEvent(e);
        }
    }

    bool MuQt_QAbstractSlider::hasHeightForWidth() const
    {
        if (!_env)
            return QAbstractSlider::hasHeightForWidth();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[6];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QAbstractSlider::hasHeightForWidth();
        }
    }

    int MuQt_QAbstractSlider::heightForWidth(int w) const
    {
        if (!_env)
            return QAbstractSlider::heightForWidth(w);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[7];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(w);
            Value rval = _env->call(F, args);
            return (int)(rval._int);
        }
        else
        {
            return QAbstractSlider::heightForWidth(w);
        }
    }

    QVariant
    MuQt_QAbstractSlider::inputMethodQuery(Qt::InputMethodQuery query) const
    {
        if (!_env)
            return QAbstractSlider::inputMethodQuery(query);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[8];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(int(query));
            Value rval = _env->call(F, args);
            return getqtype<QVariantType>(rval._Pointer);
        }
        else
        {
            return QAbstractSlider::inputMethodQuery(query);
        }
    }

    QSize MuQt_QAbstractSlider::minimumSizeHint() const
    {
        if (!_env)
            return QAbstractSlider::minimumSizeHint();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[9];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return getqtype<QSizeType>(rval._Pointer);
        }
        else
        {
            return QAbstractSlider::minimumSizeHint();
        }
    }

    QSize MuQt_QAbstractSlider::sizeHint() const
    {
        if (!_env)
            return QAbstractSlider::sizeHint();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[10];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return getqtype<QSizeType>(rval._Pointer);
        }
        else
        {
            return QAbstractSlider::sizeHint();
        }
    }

    void MuQt_QAbstractSlider::closeEvent(QCloseEvent* event)
    {
        if (!_env)
        {
            QAbstractSlider::closeEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[11];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QCloseEventType>(c, event, "qt.QCloseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSlider::closeEvent(event);
        }
    }

    void MuQt_QAbstractSlider::contextMenuEvent(QContextMenuEvent* event)
    {
        if (!_env)
        {
            QAbstractSlider::contextMenuEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[12];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QContextMenuEventType>(
                c, event, "qt.QContextMenuEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSlider::contextMenuEvent(event);
        }
    }

    void MuQt_QAbstractSlider::dragEnterEvent(QDragEnterEvent* event)
    {
        if (!_env)
        {
            QAbstractSlider::dragEnterEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[13];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QDragEnterEventType>(
                c, event, "qt.QDragEnterEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSlider::dragEnterEvent(event);
        }
    }

    void MuQt_QAbstractSlider::dragLeaveEvent(QDragLeaveEvent* event)
    {
        if (!_env)
        {
            QAbstractSlider::dragLeaveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[14];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QDragLeaveEventType>(
                c, event, "qt.QDragLeaveEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSlider::dragLeaveEvent(event);
        }
    }

    void MuQt_QAbstractSlider::dragMoveEvent(QDragMoveEvent* event)
    {
        if (!_env)
        {
            QAbstractSlider::dragMoveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[15];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QDragMoveEventType>(
                c, event, "qt.QDragMoveEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSlider::dragMoveEvent(event);
        }
    }

    void MuQt_QAbstractSlider::dropEvent(QDropEvent* event)
    {
        if (!_env)
        {
            QAbstractSlider::dropEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[16];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QDropEventType>(c, event, "qt.QDropEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSlider::dropEvent(event);
        }
    }

    void MuQt_QAbstractSlider::focusInEvent(QFocusEvent* event)
    {
        if (!_env)
        {
            QAbstractSlider::focusInEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[17];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QFocusEventType>(c, event, "qt.QFocusEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSlider::focusInEvent(event);
        }
    }

    bool MuQt_QAbstractSlider::focusNextPrevChild(bool next)
    {
        if (!_env)
            return QAbstractSlider::focusNextPrevChild(next);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[18];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(next);
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QAbstractSlider::focusNextPrevChild(next);
        }
    }

    void MuQt_QAbstractSlider::focusOutEvent(QFocusEvent* event)
    {
        if (!_env)
        {
            QAbstractSlider::focusOutEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[19];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QFocusEventType>(c, event, "qt.QFocusEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSlider::focusOutEvent(event);
        }
    }

    void MuQt_QAbstractSlider::hideEvent(QHideEvent* event)
    {
        if (!_env)
        {
            QAbstractSlider::hideEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[20];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QHideEventType>(c, event, "qt.QHideEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSlider::hideEvent(event);
        }
    }

    void MuQt_QAbstractSlider::keyReleaseEvent(QKeyEvent* event)
    {
        if (!_env)
        {
            QAbstractSlider::keyReleaseEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[21];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QKeyEventType>(c, event, "qt.QKeyEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSlider::keyReleaseEvent(event);
        }
    }

    void MuQt_QAbstractSlider::leaveEvent(QEvent* event)
    {
        if (!_env)
        {
            QAbstractSlider::leaveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[22];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, event, "qt.QEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSlider::leaveEvent(event);
        }
    }

    void MuQt_QAbstractSlider::mouseDoubleClickEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QAbstractSlider::mouseDoubleClickEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[23];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSlider::mouseDoubleClickEvent(event);
        }
    }

    void MuQt_QAbstractSlider::mouseMoveEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QAbstractSlider::mouseMoveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[24];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSlider::mouseMoveEvent(event);
        }
    }

    void MuQt_QAbstractSlider::mousePressEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QAbstractSlider::mousePressEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[25];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSlider::mousePressEvent(event);
        }
    }

    void MuQt_QAbstractSlider::mouseReleaseEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QAbstractSlider::mouseReleaseEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[26];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSlider::mouseReleaseEvent(event);
        }
    }

    void MuQt_QAbstractSlider::moveEvent(QMoveEvent* event)
    {
        if (!_env)
        {
            QAbstractSlider::moveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[27];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QMoveEventType>(c, event, "qt.QMoveEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSlider::moveEvent(event);
        }
    }

    void MuQt_QAbstractSlider::paintEvent(QPaintEvent* event)
    {
        if (!_env)
        {
            QAbstractSlider::paintEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[28];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QPaintEventType>(c, event, "qt.QPaintEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSlider::paintEvent(event);
        }
    }

    void MuQt_QAbstractSlider::resizeEvent(QResizeEvent* event)
    {
        if (!_env)
        {
            QAbstractSlider::resizeEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[29];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QResizeEventType>(c, event, "qt.QResizeEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSlider::resizeEvent(event);
        }
    }

    void MuQt_QAbstractSlider::showEvent(QShowEvent* event)
    {
        if (!_env)
        {
            QAbstractSlider::showEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[30];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QShowEventType>(c, event, "qt.QShowEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSlider::showEvent(event);
        }
    }

    void MuQt_QAbstractSlider::tabletEvent(QTabletEvent* event)
    {
        if (!_env)
        {
            QAbstractSlider::tabletEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[31];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QTabletEventType>(c, event, "qt.QTabletEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSlider::tabletEvent(event);
        }
    }

    int MuQt_QAbstractSlider::metric(QPaintDevice::PaintDeviceMetric m) const
    {
        if (!_env)
            return QAbstractSlider::metric(m);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[32];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(int(m));
            Value rval = _env->call(F, args);
            return (int)(rval._int);
        }
        else
        {
            return QAbstractSlider::metric(m);
        }
    }

    //----------------------------------------------------------------------
    //  Mu Type CONSTRUCTORS

    QAbstractSliderType::QAbstractSliderType(Context* c, const char* name,
                                             Class* super, Class* super2)
        : Class(c, name, vectorOf2(super, super2))
    {
    }

    QAbstractSliderType::~QAbstractSliderType() {}

    //----------------------------------------------------------------------
    //  PRE-COMPILED FUNCTIONS

    static Pointer QAbstractSlider_QAbstractSlider_QObject(Thread& NODE_THREAD,
                                                           Pointer obj)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        ClassInstance* widget = reinterpret_cast<ClassInstance*>(obj);

        if (!widget)
        {
            return 0;
        }
        else if (QAbstractSlider* w = object<QAbstractSlider>(widget))
        {
            QAbstractSliderType* type =
                c->findSymbolOfTypeByQualifiedName<QAbstractSliderType>(
                    c->internName("qt.QAbstractSlider"), false);
            ClassInstance* o = ClassInstance::allocate(type);
            setobject(o, w);
            return o;
        }
        else
        {
            throw BadCastException();
        }
    }

    static NODE_IMPLEMENTATION(castFromObject, Pointer)
    {
        NODE_RETURN(QAbstractSlider_QAbstractSlider_QObject(
            NODE_THREAD, NODE_ARG(0, Pointer)));
    }

    Pointer
    qt_QAbstractSlider_QAbstractSlider_QAbstractSlider_QAbstractSlider_QWidget(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QWidget* arg1 = object<QWidget>(param_parent);
        setobject(param_this,
                  new MuQt_QAbstractSlider(
                      param_this, NODE_THREAD.process()->callEnv(), arg1));
        return param_this;
    }

    void qt_QAbstractSlider_triggerAction_void_QAbstractSlider_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_action)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        QAbstractSlider::SliderAction arg1 =
            (QAbstractSlider::SliderAction)(param_action);
        arg0->triggerAction(arg1);
    }

    int
    qt_QAbstractSlider_repeatAction_int_QAbstractSlider(Mu::Thread& NODE_THREAD,
                                                        Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        return int(((MuQt_QAbstractSlider*)arg0)->repeatAction_pub());
    }

    void qt_QAbstractSlider_setRepeatAction_void_QAbstractSlider_int_int_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_action,
        int param_thresholdTime, int param_repeatTime)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        QAbstractSlider::SliderAction arg1 =
            (QAbstractSlider::SliderAction)(param_action);
        int arg2 = (int)(param_thresholdTime);
        int arg3 = (int)(param_repeatTime);
        ((MuQt_QAbstractSlider*)arg0)->setRepeatAction_pub(arg1, arg2, arg3);
    }

    void qt_QAbstractSlider_sliderChange_void_QAbstractSlider_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_change)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        MuQtPublicEnum arg1 = (MuQtPublicEnum)(param_change);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSlider*)arg0)->sliderChange_pub_parent(arg1);
        else
            ((MuQt_QAbstractSlider*)arg0)->sliderChange_pub(arg1);
    }

    void qt_QAbstractSlider_changeEvent_void_QAbstractSlider_QEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_ev)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_ev);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSlider*)arg0)->changeEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSlider*)arg0)->changeEvent_pub(arg1);
    }

    bool qt_QAbstractSlider_event_bool_QAbstractSlider_QEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_e);
        return isMuQtObject(arg0)
                   ? ((MuQt_QAbstractSlider*)arg0)->event_pub_parent(arg1)
                   : ((MuQt_QAbstractSlider*)arg0)->event_pub(arg1);
    }

    void qt_QAbstractSlider_keyPressEvent_void_QAbstractSlider_QKeyEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_ev)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        QKeyEvent* arg1 = getqpointer<QKeyEventType>(param_ev);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSlider*)arg0)->keyPressEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSlider*)arg0)->keyPressEvent_pub(arg1);
    }

    void qt_QAbstractSlider_timerEvent_void_QAbstractSlider_QTimerEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        QTimerEvent* arg1 = getqpointer<QTimerEventType>(param_e);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSlider*)arg0)->timerEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSlider*)arg0)->timerEvent_pub(arg1);
    }

    void qt_QAbstractSlider_wheelEvent_void_QAbstractSlider_QWheelEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        QWheelEvent* arg1 = getqpointer<QWheelEventType>(param_e);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSlider*)arg0)->wheelEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSlider*)arg0)->wheelEvent_pub(arg1);
    }

    bool qt_QAbstractSlider_hasHeightForWidth_bool_QAbstractSlider(
        Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        return isMuQtObject(arg0) ? arg0->QAbstractSlider::hasHeightForWidth()
                                  : arg0->hasHeightForWidth();
    }

    int qt_QAbstractSlider_heightForWidth_int_QAbstractSlider_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_w)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        int arg1 = (int)(param_w);
        return isMuQtObject(arg0) ? arg0->QAbstractSlider::heightForWidth(arg1)
                                  : arg0->heightForWidth(arg1);
    }

    Pointer qt_QAbstractSlider_inputMethodQuery_QVariant_QAbstractSlider_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_query)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        Qt::InputMethodQuery arg1 = (Qt::InputMethodQuery)(param_query);
        return isMuQtObject(arg0)
                   ? makeqtype<QVariantType>(
                         c, arg0->QAbstractSlider::inputMethodQuery(arg1),
                         "qt.QVariant")
                   : makeqtype<QVariantType>(c, arg0->inputMethodQuery(arg1),
                                             "qt.QVariant");
    }

    Pointer qt_QAbstractSlider_minimumSizeHint_QSize_QAbstractSlider(
        Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        return isMuQtObject(arg0)
                   ? makeqtype<QSizeType>(
                         c, arg0->QAbstractSlider::minimumSizeHint(),
                         "qt.QSize")
                   : makeqtype<QSizeType>(c, arg0->minimumSizeHint(),
                                          "qt.QSize");
    }

    Pointer
    qt_QAbstractSlider_sizeHint_QSize_QAbstractSlider(Mu::Thread& NODE_THREAD,
                                                      Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        return isMuQtObject(arg0)
                   ? makeqtype<QSizeType>(c, arg0->QAbstractSlider::sizeHint(),
                                          "qt.QSize")
                   : makeqtype<QSizeType>(c, arg0->sizeHint(), "qt.QSize");
    }

    void qt_QAbstractSlider_closeEvent_void_QAbstractSlider_QCloseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        QCloseEvent* arg1 = getqpointer<QCloseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSlider*)arg0)->closeEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSlider*)arg0)->closeEvent_pub(arg1);
    }

    void
    qt_QAbstractSlider_contextMenuEvent_void_QAbstractSlider_QContextMenuEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        QContextMenuEvent* arg1 =
            getqpointer<QContextMenuEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSlider*)arg0)->contextMenuEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSlider*)arg0)->contextMenuEvent_pub(arg1);
    }

    void qt_QAbstractSlider_dragEnterEvent_void_QAbstractSlider_QDragEnterEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        QDragEnterEvent* arg1 = getqpointer<QDragEnterEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSlider*)arg0)->dragEnterEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSlider*)arg0)->dragEnterEvent_pub(arg1);
    }

    void qt_QAbstractSlider_dragLeaveEvent_void_QAbstractSlider_QDragLeaveEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        QDragLeaveEvent* arg1 = getqpointer<QDragLeaveEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSlider*)arg0)->dragLeaveEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSlider*)arg0)->dragLeaveEvent_pub(arg1);
    }

    void qt_QAbstractSlider_dragMoveEvent_void_QAbstractSlider_QDragMoveEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        QDragMoveEvent* arg1 = getqpointer<QDragMoveEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSlider*)arg0)->dragMoveEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSlider*)arg0)->dragMoveEvent_pub(arg1);
    }

    void qt_QAbstractSlider_dropEvent_void_QAbstractSlider_QDropEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        QDropEvent* arg1 = getqpointer<QDropEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSlider*)arg0)->dropEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSlider*)arg0)->dropEvent_pub(arg1);
    }

    void qt_QAbstractSlider_focusInEvent_void_QAbstractSlider_QFocusEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        QFocusEvent* arg1 = getqpointer<QFocusEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSlider*)arg0)->focusInEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSlider*)arg0)->focusInEvent_pub(arg1);
    }

    bool qt_QAbstractSlider_focusNextPrevChild_bool_QAbstractSlider_bool(
        Mu::Thread& NODE_THREAD, Pointer param_this, bool param_next)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        bool arg1 = (bool)(param_next);
        return isMuQtObject(arg0) ? ((MuQt_QAbstractSlider*)arg0)
                                        ->focusNextPrevChild_pub_parent(arg1)
                                  : ((MuQt_QAbstractSlider*)arg0)
                                        ->focusNextPrevChild_pub(arg1);
    }

    void qt_QAbstractSlider_focusOutEvent_void_QAbstractSlider_QFocusEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        QFocusEvent* arg1 = getqpointer<QFocusEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSlider*)arg0)->focusOutEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSlider*)arg0)->focusOutEvent_pub(arg1);
    }

    void qt_QAbstractSlider_hideEvent_void_QAbstractSlider_QHideEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        QHideEvent* arg1 = getqpointer<QHideEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSlider*)arg0)->hideEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSlider*)arg0)->hideEvent_pub(arg1);
    }

    void qt_QAbstractSlider_keyReleaseEvent_void_QAbstractSlider_QKeyEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        QKeyEvent* arg1 = getqpointer<QKeyEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSlider*)arg0)->keyReleaseEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSlider*)arg0)->keyReleaseEvent_pub(arg1);
    }

    void qt_QAbstractSlider_leaveEvent_void_QAbstractSlider_QEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSlider*)arg0)->leaveEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSlider*)arg0)->leaveEvent_pub(arg1);
    }

    void
    qt_QAbstractSlider_mouseDoubleClickEvent_void_QAbstractSlider_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSlider*)arg0)
                ->mouseDoubleClickEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSlider*)arg0)->mouseDoubleClickEvent_pub(arg1);
    }

    void qt_QAbstractSlider_mouseMoveEvent_void_QAbstractSlider_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSlider*)arg0)->mouseMoveEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSlider*)arg0)->mouseMoveEvent_pub(arg1);
    }

    void qt_QAbstractSlider_mousePressEvent_void_QAbstractSlider_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSlider*)arg0)->mousePressEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSlider*)arg0)->mousePressEvent_pub(arg1);
    }

    void qt_QAbstractSlider_mouseReleaseEvent_void_QAbstractSlider_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSlider*)arg0)->mouseReleaseEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSlider*)arg0)->mouseReleaseEvent_pub(arg1);
    }

    void qt_QAbstractSlider_moveEvent_void_QAbstractSlider_QMoveEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        QMoveEvent* arg1 = getqpointer<QMoveEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSlider*)arg0)->moveEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSlider*)arg0)->moveEvent_pub(arg1);
    }

    void qt_QAbstractSlider_paintEvent_void_QAbstractSlider_QPaintEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        QPaintEvent* arg1 = getqpointer<QPaintEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSlider*)arg0)->paintEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSlider*)arg0)->paintEvent_pub(arg1);
    }

    void qt_QAbstractSlider_resizeEvent_void_QAbstractSlider_QResizeEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        QResizeEvent* arg1 = getqpointer<QResizeEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSlider*)arg0)->resizeEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSlider*)arg0)->resizeEvent_pub(arg1);
    }

    void qt_QAbstractSlider_showEvent_void_QAbstractSlider_QShowEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        QShowEvent* arg1 = getqpointer<QShowEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSlider*)arg0)->showEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSlider*)arg0)->showEvent_pub(arg1);
    }

    void qt_QAbstractSlider_tabletEvent_void_QAbstractSlider_QTabletEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        QTabletEvent* arg1 = getqpointer<QTabletEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSlider*)arg0)->tabletEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSlider*)arg0)->tabletEvent_pub(arg1);
    }

    int qt_QAbstractSlider_metric_int_QAbstractSlider_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_m)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSlider* arg0 = object<QAbstractSlider>(param_this);
        QPaintDevice::PaintDeviceMetric arg1 =
            (QPaintDevice::PaintDeviceMetric)(param_m);
        return isMuQtObject(arg0)
                   ? ((MuQt_QAbstractSlider*)arg0)->metric_pub_parent(arg1)
                   : ((MuQt_QAbstractSlider*)arg0)->metric_pub(arg1);
    }

    static NODE_IMPLEMENTATION(_n_QAbstractSlider0, Pointer)
    {
        NODE_RETURN(
            qt_QAbstractSlider_QAbstractSlider_QAbstractSlider_QAbstractSlider_QWidget(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer),
                NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_triggerAction0, void)
    {
        qt_QAbstractSlider_triggerAction_void_QAbstractSlider_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int));
    }

    static NODE_IMPLEMENTATION(_n_repeatAction0, int)
    {
        NODE_RETURN(qt_QAbstractSlider_repeatAction_int_QAbstractSlider(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_setRepeatAction0, void)
    {
        qt_QAbstractSlider_setRepeatAction_void_QAbstractSlider_int_int_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
            NODE_ARG(2, int), NODE_ARG(3, int));
    }

    static NODE_IMPLEMENTATION(_n_sliderChange0, void)
    {
        qt_QAbstractSlider_sliderChange_void_QAbstractSlider_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int));
    }

    static NODE_IMPLEMENTATION(_n_changeEvent0, void)
    {
        qt_QAbstractSlider_changeEvent_void_QAbstractSlider_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_event0, bool)
    {
        NODE_RETURN(qt_QAbstractSlider_event_bool_QAbstractSlider_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_keyPressEvent0, void)
    {
        qt_QAbstractSlider_keyPressEvent_void_QAbstractSlider_QKeyEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_timerEvent0, void)
    {
        qt_QAbstractSlider_timerEvent_void_QAbstractSlider_QTimerEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_wheelEvent0, void)
    {
        qt_QAbstractSlider_wheelEvent_void_QAbstractSlider_QWheelEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_hasHeightForWidth0, bool)
    {
        NODE_RETURN(qt_QAbstractSlider_hasHeightForWidth_bool_QAbstractSlider(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_heightForWidth0, int)
    {
        NODE_RETURN(qt_QAbstractSlider_heightForWidth_int_QAbstractSlider_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_inputMethodQuery0, Pointer)
    {
        NODE_RETURN(
            qt_QAbstractSlider_inputMethodQuery_QVariant_QAbstractSlider_int(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_minimumSizeHint0, Pointer)
    {
        NODE_RETURN(qt_QAbstractSlider_minimumSizeHint_QSize_QAbstractSlider(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_sizeHint0, Pointer)
    {
        NODE_RETURN(qt_QAbstractSlider_sizeHint_QSize_QAbstractSlider(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_closeEvent0, void)
    {
        qt_QAbstractSlider_closeEvent_void_QAbstractSlider_QCloseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_contextMenuEvent0, void)
    {
        qt_QAbstractSlider_contextMenuEvent_void_QAbstractSlider_QContextMenuEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dragEnterEvent0, void)
    {
        qt_QAbstractSlider_dragEnterEvent_void_QAbstractSlider_QDragEnterEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dragLeaveEvent0, void)
    {
        qt_QAbstractSlider_dragLeaveEvent_void_QAbstractSlider_QDragLeaveEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dragMoveEvent0, void)
    {
        qt_QAbstractSlider_dragMoveEvent_void_QAbstractSlider_QDragMoveEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dropEvent0, void)
    {
        qt_QAbstractSlider_dropEvent_void_QAbstractSlider_QDropEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_focusInEvent0, void)
    {
        qt_QAbstractSlider_focusInEvent_void_QAbstractSlider_QFocusEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_focusNextPrevChild0, bool)
    {
        NODE_RETURN(
            qt_QAbstractSlider_focusNextPrevChild_bool_QAbstractSlider_bool(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, bool)));
    }

    static NODE_IMPLEMENTATION(_n_focusOutEvent0, void)
    {
        qt_QAbstractSlider_focusOutEvent_void_QAbstractSlider_QFocusEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_hideEvent0, void)
    {
        qt_QAbstractSlider_hideEvent_void_QAbstractSlider_QHideEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_keyReleaseEvent0, void)
    {
        qt_QAbstractSlider_keyReleaseEvent_void_QAbstractSlider_QKeyEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_leaveEvent0, void)
    {
        qt_QAbstractSlider_leaveEvent_void_QAbstractSlider_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mouseDoubleClickEvent0, void)
    {
        qt_QAbstractSlider_mouseDoubleClickEvent_void_QAbstractSlider_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mouseMoveEvent0, void)
    {
        qt_QAbstractSlider_mouseMoveEvent_void_QAbstractSlider_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mousePressEvent0, void)
    {
        qt_QAbstractSlider_mousePressEvent_void_QAbstractSlider_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mouseReleaseEvent0, void)
    {
        qt_QAbstractSlider_mouseReleaseEvent_void_QAbstractSlider_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_moveEvent0, void)
    {
        qt_QAbstractSlider_moveEvent_void_QAbstractSlider_QMoveEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_paintEvent0, void)
    {
        qt_QAbstractSlider_paintEvent_void_QAbstractSlider_QPaintEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_resizeEvent0, void)
    {
        qt_QAbstractSlider_resizeEvent_void_QAbstractSlider_QResizeEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_showEvent0, void)
    {
        qt_QAbstractSlider_showEvent_void_QAbstractSlider_QShowEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_tabletEvent0, void)
    {
        qt_QAbstractSlider_tabletEvent_void_QAbstractSlider_QTabletEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_metric0, int)
    {
        NODE_RETURN(qt_QAbstractSlider_metric_int_QAbstractSlider_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    void QAbstractSliderType::load()
    {
        USING_MU_FUNCTION_SYMBOLS;
        MuLangContext* c = static_cast<MuLangContext*>(context());
        Module* global = globalModule();

        const string typeName = name();
        const string refTypeName = typeName + "&";
        const string fullTypeName = fullyQualifiedName();
        const string fullRefTypeName = fullTypeName + "&";
        const char* tn = typeName.c_str();
        const char* ftn = fullTypeName.c_str();
        const char* rtn = refTypeName.c_str();
        const char* frtn = fullRefTypeName.c_str();

        scope()->addSymbols(new ReferenceType(c, rtn, this),

                            new Function(c, tn, BaseFunctions::dereference,
                                         Cast, Return, ftn, Args, frtn, End),

                            EndArguments);

        addSymbols(new Function(c, "__allocate", BaseFunctions::classAllocate,
                                None, Return, ftn, End),

                   new Function(c, tn, castFromObject, Cast, Compiled,
                                QAbstractSlider_QAbstractSlider_QObject, Return,
                                ftn, Parameters,
                                new Param(c, "object", "qt.QObject"), End),

                   EndArguments);

        addSymbols(
            // enums
            new Alias(c, "SliderChange", "int") /* PROTECTED ENUM */,
            new SymbolicConstant(c, "SliderRangeChange", "int", Value(int(0))),
            new SymbolicConstant(c, "SliderOrientationChange", "int",
                                 Value(int(1))),
            new SymbolicConstant(c, "SliderStepsChange", "int", Value(int(2))),
            new SymbolicConstant(c, "SliderValueChange", "int", Value(int(3))),
            // member functions
            new Function(
                c, "QAbstractSlider", _n_QAbstractSlider0, None, Compiled,
                qt_QAbstractSlider_QAbstractSlider_QAbstractSlider_QAbstractSlider_QWidget,
                Return, "qt.QAbstractSlider", Parameters,
                new Param(c, "this", "qt.QAbstractSlider"),
                new Param(c, "parent", "qt.QWidget"), End),
            // PROP: hasTracking (bool; QAbstractSlider this)
            // PROP: invertedAppearance (bool; QAbstractSlider this)
            // PROP: invertedControls (bool; QAbstractSlider this)
            // PROP: isSliderDown (bool; QAbstractSlider this)
            // PROP: maximum (int; QAbstractSlider this)
            // PROP: minimum (int; QAbstractSlider this)
            // PROP: orientation (flags Qt::Orientation; QAbstractSlider this)
            // PROP: pageStep (int; QAbstractSlider this)
            // PROP: setInvertedAppearance (void; QAbstractSlider this, bool
            // _p4) PROP: setInvertedControls (void; QAbstractSlider this, bool
            // _p4) PROP: setMaximum (void; QAbstractSlider this, int _p3) PROP:
            // setMinimum (void; QAbstractSlider this, int _p3) PROP:
            // setPageStep (void; QAbstractSlider this, int _p3) PROP:
            // setSingleStep (void; QAbstractSlider this, int _p3) PROP:
            // setSliderDown (void; QAbstractSlider this, bool _p4) PROP:
            // setSliderPosition (void; QAbstractSlider this, int _p3) PROP:
            // setTracking (void; QAbstractSlider this, bool enable) PROP:
            // singleStep (int; QAbstractSlider this) PROP: sliderPosition (int;
            // QAbstractSlider this)
            new Function(
                c, "triggerAction", _n_triggerAction0, None, Compiled,
                qt_QAbstractSlider_triggerAction_void_QAbstractSlider_int,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSlider"),
                new Param(c, "action", "int"), End),
            // PROP: value (int; QAbstractSlider this)
            new Function(c, "repeatAction", _n_repeatAction0, None, Compiled,
                         qt_QAbstractSlider_repeatAction_int_QAbstractSlider,
                         Return, "int", Parameters,
                         new Param(c, "this", "qt.QAbstractSlider"), End),
            new Function(
                c, "setRepeatAction", _n_setRepeatAction0, None, Compiled,
                qt_QAbstractSlider_setRepeatAction_void_QAbstractSlider_int_int_int,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSlider"),
                new Param(c, "action", "int"),
                new Param(c, "thresholdTime", "int", Value((int)500)),
                new Param(c, "repeatTime", "int", Value((int)50)), End),
            _func[0] = new MemberFunction(
                c, "sliderChange", _n_sliderChange0, None, Compiled,
                qt_QAbstractSlider_sliderChange_void_QAbstractSlider_int,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSlider"),
                new Param(c, "change", "int"), End),
            _func[1] = new MemberFunction(
                c, "changeEvent", _n_changeEvent0, None, Compiled,
                qt_QAbstractSlider_changeEvent_void_QAbstractSlider_QEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSlider"),
                new Param(c, "ev", "qt.QEvent"), End),
            _func[2] = new MemberFunction(
                c, "event", _n_event0, None, Compiled,
                qt_QAbstractSlider_event_bool_QAbstractSlider_QEvent, Return,
                "bool", Parameters, new Param(c, "this", "qt.QAbstractSlider"),
                new Param(c, "e", "qt.QEvent"), End),
            _func[3] = new MemberFunction(
                c, "keyPressEvent", _n_keyPressEvent0, None, Compiled,
                qt_QAbstractSlider_keyPressEvent_void_QAbstractSlider_QKeyEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSlider"),
                new Param(c, "ev", "qt.QKeyEvent"), End),
            _func[4] = new MemberFunction(
                c, "timerEvent", _n_timerEvent0, None, Compiled,
                qt_QAbstractSlider_timerEvent_void_QAbstractSlider_QTimerEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSlider"),
                new Param(c, "e", "qt.QTimerEvent"), End),
            _func[5] = new MemberFunction(
                c, "wheelEvent", _n_wheelEvent0, None, Compiled,
                qt_QAbstractSlider_wheelEvent_void_QAbstractSlider_QWheelEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSlider"),
                new Param(c, "e", "qt.QWheelEvent"), End),
            _func[6] = new MemberFunction(
                c, "hasHeightForWidth", _n_hasHeightForWidth0, None, Compiled,
                qt_QAbstractSlider_hasHeightForWidth_bool_QAbstractSlider,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractSlider"), End),
            _func[7] = new MemberFunction(
                c, "heightForWidth", _n_heightForWidth0, None, Compiled,
                qt_QAbstractSlider_heightForWidth_int_QAbstractSlider_int,
                Return, "int", Parameters,
                new Param(c, "this", "qt.QAbstractSlider"),
                new Param(c, "w", "int"), End),
            _func[8] = new MemberFunction(
                c, "inputMethodQuery", _n_inputMethodQuery0, None, Compiled,
                qt_QAbstractSlider_inputMethodQuery_QVariant_QAbstractSlider_int,
                Return, "qt.QVariant", Parameters,
                new Param(c, "this", "qt.QAbstractSlider"),
                new Param(c, "query", "int"), End),
            _func[9] = new MemberFunction(
                c, "minimumSizeHint", _n_minimumSizeHint0, None, Compiled,
                qt_QAbstractSlider_minimumSizeHint_QSize_QAbstractSlider,
                Return, "qt.QSize", Parameters,
                new Param(c, "this", "qt.QAbstractSlider"), End),
            _func[10] = new MemberFunction(
                c, "sizeHint", _n_sizeHint0, None, Compiled,
                qt_QAbstractSlider_sizeHint_QSize_QAbstractSlider, Return,
                "qt.QSize", Parameters,
                new Param(c, "this", "qt.QAbstractSlider"), End),
            // MISSING: paintEngine ("QPaintEngine *"; QAbstractSlider this)
            // MISSING: actionEvent (void; QAbstractSlider this, "QActionEvent
            // *" event) // protected
            _func[11] = new MemberFunction(
                c, "closeEvent", _n_closeEvent0, None, Compiled,
                qt_QAbstractSlider_closeEvent_void_QAbstractSlider_QCloseEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSlider"),
                new Param(c, "event", "qt.QCloseEvent"), End),
            _func[12] = new MemberFunction(
                c, "contextMenuEvent", _n_contextMenuEvent0, None, Compiled,
                qt_QAbstractSlider_contextMenuEvent_void_QAbstractSlider_QContextMenuEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSlider"),
                new Param(c, "event", "qt.QContextMenuEvent"), End),
            _func[13] = new MemberFunction(
                c, "dragEnterEvent", _n_dragEnterEvent0, None, Compiled,
                qt_QAbstractSlider_dragEnterEvent_void_QAbstractSlider_QDragEnterEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSlider"),
                new Param(c, "event", "qt.QDragEnterEvent"), End),
            _func[14] = new MemberFunction(
                c, "dragLeaveEvent", _n_dragLeaveEvent0, None, Compiled,
                qt_QAbstractSlider_dragLeaveEvent_void_QAbstractSlider_QDragLeaveEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSlider"),
                new Param(c, "event", "qt.QDragLeaveEvent"), End),
            _func[15] = new MemberFunction(
                c, "dragMoveEvent", _n_dragMoveEvent0, None, Compiled,
                qt_QAbstractSlider_dragMoveEvent_void_QAbstractSlider_QDragMoveEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSlider"),
                new Param(c, "event", "qt.QDragMoveEvent"), End),
            _func[16] = new MemberFunction(
                c, "dropEvent", _n_dropEvent0, None, Compiled,
                qt_QAbstractSlider_dropEvent_void_QAbstractSlider_QDropEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSlider"),
                new Param(c, "event", "qt.QDropEvent"), End),
            // MISSING: enterEvent (void; QAbstractSlider this, "QEnterEvent *"
            // event) // protected
            _func[17] = new MemberFunction(
                c, "focusInEvent", _n_focusInEvent0, None, Compiled,
                qt_QAbstractSlider_focusInEvent_void_QAbstractSlider_QFocusEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSlider"),
                new Param(c, "event", "qt.QFocusEvent"), End),
            _func[18] = new MemberFunction(
                c, "focusNextPrevChild", _n_focusNextPrevChild0, None, Compiled,
                qt_QAbstractSlider_focusNextPrevChild_bool_QAbstractSlider_bool,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractSlider"),
                new Param(c, "next", "bool"), End),
            _func[19] = new MemberFunction(
                c, "focusOutEvent", _n_focusOutEvent0, None, Compiled,
                qt_QAbstractSlider_focusOutEvent_void_QAbstractSlider_QFocusEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSlider"),
                new Param(c, "event", "qt.QFocusEvent"), End),
            _func[20] = new MemberFunction(
                c, "hideEvent", _n_hideEvent0, None, Compiled,
                qt_QAbstractSlider_hideEvent_void_QAbstractSlider_QHideEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSlider"),
                new Param(c, "event", "qt.QHideEvent"), End),
            // MISSING: inputMethodEvent (void; QAbstractSlider this,
            // "QInputMethodEvent *" event) // protected
            _func[21] = new MemberFunction(
                c, "keyReleaseEvent", _n_keyReleaseEvent0, None, Compiled,
                qt_QAbstractSlider_keyReleaseEvent_void_QAbstractSlider_QKeyEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSlider"),
                new Param(c, "event", "qt.QKeyEvent"), End),
            _func[22] = new MemberFunction(
                c, "leaveEvent", _n_leaveEvent0, None, Compiled,
                qt_QAbstractSlider_leaveEvent_void_QAbstractSlider_QEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSlider"),
                new Param(c, "event", "qt.QEvent"), End),
            _func[23] = new MemberFunction(
                c, "mouseDoubleClickEvent", _n_mouseDoubleClickEvent0, None,
                Compiled,
                qt_QAbstractSlider_mouseDoubleClickEvent_void_QAbstractSlider_QMouseEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSlider"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[24] = new MemberFunction(
                c, "mouseMoveEvent", _n_mouseMoveEvent0, None, Compiled,
                qt_QAbstractSlider_mouseMoveEvent_void_QAbstractSlider_QMouseEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSlider"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[25] = new MemberFunction(
                c, "mousePressEvent", _n_mousePressEvent0, None, Compiled,
                qt_QAbstractSlider_mousePressEvent_void_QAbstractSlider_QMouseEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSlider"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[26] = new MemberFunction(
                c, "mouseReleaseEvent", _n_mouseReleaseEvent0, None, Compiled,
                qt_QAbstractSlider_mouseReleaseEvent_void_QAbstractSlider_QMouseEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSlider"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[27] = new MemberFunction(
                c, "moveEvent", _n_moveEvent0, None, Compiled,
                qt_QAbstractSlider_moveEvent_void_QAbstractSlider_QMoveEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSlider"),
                new Param(c, "event", "qt.QMoveEvent"), End),
            // MISSING: nativeEvent (bool; QAbstractSlider this, QByteArray
            // eventType, "void *" message, "qintptr *" result) // protected
            _func[28] = new MemberFunction(
                c, "paintEvent", _n_paintEvent0, None, Compiled,
                qt_QAbstractSlider_paintEvent_void_QAbstractSlider_QPaintEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSlider"),
                new Param(c, "event", "qt.QPaintEvent"), End),
            _func[29] = new MemberFunction(
                c, "resizeEvent", _n_resizeEvent0, None, Compiled,
                qt_QAbstractSlider_resizeEvent_void_QAbstractSlider_QResizeEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSlider"),
                new Param(c, "event", "qt.QResizeEvent"), End),
            _func[30] = new MemberFunction(
                c, "showEvent", _n_showEvent0, None, Compiled,
                qt_QAbstractSlider_showEvent_void_QAbstractSlider_QShowEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSlider"),
                new Param(c, "event", "qt.QShowEvent"), End),
            _func[31] = new MemberFunction(
                c, "tabletEvent", _n_tabletEvent0, None, Compiled,
                qt_QAbstractSlider_tabletEvent_void_QAbstractSlider_QTabletEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSlider"),
                new Param(c, "event", "qt.QTabletEvent"), End),
            // MISSING: initPainter (void; QAbstractSlider this, "QPainter *"
            // painter) // protected
            _func[32] = new MemberFunction(
                c, "metric", _n_metric0, None, Compiled,
                qt_QAbstractSlider_metric_int_QAbstractSlider_int, Return,
                "int", Parameters, new Param(c, "this", "qt.QAbstractSlider"),
                new Param(c, "m", "int"), End),
            // static functions
            EndArguments);
        globalScope()->addSymbols(EndArguments);
        scope()->addSymbols(EndArguments);

        const char** propExclusions = 0;

        populate(this, QAbstractSlider::staticMetaObject, propExclusions);
    }

} // namespace Mu
