//*****************************************************************************
// Copyright (c) 2024 Autodesk, Inc.
// All rights reserved.
//
// SPDX-License-Identifier: Apache-2.0
//
//*****************************************************************************

// IMPORTANT: This file (not the template) is auto-generated by qt2mu.py script.
//            The prefered way to do a fix is to handrolled it or modify the
//            qt2mu.py script. If it is not possible, manual editing is ok but
//            it could be lost in future generations.

#include <MuQt6/qtUtils.h>
#include <MuQt6/QAbstractSpinBoxType.h>
#include <QtGui/QtGui>
#include <QtWidgets/QtWidgets>
#include <QtSvg/QtSvg>
#include <QSvgWidget>
#include <QtNetwork/QtNetwork>
#include <MuQt6/QWidgetType.h>
#include <MuQt6/QActionType.h>
#include <MuQt6/QIconType.h>
#include <Mu/BaseFunctions.h>
#include <Mu/Thread.h>
#include <Mu/Alias.h>
#include <Mu/SymbolicConstant.h>
#include <Mu/ClassInstance.h>
#include <Mu/Function.h>
#include <Mu/MemberFunction.h>
#include <Mu/MemberVariable.h>
#include <Mu/Node.h>
#include <Mu/Exception.h>
#include <Mu/ParameterVariable.h>
#include <Mu/ReferenceType.h>
#include <Mu/Value.h>
#include <MuLang/MuLangContext.h>
#include <MuLang/StringType.h>
#include <MuQt6/QSizeType.h>
#include <MuQt6/QLineEditType.h>
#include <MuQt6/QDropEventType.h>
#include <MuQt6/QDragLeaveEventType.h>
#include <MuQt6/QEventType.h>
#include <MuQt6/QMouseEventType.h>
#include <MuQt6/QCloseEventType.h>
#include <MuQt6/QDragMoveEventType.h>
#include <MuQt6/QFocusEventType.h>
#include <MuQt6/QShowEventType.h>
#include <MuQt6/QContextMenuEventType.h>
#include <MuQt6/QKeyEventType.h>
#include <MuQt6/QHideEventType.h>
#include <MuQt6/QMoveEventType.h>
#include <MuQt6/QResizeEventType.h>
#include <MuQt6/QTabletEventType.h>
#include <MuQt6/QWheelEventType.h>
#include <MuQt6/QVariantType.h>
#include <MuQt6/QTimerEventType.h>
#include <MuQt6/QPaintEventType.h>
#include <MuQt6/QDragEnterEventType.h>

namespace Mu
{
    using namespace std;

    //----------------------------------------------------------------------
    //  INHERITABLE TYPE IMPLEMENTATION

    // destructor
    MuQt_QAbstractSpinBox::~MuQt_QAbstractSpinBox()
    {
        if (_obj)
        {
            *_obj->data<Pointer>() = Pointer(0);
            _obj->releaseExternal();
        }
        _obj = 0;
        _env = 0;
        _baseType = 0;
    }

    MuQt_QAbstractSpinBox::MuQt_QAbstractSpinBox(Pointer muobj,
                                                 const CallEnvironment* ce,
                                                 QWidget* parent)
        : QAbstractSpinBox(parent)
    {
        _env = ce;
        _obj = reinterpret_cast<ClassInstance*>(muobj);
        _obj->retainExternal();
        MuLangContext* c = (MuLangContext*)_env->context();
        _baseType = c->findSymbolOfTypeByQualifiedName<QAbstractSpinBoxType>(
            c->internName("qt.QAbstractSpinBox"));
    }

    void MuQt_QAbstractSpinBox::stepBy(int steps)
    {
        if (!_env)
        {
            QAbstractSpinBox::stepBy(steps);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[0];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(steps);
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSpinBox::stepBy(steps);
        }
    }

    bool MuQt_QAbstractSpinBox::event(QEvent* event_)
    {
        if (!_env)
            return QAbstractSpinBox::event(event_);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[1];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, event_, "qt.QEvent"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QAbstractSpinBox::event(event_);
        }
    }

    QVariant
    MuQt_QAbstractSpinBox::inputMethodQuery(Qt::InputMethodQuery query) const
    {
        if (!_env)
            return QAbstractSpinBox::inputMethodQuery(query);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[2];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(int(query));
            Value rval = _env->call(F, args);
            return getqtype<QVariantType>(rval._Pointer);
        }
        else
        {
            return QAbstractSpinBox::inputMethodQuery(query);
        }
    }

    QSize MuQt_QAbstractSpinBox::minimumSizeHint() const
    {
        if (!_env)
            return QAbstractSpinBox::minimumSizeHint();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[3];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return getqtype<QSizeType>(rval._Pointer);
        }
        else
        {
            return QAbstractSpinBox::minimumSizeHint();
        }
    }

    QSize MuQt_QAbstractSpinBox::sizeHint() const
    {
        if (!_env)
            return QAbstractSpinBox::sizeHint();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[4];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return getqtype<QSizeType>(rval._Pointer);
        }
        else
        {
            return QAbstractSpinBox::sizeHint();
        }
    }

    void MuQt_QAbstractSpinBox::changeEvent(QEvent* event)
    {
        if (!_env)
        {
            QAbstractSpinBox::changeEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[5];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, event, "qt.QEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSpinBox::changeEvent(event);
        }
    }

    void MuQt_QAbstractSpinBox::closeEvent(QCloseEvent* event)
    {
        if (!_env)
        {
            QAbstractSpinBox::closeEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[6];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QCloseEventType>(c, event, "qt.QCloseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSpinBox::closeEvent(event);
        }
    }

    void MuQt_QAbstractSpinBox::contextMenuEvent(QContextMenuEvent* event)
    {
        if (!_env)
        {
            QAbstractSpinBox::contextMenuEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[7];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QContextMenuEventType>(
                c, event, "qt.QContextMenuEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSpinBox::contextMenuEvent(event);
        }
    }

    void MuQt_QAbstractSpinBox::focusInEvent(QFocusEvent* event)
    {
        if (!_env)
        {
            QAbstractSpinBox::focusInEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[8];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QFocusEventType>(c, event, "qt.QFocusEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSpinBox::focusInEvent(event);
        }
    }

    void MuQt_QAbstractSpinBox::focusOutEvent(QFocusEvent* event)
    {
        if (!_env)
        {
            QAbstractSpinBox::focusOutEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[9];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QFocusEventType>(c, event, "qt.QFocusEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSpinBox::focusOutEvent(event);
        }
    }

    void MuQt_QAbstractSpinBox::hideEvent(QHideEvent* event)
    {
        if (!_env)
        {
            QAbstractSpinBox::hideEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[10];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QHideEventType>(c, event, "qt.QHideEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSpinBox::hideEvent(event);
        }
    }

    void MuQt_QAbstractSpinBox::keyPressEvent(QKeyEvent* event)
    {
        if (!_env)
        {
            QAbstractSpinBox::keyPressEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[11];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QKeyEventType>(c, event, "qt.QKeyEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSpinBox::keyPressEvent(event);
        }
    }

    void MuQt_QAbstractSpinBox::keyReleaseEvent(QKeyEvent* event)
    {
        if (!_env)
        {
            QAbstractSpinBox::keyReleaseEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[12];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QKeyEventType>(c, event, "qt.QKeyEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSpinBox::keyReleaseEvent(event);
        }
    }

    void MuQt_QAbstractSpinBox::mouseMoveEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QAbstractSpinBox::mouseMoveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[13];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSpinBox::mouseMoveEvent(event);
        }
    }

    void MuQt_QAbstractSpinBox::mousePressEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QAbstractSpinBox::mousePressEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[14];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSpinBox::mousePressEvent(event);
        }
    }

    void MuQt_QAbstractSpinBox::mouseReleaseEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QAbstractSpinBox::mouseReleaseEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[15];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSpinBox::mouseReleaseEvent(event);
        }
    }

    void MuQt_QAbstractSpinBox::paintEvent(QPaintEvent* event)
    {
        if (!_env)
        {
            QAbstractSpinBox::paintEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[16];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QPaintEventType>(c, event, "qt.QPaintEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSpinBox::paintEvent(event);
        }
    }

    void MuQt_QAbstractSpinBox::resizeEvent(QResizeEvent* event)
    {
        if (!_env)
        {
            QAbstractSpinBox::resizeEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[17];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QResizeEventType>(c, event, "qt.QResizeEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSpinBox::resizeEvent(event);
        }
    }

    void MuQt_QAbstractSpinBox::showEvent(QShowEvent* event)
    {
        if (!_env)
        {
            QAbstractSpinBox::showEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[18];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QShowEventType>(c, event, "qt.QShowEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSpinBox::showEvent(event);
        }
    }

    void MuQt_QAbstractSpinBox::timerEvent(QTimerEvent* event)
    {
        if (!_env)
        {
            QAbstractSpinBox::timerEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[19];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QTimerEventType>(c, event, "qt.QTimerEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSpinBox::timerEvent(event);
        }
    }

    void MuQt_QAbstractSpinBox::wheelEvent(QWheelEvent* event)
    {
        if (!_env)
        {
            QAbstractSpinBox::wheelEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[20];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QWheelEventType>(c, event, "qt.QWheelEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSpinBox::wheelEvent(event);
        }
    }

    bool MuQt_QAbstractSpinBox::hasHeightForWidth() const
    {
        if (!_env)
            return QAbstractSpinBox::hasHeightForWidth();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[21];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QAbstractSpinBox::hasHeightForWidth();
        }
    }

    int MuQt_QAbstractSpinBox::heightForWidth(int w) const
    {
        if (!_env)
            return QAbstractSpinBox::heightForWidth(w);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[22];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(w);
            Value rval = _env->call(F, args);
            return (int)(rval._int);
        }
        else
        {
            return QAbstractSpinBox::heightForWidth(w);
        }
    }

    void MuQt_QAbstractSpinBox::dragEnterEvent(QDragEnterEvent* event)
    {
        if (!_env)
        {
            QAbstractSpinBox::dragEnterEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[23];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QDragEnterEventType>(
                c, event, "qt.QDragEnterEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSpinBox::dragEnterEvent(event);
        }
    }

    void MuQt_QAbstractSpinBox::dragLeaveEvent(QDragLeaveEvent* event)
    {
        if (!_env)
        {
            QAbstractSpinBox::dragLeaveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[24];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QDragLeaveEventType>(
                c, event, "qt.QDragLeaveEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSpinBox::dragLeaveEvent(event);
        }
    }

    void MuQt_QAbstractSpinBox::dragMoveEvent(QDragMoveEvent* event)
    {
        if (!_env)
        {
            QAbstractSpinBox::dragMoveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[25];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QDragMoveEventType>(
                c, event, "qt.QDragMoveEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSpinBox::dragMoveEvent(event);
        }
    }

    void MuQt_QAbstractSpinBox::dropEvent(QDropEvent* event)
    {
        if (!_env)
        {
            QAbstractSpinBox::dropEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[26];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QDropEventType>(c, event, "qt.QDropEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSpinBox::dropEvent(event);
        }
    }

    bool MuQt_QAbstractSpinBox::focusNextPrevChild(bool next)
    {
        if (!_env)
            return QAbstractSpinBox::focusNextPrevChild(next);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[27];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(next);
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QAbstractSpinBox::focusNextPrevChild(next);
        }
    }

    void MuQt_QAbstractSpinBox::leaveEvent(QEvent* event)
    {
        if (!_env)
        {
            QAbstractSpinBox::leaveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[28];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, event, "qt.QEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSpinBox::leaveEvent(event);
        }
    }

    void MuQt_QAbstractSpinBox::mouseDoubleClickEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QAbstractSpinBox::mouseDoubleClickEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[29];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSpinBox::mouseDoubleClickEvent(event);
        }
    }

    void MuQt_QAbstractSpinBox::moveEvent(QMoveEvent* event)
    {
        if (!_env)
        {
            QAbstractSpinBox::moveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[30];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QMoveEventType>(c, event, "qt.QMoveEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSpinBox::moveEvent(event);
        }
    }

    void MuQt_QAbstractSpinBox::tabletEvent(QTabletEvent* event)
    {
        if (!_env)
        {
            QAbstractSpinBox::tabletEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[31];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QTabletEventType>(c, event, "qt.QTabletEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QAbstractSpinBox::tabletEvent(event);
        }
    }

    int MuQt_QAbstractSpinBox::metric(QPaintDevice::PaintDeviceMetric m) const
    {
        if (!_env)
            return QAbstractSpinBox::metric(m);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[32];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(int(m));
            Value rval = _env->call(F, args);
            return (int)(rval._int);
        }
        else
        {
            return QAbstractSpinBox::metric(m);
        }
    }

    //----------------------------------------------------------------------
    //  Mu Type CONSTRUCTORS

    QAbstractSpinBoxType::QAbstractSpinBoxType(Context* c, const char* name,
                                               Class* super, Class* super2)
        : Class(c, name, vectorOf2(super, super2))
    {
    }

    QAbstractSpinBoxType::~QAbstractSpinBoxType() {}

    //----------------------------------------------------------------------
    //  PRE-COMPILED FUNCTIONS

    static Pointer
    QAbstractSpinBox_QAbstractSpinBox_QObject(Thread& NODE_THREAD, Pointer obj)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        ClassInstance* widget = reinterpret_cast<ClassInstance*>(obj);

        if (!widget)
        {
            return 0;
        }
        else if (QAbstractSpinBox* w = object<QAbstractSpinBox>(widget))
        {
            QAbstractSpinBoxType* type =
                c->findSymbolOfTypeByQualifiedName<QAbstractSpinBoxType>(
                    c->internName("qt.QAbstractSpinBox"), false);
            ClassInstance* o = ClassInstance::allocate(type);
            setobject(o, w);
            return o;
        }
        else
        {
            throw BadCastException();
        }
    }

    static NODE_IMPLEMENTATION(castFromObject, Pointer)
    {
        NODE_RETURN(QAbstractSpinBox_QAbstractSpinBox_QObject(
            NODE_THREAD, NODE_ARG(0, Pointer)));
    }

    Pointer
    qt_QAbstractSpinBox_QAbstractSpinBox_QAbstractSpinBox_QAbstractSpinBox_QWidget(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QWidget* arg1 = object<QWidget>(param_parent);
        setobject(param_this,
                  new MuQt_QAbstractSpinBox(
                      param_this, NODE_THREAD.process()->callEnv(), arg1));
        return param_this;
    }

    void qt_QAbstractSpinBox_interpretText_void_QAbstractSpinBox(
        Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        arg0->interpretText();
    }

    void qt_QAbstractSpinBox_stepBy_void_QAbstractSpinBox_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_steps)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        int arg1 = (int)(param_steps);
        if (isMuQtObject(arg0))
            arg0->QAbstractSpinBox::stepBy(arg1);
        else
            arg0->stepBy(arg1);
    }

    bool qt_QAbstractSpinBox_event_bool_QAbstractSpinBox_QEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event_)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_event_);
        return isMuQtObject(arg0) ? arg0->QAbstractSpinBox::event(arg1)
                                  : arg0->event(arg1);
    }

    Pointer qt_QAbstractSpinBox_inputMethodQuery_QVariant_QAbstractSpinBox_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_query)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        Qt::InputMethodQuery arg1 = (Qt::InputMethodQuery)(param_query);
        return isMuQtObject(arg0)
                   ? makeqtype<QVariantType>(
                         c, arg0->QAbstractSpinBox::inputMethodQuery(arg1),
                         "qt.QVariant")
                   : makeqtype<QVariantType>(c, arg0->inputMethodQuery(arg1),
                                             "qt.QVariant");
    }

    Pointer qt_QAbstractSpinBox_minimumSizeHint_QSize_QAbstractSpinBox(
        Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        return isMuQtObject(arg0)
                   ? makeqtype<QSizeType>(
                         c, arg0->QAbstractSpinBox::minimumSizeHint(),
                         "qt.QSize")
                   : makeqtype<QSizeType>(c, arg0->minimumSizeHint(),
                                          "qt.QSize");
    }

    Pointer
    qt_QAbstractSpinBox_sizeHint_QSize_QAbstractSpinBox(Mu::Thread& NODE_THREAD,
                                                        Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        return isMuQtObject(arg0)
                   ? makeqtype<QSizeType>(c, arg0->QAbstractSpinBox::sizeHint(),
                                          "qt.QSize")
                   : makeqtype<QSizeType>(c, arg0->sizeHint(), "qt.QSize");
    }

    Pointer qt_QAbstractSpinBox_lineEdit_QLineEdit_QAbstractSpinBox(
        Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        return makeinstance<QLineEditType>(
            c, ((MuQt_QAbstractSpinBox*)arg0)->lineEdit_pub(), "qt.QLineEdit");
    }

    void qt_QAbstractSpinBox_setLineEdit_void_QAbstractSpinBox_QLineEdit(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_lineEdit)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        QLineEdit* arg1 = object<QLineEdit>(param_lineEdit);
        ((MuQt_QAbstractSpinBox*)arg0)->setLineEdit_pub(arg1);
    }

    void qt_QAbstractSpinBox_changeEvent_void_QAbstractSpinBox_QEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSpinBox*)arg0)->changeEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSpinBox*)arg0)->changeEvent_pub(arg1);
    }

    void qt_QAbstractSpinBox_closeEvent_void_QAbstractSpinBox_QCloseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        QCloseEvent* arg1 = getqpointer<QCloseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSpinBox*)arg0)->closeEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSpinBox*)arg0)->closeEvent_pub(arg1);
    }

    void
    qt_QAbstractSpinBox_contextMenuEvent_void_QAbstractSpinBox_QContextMenuEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        QContextMenuEvent* arg1 =
            getqpointer<QContextMenuEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSpinBox*)arg0)->contextMenuEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSpinBox*)arg0)->contextMenuEvent_pub(arg1);
    }

    void qt_QAbstractSpinBox_focusInEvent_void_QAbstractSpinBox_QFocusEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        QFocusEvent* arg1 = getqpointer<QFocusEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSpinBox*)arg0)->focusInEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSpinBox*)arg0)->focusInEvent_pub(arg1);
    }

    void qt_QAbstractSpinBox_focusOutEvent_void_QAbstractSpinBox_QFocusEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        QFocusEvent* arg1 = getqpointer<QFocusEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSpinBox*)arg0)->focusOutEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSpinBox*)arg0)->focusOutEvent_pub(arg1);
    }

    void qt_QAbstractSpinBox_hideEvent_void_QAbstractSpinBox_QHideEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        QHideEvent* arg1 = getqpointer<QHideEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSpinBox*)arg0)->hideEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSpinBox*)arg0)->hideEvent_pub(arg1);
    }

    void qt_QAbstractSpinBox_keyPressEvent_void_QAbstractSpinBox_QKeyEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        QKeyEvent* arg1 = getqpointer<QKeyEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSpinBox*)arg0)->keyPressEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSpinBox*)arg0)->keyPressEvent_pub(arg1);
    }

    void qt_QAbstractSpinBox_keyReleaseEvent_void_QAbstractSpinBox_QKeyEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        QKeyEvent* arg1 = getqpointer<QKeyEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSpinBox*)arg0)->keyReleaseEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSpinBox*)arg0)->keyReleaseEvent_pub(arg1);
    }

    void qt_QAbstractSpinBox_mouseMoveEvent_void_QAbstractSpinBox_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSpinBox*)arg0)->mouseMoveEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSpinBox*)arg0)->mouseMoveEvent_pub(arg1);
    }

    void qt_QAbstractSpinBox_mousePressEvent_void_QAbstractSpinBox_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSpinBox*)arg0)->mousePressEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSpinBox*)arg0)->mousePressEvent_pub(arg1);
    }

    void
    qt_QAbstractSpinBox_mouseReleaseEvent_void_QAbstractSpinBox_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSpinBox*)arg0)->mouseReleaseEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSpinBox*)arg0)->mouseReleaseEvent_pub(arg1);
    }

    void qt_QAbstractSpinBox_paintEvent_void_QAbstractSpinBox_QPaintEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        QPaintEvent* arg1 = getqpointer<QPaintEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSpinBox*)arg0)->paintEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSpinBox*)arg0)->paintEvent_pub(arg1);
    }

    void qt_QAbstractSpinBox_resizeEvent_void_QAbstractSpinBox_QResizeEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        QResizeEvent* arg1 = getqpointer<QResizeEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSpinBox*)arg0)->resizeEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSpinBox*)arg0)->resizeEvent_pub(arg1);
    }

    void qt_QAbstractSpinBox_showEvent_void_QAbstractSpinBox_QShowEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        QShowEvent* arg1 = getqpointer<QShowEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSpinBox*)arg0)->showEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSpinBox*)arg0)->showEvent_pub(arg1);
    }

    void qt_QAbstractSpinBox_timerEvent_void_QAbstractSpinBox_QTimerEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        QTimerEvent* arg1 = getqpointer<QTimerEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSpinBox*)arg0)->timerEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSpinBox*)arg0)->timerEvent_pub(arg1);
    }

    void qt_QAbstractSpinBox_wheelEvent_void_QAbstractSpinBox_QWheelEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        QWheelEvent* arg1 = getqpointer<QWheelEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSpinBox*)arg0)->wheelEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSpinBox*)arg0)->wheelEvent_pub(arg1);
    }

    bool qt_QAbstractSpinBox_hasHeightForWidth_bool_QAbstractSpinBox(
        Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        return isMuQtObject(arg0) ? arg0->QAbstractSpinBox::hasHeightForWidth()
                                  : arg0->hasHeightForWidth();
    }

    int qt_QAbstractSpinBox_heightForWidth_int_QAbstractSpinBox_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_w)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        int arg1 = (int)(param_w);
        return isMuQtObject(arg0) ? arg0->QAbstractSpinBox::heightForWidth(arg1)
                                  : arg0->heightForWidth(arg1);
    }

    void
    qt_QAbstractSpinBox_dragEnterEvent_void_QAbstractSpinBox_QDragEnterEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        QDragEnterEvent* arg1 = getqpointer<QDragEnterEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSpinBox*)arg0)->dragEnterEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSpinBox*)arg0)->dragEnterEvent_pub(arg1);
    }

    void
    qt_QAbstractSpinBox_dragLeaveEvent_void_QAbstractSpinBox_QDragLeaveEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        QDragLeaveEvent* arg1 = getqpointer<QDragLeaveEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSpinBox*)arg0)->dragLeaveEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSpinBox*)arg0)->dragLeaveEvent_pub(arg1);
    }

    void qt_QAbstractSpinBox_dragMoveEvent_void_QAbstractSpinBox_QDragMoveEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        QDragMoveEvent* arg1 = getqpointer<QDragMoveEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSpinBox*)arg0)->dragMoveEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSpinBox*)arg0)->dragMoveEvent_pub(arg1);
    }

    void qt_QAbstractSpinBox_dropEvent_void_QAbstractSpinBox_QDropEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        QDropEvent* arg1 = getqpointer<QDropEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSpinBox*)arg0)->dropEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSpinBox*)arg0)->dropEvent_pub(arg1);
    }

    bool qt_QAbstractSpinBox_focusNextPrevChild_bool_QAbstractSpinBox_bool(
        Mu::Thread& NODE_THREAD, Pointer param_this, bool param_next)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        bool arg1 = (bool)(param_next);
        return isMuQtObject(arg0) ? ((MuQt_QAbstractSpinBox*)arg0)
                                        ->focusNextPrevChild_pub_parent(arg1)
                                  : ((MuQt_QAbstractSpinBox*)arg0)
                                        ->focusNextPrevChild_pub(arg1);
    }

    void qt_QAbstractSpinBox_leaveEvent_void_QAbstractSpinBox_QEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSpinBox*)arg0)->leaveEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSpinBox*)arg0)->leaveEvent_pub(arg1);
    }

    void
    qt_QAbstractSpinBox_mouseDoubleClickEvent_void_QAbstractSpinBox_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSpinBox*)arg0)
                ->mouseDoubleClickEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSpinBox*)arg0)->mouseDoubleClickEvent_pub(arg1);
    }

    void qt_QAbstractSpinBox_moveEvent_void_QAbstractSpinBox_QMoveEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        QMoveEvent* arg1 = getqpointer<QMoveEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSpinBox*)arg0)->moveEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSpinBox*)arg0)->moveEvent_pub(arg1);
    }

    void qt_QAbstractSpinBox_tabletEvent_void_QAbstractSpinBox_QTabletEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        QTabletEvent* arg1 = getqpointer<QTabletEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QAbstractSpinBox*)arg0)->tabletEvent_pub_parent(arg1);
        else
            ((MuQt_QAbstractSpinBox*)arg0)->tabletEvent_pub(arg1);
    }

    int qt_QAbstractSpinBox_metric_int_QAbstractSpinBox_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_m)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QAbstractSpinBox* arg0 = object<QAbstractSpinBox>(param_this);
        QPaintDevice::PaintDeviceMetric arg1 =
            (QPaintDevice::PaintDeviceMetric)(param_m);
        return isMuQtObject(arg0)
                   ? ((MuQt_QAbstractSpinBox*)arg0)->metric_pub_parent(arg1)
                   : ((MuQt_QAbstractSpinBox*)arg0)->metric_pub(arg1);
    }

    static NODE_IMPLEMENTATION(_n_QAbstractSpinBox0, Pointer)
    {
        NODE_RETURN(
            qt_QAbstractSpinBox_QAbstractSpinBox_QAbstractSpinBox_QAbstractSpinBox_QWidget(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer),
                NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_interpretText0, void)
    {
        qt_QAbstractSpinBox_interpretText_void_QAbstractSpinBox(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_stepBy0, void)
    {
        qt_QAbstractSpinBox_stepBy_void_QAbstractSpinBox_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int));
    }

    static NODE_IMPLEMENTATION(_n_event0, bool)
    {
        NODE_RETURN(qt_QAbstractSpinBox_event_bool_QAbstractSpinBox_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_inputMethodQuery0, Pointer)
    {
        NODE_RETURN(
            qt_QAbstractSpinBox_inputMethodQuery_QVariant_QAbstractSpinBox_int(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_minimumSizeHint0, Pointer)
    {
        NODE_RETURN(qt_QAbstractSpinBox_minimumSizeHint_QSize_QAbstractSpinBox(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_sizeHint0, Pointer)
    {
        NODE_RETURN(qt_QAbstractSpinBox_sizeHint_QSize_QAbstractSpinBox(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_lineEdit0, Pointer)
    {
        NODE_RETURN(qt_QAbstractSpinBox_lineEdit_QLineEdit_QAbstractSpinBox(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_setLineEdit0, void)
    {
        qt_QAbstractSpinBox_setLineEdit_void_QAbstractSpinBox_QLineEdit(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_changeEvent0, void)
    {
        qt_QAbstractSpinBox_changeEvent_void_QAbstractSpinBox_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_closeEvent0, void)
    {
        qt_QAbstractSpinBox_closeEvent_void_QAbstractSpinBox_QCloseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_contextMenuEvent0, void)
    {
        qt_QAbstractSpinBox_contextMenuEvent_void_QAbstractSpinBox_QContextMenuEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_focusInEvent0, void)
    {
        qt_QAbstractSpinBox_focusInEvent_void_QAbstractSpinBox_QFocusEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_focusOutEvent0, void)
    {
        qt_QAbstractSpinBox_focusOutEvent_void_QAbstractSpinBox_QFocusEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_hideEvent0, void)
    {
        qt_QAbstractSpinBox_hideEvent_void_QAbstractSpinBox_QHideEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_keyPressEvent0, void)
    {
        qt_QAbstractSpinBox_keyPressEvent_void_QAbstractSpinBox_QKeyEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_keyReleaseEvent0, void)
    {
        qt_QAbstractSpinBox_keyReleaseEvent_void_QAbstractSpinBox_QKeyEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mouseMoveEvent0, void)
    {
        qt_QAbstractSpinBox_mouseMoveEvent_void_QAbstractSpinBox_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mousePressEvent0, void)
    {
        qt_QAbstractSpinBox_mousePressEvent_void_QAbstractSpinBox_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mouseReleaseEvent0, void)
    {
        qt_QAbstractSpinBox_mouseReleaseEvent_void_QAbstractSpinBox_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_paintEvent0, void)
    {
        qt_QAbstractSpinBox_paintEvent_void_QAbstractSpinBox_QPaintEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_resizeEvent0, void)
    {
        qt_QAbstractSpinBox_resizeEvent_void_QAbstractSpinBox_QResizeEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_showEvent0, void)
    {
        qt_QAbstractSpinBox_showEvent_void_QAbstractSpinBox_QShowEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_timerEvent0, void)
    {
        qt_QAbstractSpinBox_timerEvent_void_QAbstractSpinBox_QTimerEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_wheelEvent0, void)
    {
        qt_QAbstractSpinBox_wheelEvent_void_QAbstractSpinBox_QWheelEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_hasHeightForWidth0, bool)
    {
        NODE_RETURN(qt_QAbstractSpinBox_hasHeightForWidth_bool_QAbstractSpinBox(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_heightForWidth0, int)
    {
        NODE_RETURN(qt_QAbstractSpinBox_heightForWidth_int_QAbstractSpinBox_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_dragEnterEvent0, void)
    {
        qt_QAbstractSpinBox_dragEnterEvent_void_QAbstractSpinBox_QDragEnterEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dragLeaveEvent0, void)
    {
        qt_QAbstractSpinBox_dragLeaveEvent_void_QAbstractSpinBox_QDragLeaveEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dragMoveEvent0, void)
    {
        qt_QAbstractSpinBox_dragMoveEvent_void_QAbstractSpinBox_QDragMoveEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dropEvent0, void)
    {
        qt_QAbstractSpinBox_dropEvent_void_QAbstractSpinBox_QDropEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_focusNextPrevChild0, bool)
    {
        NODE_RETURN(
            qt_QAbstractSpinBox_focusNextPrevChild_bool_QAbstractSpinBox_bool(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, bool)));
    }

    static NODE_IMPLEMENTATION(_n_leaveEvent0, void)
    {
        qt_QAbstractSpinBox_leaveEvent_void_QAbstractSpinBox_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mouseDoubleClickEvent0, void)
    {
        qt_QAbstractSpinBox_mouseDoubleClickEvent_void_QAbstractSpinBox_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_moveEvent0, void)
    {
        qt_QAbstractSpinBox_moveEvent_void_QAbstractSpinBox_QMoveEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_tabletEvent0, void)
    {
        qt_QAbstractSpinBox_tabletEvent_void_QAbstractSpinBox_QTabletEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_metric0, int)
    {
        NODE_RETURN(qt_QAbstractSpinBox_metric_int_QAbstractSpinBox_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    void QAbstractSpinBoxType::load()
    {
        USING_MU_FUNCTION_SYMBOLS;
        MuLangContext* c = static_cast<MuLangContext*>(context());
        Module* global = globalModule();

        const string typeName = name();
        const string refTypeName = typeName + "&";
        const string fullTypeName = fullyQualifiedName();
        const string fullRefTypeName = fullTypeName + "&";
        const char* tn = typeName.c_str();
        const char* ftn = fullTypeName.c_str();
        const char* rtn = refTypeName.c_str();
        const char* frtn = fullRefTypeName.c_str();

        scope()->addSymbols(new ReferenceType(c, rtn, this),

                            new Function(c, tn, BaseFunctions::dereference,
                                         Cast, Return, ftn, Args, frtn, End),

                            EndArguments);

        addSymbols(new Function(c, "__allocate", BaseFunctions::classAllocate,
                                None, Return, ftn, End),

                   new Function(c, tn, castFromObject, Cast, Compiled,
                                QAbstractSpinBox_QAbstractSpinBox_QObject,
                                Return, ftn, Parameters,
                                new Param(c, "object", "qt.QObject"), End),

                   EndArguments);

        addSymbols(
            // enums
            // member functions
            new Function(
                c, "QAbstractSpinBox", _n_QAbstractSpinBox0, None, Compiled,
                qt_QAbstractSpinBox_QAbstractSpinBox_QAbstractSpinBox_QAbstractSpinBox_QWidget,
                Return, "qt.QAbstractSpinBox", Parameters,
                new Param(c, "this", "qt.QAbstractSpinBox"),
                new Param(c, "parent", "qt.QWidget"), End),
            // PROP: alignment (flags Qt::Alignment; QAbstractSpinBox this)
            // PROP: buttonSymbols (flags QAbstractSpinBox::ButtonSymbols;
            // QAbstractSpinBox this) PROP: correctionMode (flags
            // QAbstractSpinBox::CorrectionMode; QAbstractSpinBox this) PROP:
            // hasAcceptableInput (bool; QAbstractSpinBox this) PROP: hasFrame
            // (bool; QAbstractSpinBox this)
            new Function(
                c, "interpretText", _n_interpretText0, None, Compiled,
                qt_QAbstractSpinBox_interpretText_void_QAbstractSpinBox, Return,
                "void", Parameters, new Param(c, "this", "qt.QAbstractSpinBox"),
                End),
            // PROP: isAccelerated (bool; QAbstractSpinBox this)
            // PROP: isGroupSeparatorShown (bool; QAbstractSpinBox this)
            // PROP: isReadOnly (bool; QAbstractSpinBox this)
            // PROP: keyboardTracking (bool; QAbstractSpinBox this)
            // PROP: setAccelerated (void; QAbstractSpinBox this, bool on)
            // PROP: setAlignment (void; QAbstractSpinBox this, flags
            // Qt::Alignment flag) PROP: setButtonSymbols (void;
            // QAbstractSpinBox this, flags QAbstractSpinBox::ButtonSymbols bs)
            // PROP: setCorrectionMode (void; QAbstractSpinBox this, flags
            // QAbstractSpinBox::CorrectionMode cm) PROP: setFrame (void;
            // QAbstractSpinBox this, bool _p4) PROP: setGroupSeparatorShown
            // (void; QAbstractSpinBox this, bool shown) PROP:
            // setKeyboardTracking (void; QAbstractSpinBox this, bool kt) PROP:
            // setReadOnly (void; QAbstractSpinBox this, bool r) PROP:
            // setSpecialValueText (void; QAbstractSpinBox this, string txt)
            // PROP: setWrapping (void; QAbstractSpinBox this, bool w)
            // PROP: specialValueText (string; QAbstractSpinBox this)
            _func[0] = new MemberFunction(
                c, "stepBy", _n_stepBy0, None, Compiled,
                qt_QAbstractSpinBox_stepBy_void_QAbstractSpinBox_int, Return,
                "void", Parameters, new Param(c, "this", "qt.QAbstractSpinBox"),
                new Param(c, "steps", "int"), End),
            // PROP: text (string; QAbstractSpinBox this)
            // MISSING: validate (flags QValidator::State; QAbstractSpinBox
            // this, string input, "int &" pos) PROP: wrapping (bool;
            // QAbstractSpinBox this)
            _func[1] = new MemberFunction(
                c, "event", _n_event0, None, Compiled,
                qt_QAbstractSpinBox_event_bool_QAbstractSpinBox_QEvent, Return,
                "bool", Parameters, new Param(c, "this", "qt.QAbstractSpinBox"),
                new Param(c, "event_", "qt.QEvent"), End),
            _func[2] = new MemberFunction(
                c, "inputMethodQuery", _n_inputMethodQuery0, None, Compiled,
                qt_QAbstractSpinBox_inputMethodQuery_QVariant_QAbstractSpinBox_int,
                Return, "qt.QVariant", Parameters,
                new Param(c, "this", "qt.QAbstractSpinBox"),
                new Param(c, "query", "int"), End),
            _func[3] = new MemberFunction(
                c, "minimumSizeHint", _n_minimumSizeHint0, None, Compiled,
                qt_QAbstractSpinBox_minimumSizeHint_QSize_QAbstractSpinBox,
                Return, "qt.QSize", Parameters,
                new Param(c, "this", "qt.QAbstractSpinBox"), End),
            _func[4] = new MemberFunction(
                c, "sizeHint", _n_sizeHint0, None, Compiled,
                qt_QAbstractSpinBox_sizeHint_QSize_QAbstractSpinBox, Return,
                "qt.QSize", Parameters,
                new Param(c, "this", "qt.QAbstractSpinBox"), End),
            // MISSING: initStyleOption (void; QAbstractSpinBox this,
            // "QStyleOptionSpinBox *" option) // protected
            new Function(
                c, "lineEdit", _n_lineEdit0, None, Compiled,
                qt_QAbstractSpinBox_lineEdit_QLineEdit_QAbstractSpinBox, Return,
                "qt.QLineEdit", Parameters,
                new Param(c, "this", "qt.QAbstractSpinBox"), End),
            new Function(
                c, "setLineEdit", _n_setLineEdit0, None, Compiled,
                qt_QAbstractSpinBox_setLineEdit_void_QAbstractSpinBox_QLineEdit,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSpinBox"),
                new Param(c, "lineEdit", "qt.QLineEdit"), End),
            _func[5] = new MemberFunction(
                c, "changeEvent", _n_changeEvent0, None, Compiled,
                qt_QAbstractSpinBox_changeEvent_void_QAbstractSpinBox_QEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSpinBox"),
                new Param(c, "event", "qt.QEvent"), End),
            _func[6] = new MemberFunction(
                c, "closeEvent", _n_closeEvent0, None, Compiled,
                qt_QAbstractSpinBox_closeEvent_void_QAbstractSpinBox_QCloseEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSpinBox"),
                new Param(c, "event", "qt.QCloseEvent"), End),
            _func[7] = new MemberFunction(
                c, "contextMenuEvent", _n_contextMenuEvent0, None, Compiled,
                qt_QAbstractSpinBox_contextMenuEvent_void_QAbstractSpinBox_QContextMenuEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSpinBox"),
                new Param(c, "event", "qt.QContextMenuEvent"), End),
            _func[8] = new MemberFunction(
                c, "focusInEvent", _n_focusInEvent0, None, Compiled,
                qt_QAbstractSpinBox_focusInEvent_void_QAbstractSpinBox_QFocusEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSpinBox"),
                new Param(c, "event", "qt.QFocusEvent"), End),
            _func[9] = new MemberFunction(
                c, "focusOutEvent", _n_focusOutEvent0, None, Compiled,
                qt_QAbstractSpinBox_focusOutEvent_void_QAbstractSpinBox_QFocusEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSpinBox"),
                new Param(c, "event", "qt.QFocusEvent"), End),
            _func[10] = new MemberFunction(
                c, "hideEvent", _n_hideEvent0, None, Compiled,
                qt_QAbstractSpinBox_hideEvent_void_QAbstractSpinBox_QHideEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSpinBox"),
                new Param(c, "event", "qt.QHideEvent"), End),
            _func[11] = new MemberFunction(
                c, "keyPressEvent", _n_keyPressEvent0, None, Compiled,
                qt_QAbstractSpinBox_keyPressEvent_void_QAbstractSpinBox_QKeyEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSpinBox"),
                new Param(c, "event", "qt.QKeyEvent"), End),
            _func[12] = new MemberFunction(
                c, "keyReleaseEvent", _n_keyReleaseEvent0, None, Compiled,
                qt_QAbstractSpinBox_keyReleaseEvent_void_QAbstractSpinBox_QKeyEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSpinBox"),
                new Param(c, "event", "qt.QKeyEvent"), End),
            _func[13] = new MemberFunction(
                c, "mouseMoveEvent", _n_mouseMoveEvent0, None, Compiled,
                qt_QAbstractSpinBox_mouseMoveEvent_void_QAbstractSpinBox_QMouseEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSpinBox"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[14] = new MemberFunction(
                c, "mousePressEvent", _n_mousePressEvent0, None, Compiled,
                qt_QAbstractSpinBox_mousePressEvent_void_QAbstractSpinBox_QMouseEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSpinBox"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[15] = new MemberFunction(
                c, "mouseReleaseEvent", _n_mouseReleaseEvent0, None, Compiled,
                qt_QAbstractSpinBox_mouseReleaseEvent_void_QAbstractSpinBox_QMouseEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSpinBox"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[16] = new MemberFunction(
                c, "paintEvent", _n_paintEvent0, None, Compiled,
                qt_QAbstractSpinBox_paintEvent_void_QAbstractSpinBox_QPaintEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSpinBox"),
                new Param(c, "event", "qt.QPaintEvent"), End),
            _func[17] = new MemberFunction(
                c, "resizeEvent", _n_resizeEvent0, None, Compiled,
                qt_QAbstractSpinBox_resizeEvent_void_QAbstractSpinBox_QResizeEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSpinBox"),
                new Param(c, "event", "qt.QResizeEvent"), End),
            _func[18] = new MemberFunction(
                c, "showEvent", _n_showEvent0, None, Compiled,
                qt_QAbstractSpinBox_showEvent_void_QAbstractSpinBox_QShowEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSpinBox"),
                new Param(c, "event", "qt.QShowEvent"), End),
            _func[19] = new MemberFunction(
                c, "timerEvent", _n_timerEvent0, None, Compiled,
                qt_QAbstractSpinBox_timerEvent_void_QAbstractSpinBox_QTimerEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSpinBox"),
                new Param(c, "event", "qt.QTimerEvent"), End),
            _func[20] = new MemberFunction(
                c, "wheelEvent", _n_wheelEvent0, None, Compiled,
                qt_QAbstractSpinBox_wheelEvent_void_QAbstractSpinBox_QWheelEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSpinBox"),
                new Param(c, "event", "qt.QWheelEvent"), End),
            _func[21] = new MemberFunction(
                c, "hasHeightForWidth", _n_hasHeightForWidth0, None, Compiled,
                qt_QAbstractSpinBox_hasHeightForWidth_bool_QAbstractSpinBox,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractSpinBox"), End),
            _func[22] = new MemberFunction(
                c, "heightForWidth", _n_heightForWidth0, None, Compiled,
                qt_QAbstractSpinBox_heightForWidth_int_QAbstractSpinBox_int,
                Return, "int", Parameters,
                new Param(c, "this", "qt.QAbstractSpinBox"),
                new Param(c, "w", "int"), End),
            // MISSING: paintEngine ("QPaintEngine *"; QAbstractSpinBox this)
            // MISSING: actionEvent (void; QAbstractSpinBox this, "QActionEvent
            // *" event) // protected
            _func[23] = new MemberFunction(
                c, "dragEnterEvent", _n_dragEnterEvent0, None, Compiled,
                qt_QAbstractSpinBox_dragEnterEvent_void_QAbstractSpinBox_QDragEnterEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSpinBox"),
                new Param(c, "event", "qt.QDragEnterEvent"), End),
            _func[24] = new MemberFunction(
                c, "dragLeaveEvent", _n_dragLeaveEvent0, None, Compiled,
                qt_QAbstractSpinBox_dragLeaveEvent_void_QAbstractSpinBox_QDragLeaveEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSpinBox"),
                new Param(c, "event", "qt.QDragLeaveEvent"), End),
            _func[25] = new MemberFunction(
                c, "dragMoveEvent", _n_dragMoveEvent0, None, Compiled,
                qt_QAbstractSpinBox_dragMoveEvent_void_QAbstractSpinBox_QDragMoveEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSpinBox"),
                new Param(c, "event", "qt.QDragMoveEvent"), End),
            _func[26] = new MemberFunction(
                c, "dropEvent", _n_dropEvent0, None, Compiled,
                qt_QAbstractSpinBox_dropEvent_void_QAbstractSpinBox_QDropEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSpinBox"),
                new Param(c, "event", "qt.QDropEvent"), End),
            // MISSING: enterEvent (void; QAbstractSpinBox this, "QEnterEvent *"
            // event) // protected
            _func[27] = new MemberFunction(
                c, "focusNextPrevChild", _n_focusNextPrevChild0, None, Compiled,
                qt_QAbstractSpinBox_focusNextPrevChild_bool_QAbstractSpinBox_bool,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QAbstractSpinBox"),
                new Param(c, "next", "bool"), End),
            // MISSING: inputMethodEvent (void; QAbstractSpinBox this,
            // "QInputMethodEvent *" event) // protected
            _func[28] = new MemberFunction(
                c, "leaveEvent", _n_leaveEvent0, None, Compiled,
                qt_QAbstractSpinBox_leaveEvent_void_QAbstractSpinBox_QEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSpinBox"),
                new Param(c, "event", "qt.QEvent"), End),
            _func[29] = new MemberFunction(
                c, "mouseDoubleClickEvent", _n_mouseDoubleClickEvent0, None,
                Compiled,
                qt_QAbstractSpinBox_mouseDoubleClickEvent_void_QAbstractSpinBox_QMouseEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSpinBox"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[30] = new MemberFunction(
                c, "moveEvent", _n_moveEvent0, None, Compiled,
                qt_QAbstractSpinBox_moveEvent_void_QAbstractSpinBox_QMoveEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSpinBox"),
                new Param(c, "event", "qt.QMoveEvent"), End),
            // MISSING: nativeEvent (bool; QAbstractSpinBox this, QByteArray
            // eventType, "void *" message, "qintptr *" result) // protected
            _func[31] = new MemberFunction(
                c, "tabletEvent", _n_tabletEvent0, None, Compiled,
                qt_QAbstractSpinBox_tabletEvent_void_QAbstractSpinBox_QTabletEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QAbstractSpinBox"),
                new Param(c, "event", "qt.QTabletEvent"), End),
            // MISSING: initPainter (void; QAbstractSpinBox this, "QPainter *"
            // painter) // protected
            _func[32] = new MemberFunction(
                c, "metric", _n_metric0, None, Compiled,
                qt_QAbstractSpinBox_metric_int_QAbstractSpinBox_int, Return,
                "int", Parameters, new Param(c, "this", "qt.QAbstractSpinBox"),
                new Param(c, "m", "int"), End),
            // static functions
            EndArguments);
        globalScope()->addSymbols(EndArguments);
        scope()->addSymbols(EndArguments);

        const char** propExclusions = 0;

        populate(this, QAbstractSpinBox::staticMetaObject, propExclusions);
    }

} // namespace Mu
