//*****************************************************************************
// Copyright (c) 2024 Autodesk, Inc.
// All rights reserved.
//
// SPDX-License-Identifier: Apache-2.0
//
//*****************************************************************************

// IMPORTANT: This file (not the template) is auto-generated by qt2mu.py script.
//            The prefered way to do a fix is to handrolled it or modify the
//            qt2mu.py script. If it is not possible, manual editing is ok but
//            it could be lost in future generations.

#include <MuQt6/qtUtils.h>
#include <MuQt6/QMenuType.h>
#include <QtGui/QtGui>
#include <QtWidgets/QtWidgets>
#include <QtSvg/QtSvg>
#include <QSvgWidget>
#include <QtNetwork/QtNetwork>
#include <MuQt6/QWidgetType.h>
#include <MuQt6/QActionType.h>
#include <MuQt6/QIconType.h>
#include <Mu/BaseFunctions.h>
#include <Mu/Thread.h>
#include <Mu/Alias.h>
#include <Mu/SymbolicConstant.h>
#include <Mu/ClassInstance.h>
#include <Mu/Function.h>
#include <Mu/MemberFunction.h>
#include <Mu/MemberVariable.h>
#include <Mu/Node.h>
#include <Mu/Exception.h>
#include <Mu/ParameterVariable.h>
#include <Mu/ReferenceType.h>
#include <Mu/Value.h>
#include <MuLang/MuLangContext.h>
#include <MuLang/StringType.h>
#include <MuQt6/QCloseEventType.h>
#include <MuQt6/QDragMoveEventType.h>
#include <MuQt6/QPointType.h>
#include <MuQt6/QWheelEventType.h>
#include <MuQt6/QMouseEventType.h>
#include <MuQt6/QFocusEventType.h>
#include <MuQt6/QIconType.h>
#include <MuQt6/QShowEventType.h>
#include <MuQt6/QSizeType.h>
#include <MuQt6/QDropEventType.h>
#include <MuQt6/QPaintEventType.h>
#include <MuQt6/QTabletEventType.h>
#include <MuQt6/QVariantType.h>
#include <MuQt6/QDragLeaveEventType.h>
#include <MuQt6/QHideEventType.h>
#include <MuQt6/QMoveEventType.h>
#include <MuQt6/QTimerEventType.h>
#include <MuQt6/QDragEnterEventType.h>
#include <MuQt6/QEventType.h>
#include <MuQt6/QRectType.h>
#include <MuQt6/QContextMenuEventType.h>
#include <MuQt6/QKeyEventType.h>
#include <MuQt6/QActionType.h>
#include <MuQt6/QResizeEventType.h>

namespace Mu
{
    using namespace std;

    //----------------------------------------------------------------------
    //  INHERITABLE TYPE IMPLEMENTATION

    // destructor
    MuQt_QMenu::~MuQt_QMenu()
    {
        if (_obj)
        {
            *_obj->data<Pointer>() = Pointer(0);
            _obj->releaseExternal();
        }
        _obj = 0;
        _env = 0;
        _baseType = 0;
    }

    MuQt_QMenu::MuQt_QMenu(Pointer muobj, const CallEnvironment* ce,
                           QWidget* parent)
        : QMenu(parent)
    {
        _env = ce;
        _obj = reinterpret_cast<ClassInstance*>(muobj);
        _obj->retainExternal();
        MuLangContext* c = (MuLangContext*)_env->context();
        _baseType = c->findSymbolOfTypeByQualifiedName<QMenuType>(
            c->internName("qt.QMenu"));
    }

    MuQt_QMenu::MuQt_QMenu(Pointer muobj, const CallEnvironment* ce,
                           const QString& title, QWidget* parent)
        : QMenu(title, parent)
    {
        _env = ce;
        _obj = reinterpret_cast<ClassInstance*>(muobj);
        _obj->retainExternal();
        MuLangContext* c = (MuLangContext*)_env->context();
        _baseType = c->findSymbolOfTypeByQualifiedName<QMenuType>(
            c->internName("qt.QMenu"));
    }

    QSize MuQt_QMenu::sizeHint() const
    {
        if (!_env)
            return QMenu::sizeHint();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[0];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return getqtype<QSizeType>(rval._Pointer);
        }
        else
        {
            return QMenu::sizeHint();
        }
    }

    void MuQt_QMenu::changeEvent(QEvent* e)
    {
        if (!_env)
        {
            QMenu::changeEvent(e);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[1];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, e, "qt.QEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QMenu::changeEvent(e);
        }
    }

    bool MuQt_QMenu::event(QEvent* e)
    {
        if (!_env)
            return QMenu::event(e);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[2];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, e, "qt.QEvent"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QMenu::event(e);
        }
    }

    bool MuQt_QMenu::focusNextPrevChild(bool next)
    {
        if (!_env)
            return QMenu::focusNextPrevChild(next);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[3];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(next);
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QMenu::focusNextPrevChild(next);
        }
    }

    void MuQt_QMenu::hideEvent(QHideEvent* _p13)
    {
        if (!_env)
        {
            QMenu::hideEvent(_p13);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[4];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QHideEventType>(c, _p13, "qt.QHideEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QMenu::hideEvent(_p13);
        }
    }

    void MuQt_QMenu::keyPressEvent(QKeyEvent* e)
    {
        if (!_env)
        {
            QMenu::keyPressEvent(e);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[5];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QKeyEventType>(c, e, "qt.QKeyEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QMenu::keyPressEvent(e);
        }
    }

    void MuQt_QMenu::leaveEvent(QEvent* _p9)
    {
        if (!_env)
        {
            QMenu::leaveEvent(_p9);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[6];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, _p9, "qt.QEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QMenu::leaveEvent(_p9);
        }
    }

    void MuQt_QMenu::mouseMoveEvent(QMouseEvent* e)
    {
        if (!_env)
        {
            QMenu::mouseMoveEvent(e);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[7];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QMouseEventType>(c, e, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QMenu::mouseMoveEvent(e);
        }
    }

    void MuQt_QMenu::mousePressEvent(QMouseEvent* e)
    {
        if (!_env)
        {
            QMenu::mousePressEvent(e);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[8];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QMouseEventType>(c, e, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QMenu::mousePressEvent(e);
        }
    }

    void MuQt_QMenu::mouseReleaseEvent(QMouseEvent* e)
    {
        if (!_env)
        {
            QMenu::mouseReleaseEvent(e);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[9];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QMouseEventType>(c, e, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QMenu::mouseReleaseEvent(e);
        }
    }

    void MuQt_QMenu::paintEvent(QPaintEvent* e)
    {
        if (!_env)
        {
            QMenu::paintEvent(e);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[10];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QPaintEventType>(c, e, "qt.QPaintEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QMenu::paintEvent(e);
        }
    }

    void MuQt_QMenu::timerEvent(QTimerEvent* e)
    {
        if (!_env)
        {
            QMenu::timerEvent(e);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[11];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QTimerEventType>(c, e, "qt.QTimerEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QMenu::timerEvent(e);
        }
    }

    void MuQt_QMenu::wheelEvent(QWheelEvent* e)
    {
        if (!_env)
        {
            QMenu::wheelEvent(e);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[12];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QWheelEventType>(c, e, "qt.QWheelEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QMenu::wheelEvent(e);
        }
    }

    bool MuQt_QMenu::hasHeightForWidth() const
    {
        if (!_env)
            return QMenu::hasHeightForWidth();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[13];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QMenu::hasHeightForWidth();
        }
    }

    int MuQt_QMenu::heightForWidth(int w) const
    {
        if (!_env)
            return QMenu::heightForWidth(w);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[14];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(w);
            Value rval = _env->call(F, args);
            return (int)(rval._int);
        }
        else
        {
            return QMenu::heightForWidth(w);
        }
    }

    QVariant MuQt_QMenu::inputMethodQuery(Qt::InputMethodQuery query) const
    {
        if (!_env)
            return QMenu::inputMethodQuery(query);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[15];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(int(query));
            Value rval = _env->call(F, args);
            return getqtype<QVariantType>(rval._Pointer);
        }
        else
        {
            return QMenu::inputMethodQuery(query);
        }
    }

    QSize MuQt_QMenu::minimumSizeHint() const
    {
        if (!_env)
            return QMenu::minimumSizeHint();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[16];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return getqtype<QSizeType>(rval._Pointer);
        }
        else
        {
            return QMenu::minimumSizeHint();
        }
    }

    void MuQt_QMenu::closeEvent(QCloseEvent* event)
    {
        if (!_env)
        {
            QMenu::closeEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[17];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QCloseEventType>(c, event, "qt.QCloseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QMenu::closeEvent(event);
        }
    }

    void MuQt_QMenu::contextMenuEvent(QContextMenuEvent* event)
    {
        if (!_env)
        {
            QMenu::contextMenuEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[18];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QContextMenuEventType>(
                c, event, "qt.QContextMenuEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QMenu::contextMenuEvent(event);
        }
    }

    void MuQt_QMenu::dragEnterEvent(QDragEnterEvent* event)
    {
        if (!_env)
        {
            QMenu::dragEnterEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[19];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QDragEnterEventType>(
                c, event, "qt.QDragEnterEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QMenu::dragEnterEvent(event);
        }
    }

    void MuQt_QMenu::dragLeaveEvent(QDragLeaveEvent* event)
    {
        if (!_env)
        {
            QMenu::dragLeaveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[20];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QDragLeaveEventType>(
                c, event, "qt.QDragLeaveEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QMenu::dragLeaveEvent(event);
        }
    }

    void MuQt_QMenu::dragMoveEvent(QDragMoveEvent* event)
    {
        if (!_env)
        {
            QMenu::dragMoveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[21];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QDragMoveEventType>(
                c, event, "qt.QDragMoveEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QMenu::dragMoveEvent(event);
        }
    }

    void MuQt_QMenu::dropEvent(QDropEvent* event)
    {
        if (!_env)
        {
            QMenu::dropEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[22];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QDropEventType>(c, event, "qt.QDropEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QMenu::dropEvent(event);
        }
    }

    void MuQt_QMenu::focusInEvent(QFocusEvent* event)
    {
        if (!_env)
        {
            QMenu::focusInEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[23];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QFocusEventType>(c, event, "qt.QFocusEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QMenu::focusInEvent(event);
        }
    }

    void MuQt_QMenu::focusOutEvent(QFocusEvent* event)
    {
        if (!_env)
        {
            QMenu::focusOutEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[24];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QFocusEventType>(c, event, "qt.QFocusEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QMenu::focusOutEvent(event);
        }
    }

    void MuQt_QMenu::keyReleaseEvent(QKeyEvent* event)
    {
        if (!_env)
        {
            QMenu::keyReleaseEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[25];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QKeyEventType>(c, event, "qt.QKeyEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QMenu::keyReleaseEvent(event);
        }
    }

    void MuQt_QMenu::mouseDoubleClickEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QMenu::mouseDoubleClickEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[26];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QMenu::mouseDoubleClickEvent(event);
        }
    }

    void MuQt_QMenu::moveEvent(QMoveEvent* event)
    {
        if (!_env)
        {
            QMenu::moveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[27];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QMoveEventType>(c, event, "qt.QMoveEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QMenu::moveEvent(event);
        }
    }

    void MuQt_QMenu::resizeEvent(QResizeEvent* event)
    {
        if (!_env)
        {
            QMenu::resizeEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[28];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QResizeEventType>(c, event, "qt.QResizeEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QMenu::resizeEvent(event);
        }
    }

    void MuQt_QMenu::showEvent(QShowEvent* event)
    {
        if (!_env)
        {
            QMenu::showEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[29];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QShowEventType>(c, event, "qt.QShowEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QMenu::showEvent(event);
        }
    }

    void MuQt_QMenu::tabletEvent(QTabletEvent* event)
    {
        if (!_env)
        {
            QMenu::tabletEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[30];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QTabletEventType>(c, event, "qt.QTabletEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QMenu::tabletEvent(event);
        }
    }

    int MuQt_QMenu::metric(QPaintDevice::PaintDeviceMetric m) const
    {
        if (!_env)
            return QMenu::metric(m);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[31];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(int(m));
            Value rval = _env->call(F, args);
            return (int)(rval._int);
        }
        else
        {
            return QMenu::metric(m);
        }
    }

    //----------------------------------------------------------------------
    //  Mu Type CONSTRUCTORS

    QMenuType::QMenuType(Context* c, const char* name, Class* super,
                         Class* super2)
        : Class(c, name, vectorOf2(super, super2))
    {
    }

    QMenuType::~QMenuType() {}

    //----------------------------------------------------------------------
    //  PRE-COMPILED FUNCTIONS

    static Pointer QMenu_QMenu_QObject(Thread& NODE_THREAD, Pointer obj)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        ClassInstance* widget = reinterpret_cast<ClassInstance*>(obj);

        if (!widget)
        {
            return 0;
        }
        else if (QMenu* w = object<QMenu>(widget))
        {
            QMenuType* type = c->findSymbolOfTypeByQualifiedName<QMenuType>(
                c->internName("qt.QMenu"), false);
            ClassInstance* o = ClassInstance::allocate(type);
            setobject(o, w);
            return o;
        }
        else
        {
            throw BadCastException();
        }
    }

    static NODE_IMPLEMENTATION(castFromObject, Pointer)
    {
        NODE_RETURN(QMenu_QMenu_QObject(NODE_THREAD, NODE_ARG(0, Pointer)));
    }

    Pointer qt_QMenu_QMenu_QMenu_QMenu_QWidget(Mu::Thread& NODE_THREAD,
                                               Pointer param_this,
                                               Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QWidget* arg1 = object<QWidget>(param_parent);
        setobject(
            param_this,
            new MuQt_QMenu(param_this, NODE_THREAD.process()->callEnv(), arg1));
        return param_this;
    }

    Pointer qt_QMenu_QMenu_QMenu_QMenu_string_QWidget(Mu::Thread& NODE_THREAD,
                                                      Pointer param_this,
                                                      Pointer param_title,
                                                      Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        const QString arg1 = qstring(param_title);
        QWidget* arg2 = object<QWidget>(param_parent);
        setobject(param_this,
                  new MuQt_QMenu(param_this, NODE_THREAD.process()->callEnv(),
                                 arg1, arg2));
        return param_this;
    }

    Pointer qt_QMenu_actionAt_QAction_QMenu_QPoint(Mu::Thread& NODE_THREAD,
                                                   Pointer param_this,
                                                   Pointer param_pt)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        const QPoint arg1 = getqtype<QPointType>(param_pt);
        return makeinstance<QActionType>(c, arg0->actionAt(arg1), "qt.QAction");
    }

    Pointer qt_QMenu_actionGeometry_QRect_QMenu_QAction(Mu::Thread& NODE_THREAD,
                                                        Pointer param_this,
                                                        Pointer param_act)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        QAction* arg1 = object<QAction>(param_act);
        return makeqtype<QRectType>(c, arg0->actionGeometry(arg1), "qt.QRect");
    }

    Pointer qt_QMenu_activeAction_QAction_QMenu(Mu::Thread& NODE_THREAD,
                                                Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        return makeinstance<QActionType>(c, arg0->activeAction(), "qt.QAction");
    }

    Pointer qt_QMenu_addMenu_QAction_QMenu_QMenu(Mu::Thread& NODE_THREAD,
                                                 Pointer param_this,
                                                 Pointer param_menu)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        QMenu* arg1 = object<QMenu>(param_menu);
        return makeinstance<QActionType>(c, arg0->addMenu(arg1), "qt.QAction");
    }

    Pointer qt_QMenu_addMenu_QMenu_QMenu_string(Mu::Thread& NODE_THREAD,
                                                Pointer param_this,
                                                Pointer param_title)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        const QString arg1 = qstring(param_title);
        return makeinstance<QMenuType>(c, arg0->addMenu(arg1), "qt.QMenu");
    }

    Pointer qt_QMenu_addMenu_QMenu_QMenu_QIcon_string(Mu::Thread& NODE_THREAD,
                                                      Pointer param_this,
                                                      Pointer param_icon,
                                                      Pointer param_title)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        const QIcon arg1 = getqtype<QIconType>(param_icon);
        const QString arg2 = qstring(param_title);
        return makeinstance<QMenuType>(c, arg0->addMenu(arg1, arg2),
                                       "qt.QMenu");
    }

    Pointer qt_QMenu_addSection_QAction_QMenu_string(Mu::Thread& NODE_THREAD,
                                                     Pointer param_this,
                                                     Pointer param_text)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        const QString arg1 = qstring(param_text);
        return makeinstance<QActionType>(c, arg0->addSection(arg1),
                                         "qt.QAction");
    }

    Pointer qt_QMenu_addSection_QAction_QMenu_QIcon_string(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_icon,
        Pointer param_text)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        const QIcon arg1 = getqtype<QIconType>(param_icon);
        const QString arg2 = qstring(param_text);
        return makeinstance<QActionType>(c, arg0->addSection(arg1, arg2),
                                         "qt.QAction");
    }

    Pointer qt_QMenu_addSeparator_QAction_QMenu(Mu::Thread& NODE_THREAD,
                                                Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        return makeinstance<QActionType>(c, arg0->addSeparator(), "qt.QAction");
    }

    void qt_QMenu_clear_void_QMenu(Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        arg0->clear();
    }

    Pointer qt_QMenu_defaultAction_QAction_QMenu(Mu::Thread& NODE_THREAD,
                                                 Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        return makeinstance<QActionType>(c, arg0->defaultAction(),
                                         "qt.QAction");
    }

    Pointer qt_QMenu_exec_QAction_QMenu(Mu::Thread& NODE_THREAD,
                                        Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        return makeinstance<QActionType>(c, arg0->exec(), "qt.QAction");
    }

    Pointer qt_QMenu_exec_QAction_QMenu_QPoint_QAction(Mu::Thread& NODE_THREAD,
                                                       Pointer param_this,
                                                       Pointer param_p,
                                                       Pointer param_action)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        const QPoint arg1 = getqtype<QPointType>(param_p);
        QAction* arg2 = object<QAction>(param_action);
        return makeinstance<QActionType>(c, arg0->exec(arg1, arg2),
                                         "qt.QAction");
    }

    void qt_QMenu_hideTearOffMenu_void_QMenu(Mu::Thread& NODE_THREAD,
                                             Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        arg0->hideTearOffMenu();
    }

    Pointer qt_QMenu_insertMenu_QAction_QMenu_QAction_QMenu(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_before,
        Pointer param_menu)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        QAction* arg1 = object<QAction>(param_before);
        QMenu* arg2 = object<QMenu>(param_menu);
        return makeinstance<QActionType>(c, arg0->insertMenu(arg1, arg2),
                                         "qt.QAction");
    }

    Pointer qt_QMenu_insertSection_QAction_QMenu_QAction_string(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_before,
        Pointer param_text)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        QAction* arg1 = object<QAction>(param_before);
        const QString arg2 = qstring(param_text);
        return makeinstance<QActionType>(c, arg0->insertSection(arg1, arg2),
                                         "qt.QAction");
    }

    Pointer qt_QMenu_insertSection_QAction_QMenu_QAction_QIcon_string(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_before,
        Pointer param_icon, Pointer param_text)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        QAction* arg1 = object<QAction>(param_before);
        const QIcon arg2 = getqtype<QIconType>(param_icon);
        const QString arg3 = qstring(param_text);
        return makeinstance<QActionType>(
            c, arg0->insertSection(arg1, arg2, arg3), "qt.QAction");
    }

    Pointer qt_QMenu_insertSeparator_QAction_QMenu_QAction(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_before)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        QAction* arg1 = object<QAction>(param_before);
        return makeinstance<QActionType>(c, arg0->insertSeparator(arg1),
                                         "qt.QAction");
    }

    bool qt_QMenu_isEmpty_bool_QMenu(Mu::Thread& NODE_THREAD,
                                     Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        return arg0->isEmpty();
    }

    bool qt_QMenu_isTearOffMenuVisible_bool_QMenu(Mu::Thread& NODE_THREAD,
                                                  Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        return arg0->isTearOffMenuVisible();
    }

    Pointer qt_QMenu_menuAction_QAction_QMenu(Mu::Thread& NODE_THREAD,
                                              Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        return makeinstance<QActionType>(c, arg0->menuAction(), "qt.QAction");
    }

    void qt_QMenu_popup_void_QMenu_QPoint_QAction(Mu::Thread& NODE_THREAD,
                                                  Pointer param_this,
                                                  Pointer param_p,
                                                  Pointer param_atAction)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        const QPoint arg1 = getqtype<QPointType>(param_p);
        QAction* arg2 = object<QAction>(param_atAction);
        arg0->popup(arg1, arg2);
    }

    void qt_QMenu_setActiveAction_void_QMenu_QAction(Mu::Thread& NODE_THREAD,
                                                     Pointer param_this,
                                                     Pointer param_act)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        QAction* arg1 = object<QAction>(param_act);
        arg0->setActiveAction(arg1);
    }

    void qt_QMenu_setDefaultAction_void_QMenu_QAction(Mu::Thread& NODE_THREAD,
                                                      Pointer param_this,
                                                      Pointer param_act)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        QAction* arg1 = object<QAction>(param_act);
        arg0->setDefaultAction(arg1);
    }

    void qt_QMenu_showTearOffMenu_void_QMenu_QPoint(Mu::Thread& NODE_THREAD,
                                                    Pointer param_this,
                                                    Pointer param_pos)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        const QPoint arg1 = getqtype<QPointType>(param_pos);
        arg0->showTearOffMenu(arg1);
    }

    void qt_QMenu_showTearOffMenu_void_QMenu(Mu::Thread& NODE_THREAD,
                                             Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        arg0->showTearOffMenu();
    }

    Pointer qt_QMenu_sizeHint_QSize_QMenu(Mu::Thread& NODE_THREAD,
                                          Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        return isMuQtObject(arg0)
                   ? makeqtype<QSizeType>(c, arg0->QMenu::sizeHint(),
                                          "qt.QSize")
                   : makeqtype<QSizeType>(c, arg0->sizeHint(), "qt.QSize");
    }

    int qt_QMenu_columnCount_int_QMenu(Mu::Thread& NODE_THREAD,
                                       Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        return ((MuQt_QMenu*)arg0)->columnCount_pub();
    }

    void qt_QMenu_changeEvent_void_QMenu_QEvent(Mu::Thread& NODE_THREAD,
                                                Pointer param_this,
                                                Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_e);
        if (isMuQtObject(arg0))
            ((MuQt_QMenu*)arg0)->changeEvent_pub_parent(arg1);
        else
            ((MuQt_QMenu*)arg0)->changeEvent_pub(arg1);
    }

    bool qt_QMenu_event_bool_QMenu_QEvent(Mu::Thread& NODE_THREAD,
                                          Pointer param_this, Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_e);
        return isMuQtObject(arg0) ? ((MuQt_QMenu*)arg0)->event_pub_parent(arg1)
                                  : ((MuQt_QMenu*)arg0)->event_pub(arg1);
    }

    bool qt_QMenu_focusNextPrevChild_bool_QMenu_bool(Mu::Thread& NODE_THREAD,
                                                     Pointer param_this,
                                                     bool param_next)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        bool arg1 = (bool)(param_next);
        return isMuQtObject(arg0)
                   ? ((MuQt_QMenu*)arg0)->focusNextPrevChild_pub_parent(arg1)
                   : ((MuQt_QMenu*)arg0)->focusNextPrevChild_pub(arg1);
    }

    void qt_QMenu_hideEvent_void_QMenu_QHideEvent(Mu::Thread& NODE_THREAD,
                                                  Pointer param_this,
                                                  Pointer param__p13)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        QHideEvent* arg1 = getqpointer<QHideEventType>(param__p13);
        if (isMuQtObject(arg0))
            ((MuQt_QMenu*)arg0)->hideEvent_pub_parent(arg1);
        else
            ((MuQt_QMenu*)arg0)->hideEvent_pub(arg1);
    }

    void qt_QMenu_keyPressEvent_void_QMenu_QKeyEvent(Mu::Thread& NODE_THREAD,
                                                     Pointer param_this,
                                                     Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        QKeyEvent* arg1 = getqpointer<QKeyEventType>(param_e);
        if (isMuQtObject(arg0))
            ((MuQt_QMenu*)arg0)->keyPressEvent_pub_parent(arg1);
        else
            ((MuQt_QMenu*)arg0)->keyPressEvent_pub(arg1);
    }

    void qt_QMenu_leaveEvent_void_QMenu_QEvent(Mu::Thread& NODE_THREAD,
                                               Pointer param_this,
                                               Pointer param__p9)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param__p9);
        if (isMuQtObject(arg0))
            ((MuQt_QMenu*)arg0)->leaveEvent_pub_parent(arg1);
        else
            ((MuQt_QMenu*)arg0)->leaveEvent_pub(arg1);
    }

    void qt_QMenu_mouseMoveEvent_void_QMenu_QMouseEvent(Mu::Thread& NODE_THREAD,
                                                        Pointer param_this,
                                                        Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_e);
        if (isMuQtObject(arg0))
            ((MuQt_QMenu*)arg0)->mouseMoveEvent_pub_parent(arg1);
        else
            ((MuQt_QMenu*)arg0)->mouseMoveEvent_pub(arg1);
    }

    void qt_QMenu_mousePressEvent_void_QMenu_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_e);
        if (isMuQtObject(arg0))
            ((MuQt_QMenu*)arg0)->mousePressEvent_pub_parent(arg1);
        else
            ((MuQt_QMenu*)arg0)->mousePressEvent_pub(arg1);
    }

    void qt_QMenu_mouseReleaseEvent_void_QMenu_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_e);
        if (isMuQtObject(arg0))
            ((MuQt_QMenu*)arg0)->mouseReleaseEvent_pub_parent(arg1);
        else
            ((MuQt_QMenu*)arg0)->mouseReleaseEvent_pub(arg1);
    }

    void qt_QMenu_paintEvent_void_QMenu_QPaintEvent(Mu::Thread& NODE_THREAD,
                                                    Pointer param_this,
                                                    Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        QPaintEvent* arg1 = getqpointer<QPaintEventType>(param_e);
        if (isMuQtObject(arg0))
            ((MuQt_QMenu*)arg0)->paintEvent_pub_parent(arg1);
        else
            ((MuQt_QMenu*)arg0)->paintEvent_pub(arg1);
    }

    void qt_QMenu_timerEvent_void_QMenu_QTimerEvent(Mu::Thread& NODE_THREAD,
                                                    Pointer param_this,
                                                    Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        QTimerEvent* arg1 = getqpointer<QTimerEventType>(param_e);
        if (isMuQtObject(arg0))
            ((MuQt_QMenu*)arg0)->timerEvent_pub_parent(arg1);
        else
            ((MuQt_QMenu*)arg0)->timerEvent_pub(arg1);
    }

    void qt_QMenu_wheelEvent_void_QMenu_QWheelEvent(Mu::Thread& NODE_THREAD,
                                                    Pointer param_this,
                                                    Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        QWheelEvent* arg1 = getqpointer<QWheelEventType>(param_e);
        if (isMuQtObject(arg0))
            ((MuQt_QMenu*)arg0)->wheelEvent_pub_parent(arg1);
        else
            ((MuQt_QMenu*)arg0)->wheelEvent_pub(arg1);
    }

    bool qt_QMenu_hasHeightForWidth_bool_QMenu(Mu::Thread& NODE_THREAD,
                                               Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        return isMuQtObject(arg0) ? arg0->QMenu::hasHeightForWidth()
                                  : arg0->hasHeightForWidth();
    }

    int qt_QMenu_heightForWidth_int_QMenu_int(Mu::Thread& NODE_THREAD,
                                              Pointer param_this, int param_w)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        int arg1 = (int)(param_w);
        return isMuQtObject(arg0) ? arg0->QMenu::heightForWidth(arg1)
                                  : arg0->heightForWidth(arg1);
    }

    Pointer qt_QMenu_inputMethodQuery_QVariant_QMenu_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_query)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        Qt::InputMethodQuery arg1 = (Qt::InputMethodQuery)(param_query);
        return isMuQtObject(arg0)
                   ? makeqtype<QVariantType>(
                         c, arg0->QMenu::inputMethodQuery(arg1), "qt.QVariant")
                   : makeqtype<QVariantType>(c, arg0->inputMethodQuery(arg1),
                                             "qt.QVariant");
    }

    Pointer qt_QMenu_minimumSizeHint_QSize_QMenu(Mu::Thread& NODE_THREAD,
                                                 Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        return isMuQtObject(arg0)
                   ? makeqtype<QSizeType>(c, arg0->QMenu::minimumSizeHint(),
                                          "qt.QSize")
                   : makeqtype<QSizeType>(c, arg0->minimumSizeHint(),
                                          "qt.QSize");
    }

    void qt_QMenu_closeEvent_void_QMenu_QCloseEvent(Mu::Thread& NODE_THREAD,
                                                    Pointer param_this,
                                                    Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        QCloseEvent* arg1 = getqpointer<QCloseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QMenu*)arg0)->closeEvent_pub_parent(arg1);
        else
            ((MuQt_QMenu*)arg0)->closeEvent_pub(arg1);
    }

    void qt_QMenu_contextMenuEvent_void_QMenu_QContextMenuEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        QContextMenuEvent* arg1 =
            getqpointer<QContextMenuEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QMenu*)arg0)->contextMenuEvent_pub_parent(arg1);
        else
            ((MuQt_QMenu*)arg0)->contextMenuEvent_pub(arg1);
    }

    void qt_QMenu_dragEnterEvent_void_QMenu_QDragEnterEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        QDragEnterEvent* arg1 = getqpointer<QDragEnterEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QMenu*)arg0)->dragEnterEvent_pub_parent(arg1);
        else
            ((MuQt_QMenu*)arg0)->dragEnterEvent_pub(arg1);
    }

    void qt_QMenu_dragLeaveEvent_void_QMenu_QDragLeaveEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        QDragLeaveEvent* arg1 = getqpointer<QDragLeaveEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QMenu*)arg0)->dragLeaveEvent_pub_parent(arg1);
        else
            ((MuQt_QMenu*)arg0)->dragLeaveEvent_pub(arg1);
    }

    void qt_QMenu_dragMoveEvent_void_QMenu_QDragMoveEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        QDragMoveEvent* arg1 = getqpointer<QDragMoveEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QMenu*)arg0)->dragMoveEvent_pub_parent(arg1);
        else
            ((MuQt_QMenu*)arg0)->dragMoveEvent_pub(arg1);
    }

    void qt_QMenu_dropEvent_void_QMenu_QDropEvent(Mu::Thread& NODE_THREAD,
                                                  Pointer param_this,
                                                  Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        QDropEvent* arg1 = getqpointer<QDropEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QMenu*)arg0)->dropEvent_pub_parent(arg1);
        else
            ((MuQt_QMenu*)arg0)->dropEvent_pub(arg1);
    }

    void qt_QMenu_focusInEvent_void_QMenu_QFocusEvent(Mu::Thread& NODE_THREAD,
                                                      Pointer param_this,
                                                      Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        QFocusEvent* arg1 = getqpointer<QFocusEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QMenu*)arg0)->focusInEvent_pub_parent(arg1);
        else
            ((MuQt_QMenu*)arg0)->focusInEvent_pub(arg1);
    }

    void qt_QMenu_focusOutEvent_void_QMenu_QFocusEvent(Mu::Thread& NODE_THREAD,
                                                       Pointer param_this,
                                                       Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        QFocusEvent* arg1 = getqpointer<QFocusEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QMenu*)arg0)->focusOutEvent_pub_parent(arg1);
        else
            ((MuQt_QMenu*)arg0)->focusOutEvent_pub(arg1);
    }

    void qt_QMenu_keyReleaseEvent_void_QMenu_QKeyEvent(Mu::Thread& NODE_THREAD,
                                                       Pointer param_this,
                                                       Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        QKeyEvent* arg1 = getqpointer<QKeyEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QMenu*)arg0)->keyReleaseEvent_pub_parent(arg1);
        else
            ((MuQt_QMenu*)arg0)->keyReleaseEvent_pub(arg1);
    }

    void qt_QMenu_mouseDoubleClickEvent_void_QMenu_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QMenu*)arg0)->mouseDoubleClickEvent_pub_parent(arg1);
        else
            ((MuQt_QMenu*)arg0)->mouseDoubleClickEvent_pub(arg1);
    }

    void qt_QMenu_moveEvent_void_QMenu_QMoveEvent(Mu::Thread& NODE_THREAD,
                                                  Pointer param_this,
                                                  Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        QMoveEvent* arg1 = getqpointer<QMoveEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QMenu*)arg0)->moveEvent_pub_parent(arg1);
        else
            ((MuQt_QMenu*)arg0)->moveEvent_pub(arg1);
    }

    void qt_QMenu_resizeEvent_void_QMenu_QResizeEvent(Mu::Thread& NODE_THREAD,
                                                      Pointer param_this,
                                                      Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        QResizeEvent* arg1 = getqpointer<QResizeEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QMenu*)arg0)->resizeEvent_pub_parent(arg1);
        else
            ((MuQt_QMenu*)arg0)->resizeEvent_pub(arg1);
    }

    void qt_QMenu_showEvent_void_QMenu_QShowEvent(Mu::Thread& NODE_THREAD,
                                                  Pointer param_this,
                                                  Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        QShowEvent* arg1 = getqpointer<QShowEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QMenu*)arg0)->showEvent_pub_parent(arg1);
        else
            ((MuQt_QMenu*)arg0)->showEvent_pub(arg1);
    }

    void qt_QMenu_tabletEvent_void_QMenu_QTabletEvent(Mu::Thread& NODE_THREAD,
                                                      Pointer param_this,
                                                      Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        QTabletEvent* arg1 = getqpointer<QTabletEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QMenu*)arg0)->tabletEvent_pub_parent(arg1);
        else
            ((MuQt_QMenu*)arg0)->tabletEvent_pub(arg1);
    }

    int qt_QMenu_metric_int_QMenu_int(Mu::Thread& NODE_THREAD,
                                      Pointer param_this, int param_m)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QMenu* arg0 = object<QMenu>(param_this);
        QPaintDevice::PaintDeviceMetric arg1 =
            (QPaintDevice::PaintDeviceMetric)(param_m);
        return isMuQtObject(arg0) ? ((MuQt_QMenu*)arg0)->metric_pub_parent(arg1)
                                  : ((MuQt_QMenu*)arg0)->metric_pub(arg1);
    }

    Pointer qt_QMenu_menuInAction_QMenu_QAction(Mu::Thread& NODE_THREAD,
                                                Pointer param_action)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        const QAction* arg0 = object<QAction>(param_action);
        return makeinstance<QMenuType>(c, QMenu::menuInAction(arg0),
                                       "qt.QMenu");
    }

    static NODE_IMPLEMENTATION(_n_QMenu0, Pointer)
    {
        NODE_RETURN(qt_QMenu_QMenu_QMenu_QMenu_QWidget(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_QMenu1, Pointer)
    {
        NODE_RETURN(qt_QMenu_QMenu_QMenu_QMenu_string_QWidget(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_actionAt0, Pointer)
    {
        NODE_RETURN(qt_QMenu_actionAt_QAction_QMenu_QPoint(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_actionGeometry0, Pointer)
    {
        NODE_RETURN(qt_QMenu_actionGeometry_QRect_QMenu_QAction(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_activeAction0, Pointer)
    {
        NODE_RETURN(qt_QMenu_activeAction_QAction_QMenu(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_addMenu0, Pointer)
    {
        NODE_RETURN(qt_QMenu_addMenu_QAction_QMenu_QMenu(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_addMenu1, Pointer)
    {
        NODE_RETURN(qt_QMenu_addMenu_QMenu_QMenu_string(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_addMenu2, Pointer)
    {
        NODE_RETURN(qt_QMenu_addMenu_QMenu_QMenu_QIcon_string(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_addSection0, Pointer)
    {
        NODE_RETURN(qt_QMenu_addSection_QAction_QMenu_string(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_addSection1, Pointer)
    {
        NODE_RETURN(qt_QMenu_addSection_QAction_QMenu_QIcon_string(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_addSeparator0, Pointer)
    {
        NODE_RETURN(qt_QMenu_addSeparator_QAction_QMenu(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_clear0, void)
    {
        qt_QMenu_clear_void_QMenu(NODE_THREAD, NONNIL_NODE_ARG(0, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_defaultAction0, Pointer)
    {
        NODE_RETURN(qt_QMenu_defaultAction_QAction_QMenu(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_exec0, Pointer)
    {
        NODE_RETURN(qt_QMenu_exec_QAction_QMenu(NODE_THREAD,
                                                NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_exec1, Pointer)
    {
        NODE_RETURN(qt_QMenu_exec_QAction_QMenu_QPoint_QAction(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_hideTearOffMenu0, void)
    {
        qt_QMenu_hideTearOffMenu_void_QMenu(NODE_THREAD,
                                            NONNIL_NODE_ARG(0, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_insertMenu0, Pointer)
    {
        NODE_RETURN(qt_QMenu_insertMenu_QAction_QMenu_QAction_QMenu(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_insertSection0, Pointer)
    {
        NODE_RETURN(qt_QMenu_insertSection_QAction_QMenu_QAction_string(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_insertSection1, Pointer)
    {
        NODE_RETURN(qt_QMenu_insertSection_QAction_QMenu_QAction_QIcon_string(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, Pointer), NODE_ARG(3, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_insertSeparator0, Pointer)
    {
        NODE_RETURN(qt_QMenu_insertSeparator_QAction_QMenu_QAction(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_isEmpty0, bool)
    {
        NODE_RETURN(qt_QMenu_isEmpty_bool_QMenu(NODE_THREAD,
                                                NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_isTearOffMenuVisible0, bool)
    {
        NODE_RETURN(qt_QMenu_isTearOffMenuVisible_bool_QMenu(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_menuAction0, Pointer)
    {
        NODE_RETURN(qt_QMenu_menuAction_QAction_QMenu(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_popup0, void)
    {
        qt_QMenu_popup_void_QMenu_QPoint_QAction(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_setActiveAction0, void)
    {
        qt_QMenu_setActiveAction_void_QMenu_QAction(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_setDefaultAction0, void)
    {
        qt_QMenu_setDefaultAction_void_QMenu_QAction(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_showTearOffMenu0, void)
    {
        qt_QMenu_showTearOffMenu_void_QMenu_QPoint(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_showTearOffMenu1, void)
    {
        qt_QMenu_showTearOffMenu_void_QMenu(NODE_THREAD,
                                            NONNIL_NODE_ARG(0, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_sizeHint0, Pointer)
    {
        NODE_RETURN(qt_QMenu_sizeHint_QSize_QMenu(NODE_THREAD,
                                                  NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_columnCount0, int)
    {
        NODE_RETURN(qt_QMenu_columnCount_int_QMenu(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_changeEvent0, void)
    {
        qt_QMenu_changeEvent_void_QMenu_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_event0, bool)
    {
        NODE_RETURN(qt_QMenu_event_bool_QMenu_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_focusNextPrevChild0, bool)
    {
        NODE_RETURN(qt_QMenu_focusNextPrevChild_bool_QMenu_bool(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, bool)));
    }

    static NODE_IMPLEMENTATION(_n_hideEvent0, void)
    {
        qt_QMenu_hideEvent_void_QMenu_QHideEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_keyPressEvent0, void)
    {
        qt_QMenu_keyPressEvent_void_QMenu_QKeyEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_leaveEvent0, void)
    {
        qt_QMenu_leaveEvent_void_QMenu_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mouseMoveEvent0, void)
    {
        qt_QMenu_mouseMoveEvent_void_QMenu_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mousePressEvent0, void)
    {
        qt_QMenu_mousePressEvent_void_QMenu_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mouseReleaseEvent0, void)
    {
        qt_QMenu_mouseReleaseEvent_void_QMenu_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_paintEvent0, void)
    {
        qt_QMenu_paintEvent_void_QMenu_QPaintEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_timerEvent0, void)
    {
        qt_QMenu_timerEvent_void_QMenu_QTimerEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_wheelEvent0, void)
    {
        qt_QMenu_wheelEvent_void_QMenu_QWheelEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_hasHeightForWidth0, bool)
    {
        NODE_RETURN(qt_QMenu_hasHeightForWidth_bool_QMenu(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_heightForWidth0, int)
    {
        NODE_RETURN(qt_QMenu_heightForWidth_int_QMenu_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_inputMethodQuery0, Pointer)
    {
        NODE_RETURN(qt_QMenu_inputMethodQuery_QVariant_QMenu_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_minimumSizeHint0, Pointer)
    {
        NODE_RETURN(qt_QMenu_minimumSizeHint_QSize_QMenu(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_closeEvent0, void)
    {
        qt_QMenu_closeEvent_void_QMenu_QCloseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_contextMenuEvent0, void)
    {
        qt_QMenu_contextMenuEvent_void_QMenu_QContextMenuEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dragEnterEvent0, void)
    {
        qt_QMenu_dragEnterEvent_void_QMenu_QDragEnterEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dragLeaveEvent0, void)
    {
        qt_QMenu_dragLeaveEvent_void_QMenu_QDragLeaveEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dragMoveEvent0, void)
    {
        qt_QMenu_dragMoveEvent_void_QMenu_QDragMoveEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dropEvent0, void)
    {
        qt_QMenu_dropEvent_void_QMenu_QDropEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_focusInEvent0, void)
    {
        qt_QMenu_focusInEvent_void_QMenu_QFocusEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_focusOutEvent0, void)
    {
        qt_QMenu_focusOutEvent_void_QMenu_QFocusEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_keyReleaseEvent0, void)
    {
        qt_QMenu_keyReleaseEvent_void_QMenu_QKeyEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mouseDoubleClickEvent0, void)
    {
        qt_QMenu_mouseDoubleClickEvent_void_QMenu_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_moveEvent0, void)
    {
        qt_QMenu_moveEvent_void_QMenu_QMoveEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_resizeEvent0, void)
    {
        qt_QMenu_resizeEvent_void_QMenu_QResizeEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_showEvent0, void)
    {
        qt_QMenu_showEvent_void_QMenu_QShowEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_tabletEvent0, void)
    {
        qt_QMenu_tabletEvent_void_QMenu_QTabletEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_metric0, int)
    {
        NODE_RETURN(qt_QMenu_metric_int_QMenu_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_menuInAction0, Pointer)
    {
        NODE_RETURN(qt_QMenu_menuInAction_QMenu_QAction(NODE_THREAD,
                                                        NODE_ARG(0, Pointer)));
    }

    void QMenuType::load()
    {
        USING_MU_FUNCTION_SYMBOLS;
        MuLangContext* c = static_cast<MuLangContext*>(context());
        Module* global = globalModule();

        const string typeName = name();
        const string refTypeName = typeName + "&";
        const string fullTypeName = fullyQualifiedName();
        const string fullRefTypeName = fullTypeName + "&";
        const char* tn = typeName.c_str();
        const char* ftn = fullTypeName.c_str();
        const char* rtn = refTypeName.c_str();
        const char* frtn = fullRefTypeName.c_str();

        scope()->addSymbols(new ReferenceType(c, rtn, this),

                            new Function(c, tn, BaseFunctions::dereference,
                                         Cast, Return, ftn, Args, frtn, End),

                            EndArguments);

        addSymbols(new Function(c, "__allocate", BaseFunctions::classAllocate,
                                None, Return, ftn, End),

                   new Function(c, tn, castFromObject, Cast, Compiled,
                                QMenu_QMenu_QObject, Return, ftn, Parameters,
                                new Param(c, "object", "qt.QObject"), End),

                   EndArguments);

        addSymbols(
            // enums
            // member functions
            new Function(c, "QMenu", _n_QMenu0, None, Compiled,
                         qt_QMenu_QMenu_QMenu_QMenu_QWidget, Return, "qt.QMenu",
                         Parameters, new Param(c, "this", "qt.QMenu"),
                         new Param(c, "parent", "qt.QWidget"), End),
            new Function(c, "QMenu", _n_QMenu1, None, Compiled,
                         qt_QMenu_QMenu_QMenu_QMenu_string_QWidget, Return,
                         "qt.QMenu", Parameters,
                         new Param(c, "this", "qt.QMenu"),
                         new Param(c, "title", "string"),
                         new Param(c, "parent", "qt.QWidget"), End),
            new Function(c, "actionAt", _n_actionAt0, None, Compiled,
                         qt_QMenu_actionAt_QAction_QMenu_QPoint, Return,
                         "qt.QAction", Parameters,
                         new Param(c, "this", "qt.QMenu"),
                         new Param(c, "pt", "qt.QPoint"), End),
            new Function(c, "actionGeometry", _n_actionGeometry0, None,
                         Compiled, qt_QMenu_actionGeometry_QRect_QMenu_QAction,
                         Return, "qt.QRect", Parameters,
                         new Param(c, "this", "qt.QMenu"),
                         new Param(c, "act", "qt.QAction"), End),
            new Function(c, "activeAction", _n_activeAction0, None, Compiled,
                         qt_QMenu_activeAction_QAction_QMenu, Return,
                         "qt.QAction", Parameters,
                         new Param(c, "this", "qt.QMenu"), End),
            new Function(c, "addMenu", _n_addMenu0, None, Compiled,
                         qt_QMenu_addMenu_QAction_QMenu_QMenu, Return,
                         "qt.QAction", Parameters,
                         new Param(c, "this", "qt.QMenu"),
                         new Param(c, "menu", "qt.QMenu"), End),
            new Function(c, "addMenu", _n_addMenu1, None, Compiled,
                         qt_QMenu_addMenu_QMenu_QMenu_string, Return,
                         "qt.QMenu", Parameters,
                         new Param(c, "this", "qt.QMenu"),
                         new Param(c, "title", "string"), End),
            new Function(c, "addMenu", _n_addMenu2, None, Compiled,
                         qt_QMenu_addMenu_QMenu_QMenu_QIcon_string, Return,
                         "qt.QMenu", Parameters,
                         new Param(c, "this", "qt.QMenu"),
                         new Param(c, "icon", "qt.QIcon"),
                         new Param(c, "title", "string"), End),
            new Function(c, "addSection", _n_addSection0, None, Compiled,
                         qt_QMenu_addSection_QAction_QMenu_string, Return,
                         "qt.QAction", Parameters,
                         new Param(c, "this", "qt.QMenu"),
                         new Param(c, "text", "string"), End),
            new Function(c, "addSection", _n_addSection1, None, Compiled,
                         qt_QMenu_addSection_QAction_QMenu_QIcon_string, Return,
                         "qt.QAction", Parameters,
                         new Param(c, "this", "qt.QMenu"),
                         new Param(c, "icon", "qt.QIcon"),
                         new Param(c, "text", "string"), End),
            new Function(c, "addSeparator", _n_addSeparator0, None, Compiled,
                         qt_QMenu_addSeparator_QAction_QMenu, Return,
                         "qt.QAction", Parameters,
                         new Param(c, "this", "qt.QMenu"), End),
            new Function(c, "clear", _n_clear0, None, Compiled,
                         qt_QMenu_clear_void_QMenu, Return, "void", Parameters,
                         new Param(c, "this", "qt.QMenu"), End),
            new Function(c, "defaultAction", _n_defaultAction0, None, Compiled,
                         qt_QMenu_defaultAction_QAction_QMenu, Return,
                         "qt.QAction", Parameters,
                         new Param(c, "this", "qt.QMenu"), End),
            new Function(c, "exec", _n_exec0, None, Compiled,
                         qt_QMenu_exec_QAction_QMenu, Return, "qt.QAction",
                         Parameters, new Param(c, "this", "qt.QMenu"), End),
            new Function(c, "exec", _n_exec1, None, Compiled,
                         qt_QMenu_exec_QAction_QMenu_QPoint_QAction, Return,
                         "qt.QAction", Parameters,
                         new Param(c, "this", "qt.QMenu"),
                         new Param(c, "p", "qt.QPoint"),
                         new Param(c, "action", "qt.QAction"), End),
            new Function(c, "hideTearOffMenu", _n_hideTearOffMenu0, None,
                         Compiled, qt_QMenu_hideTearOffMenu_void_QMenu, Return,
                         "void", Parameters, new Param(c, "this", "qt.QMenu"),
                         End),
            // PROP: icon (QIcon; QMenu this)
            new Function(c, "insertMenu", _n_insertMenu0, None, Compiled,
                         qt_QMenu_insertMenu_QAction_QMenu_QAction_QMenu,
                         Return, "qt.QAction", Parameters,
                         new Param(c, "this", "qt.QMenu"),
                         new Param(c, "before", "qt.QAction"),
                         new Param(c, "menu", "qt.QMenu"), End),
            new Function(c, "insertSection", _n_insertSection0, None, Compiled,
                         qt_QMenu_insertSection_QAction_QMenu_QAction_string,
                         Return, "qt.QAction", Parameters,
                         new Param(c, "this", "qt.QMenu"),
                         new Param(c, "before", "qt.QAction"),
                         new Param(c, "text", "string"), End),
            new Function(
                c, "insertSection", _n_insertSection1, None, Compiled,
                qt_QMenu_insertSection_QAction_QMenu_QAction_QIcon_string,
                Return, "qt.QAction", Parameters,
                new Param(c, "this", "qt.QMenu"),
                new Param(c, "before", "qt.QAction"),
                new Param(c, "icon", "qt.QIcon"),
                new Param(c, "text", "string"), End),
            new Function(
                c, "insertSeparator", _n_insertSeparator0, None, Compiled,
                qt_QMenu_insertSeparator_QAction_QMenu_QAction, Return,
                "qt.QAction", Parameters, new Param(c, "this", "qt.QMenu"),
                new Param(c, "before", "qt.QAction"), End),
            new Function(c, "isEmpty", _n_isEmpty0, None, Compiled,
                         qt_QMenu_isEmpty_bool_QMenu, Return, "bool",
                         Parameters, new Param(c, "this", "qt.QMenu"), End),
            // PROP: isTearOffEnabled (bool; QMenu this)
            new Function(
                c, "isTearOffMenuVisible", _n_isTearOffMenuVisible0, None,
                Compiled, qt_QMenu_isTearOffMenuVisible_bool_QMenu, Return,
                "bool", Parameters, new Param(c, "this", "qt.QMenu"), End),
            new Function(c, "menuAction", _n_menuAction0, None, Compiled,
                         qt_QMenu_menuAction_QAction_QMenu, Return,
                         "qt.QAction", Parameters,
                         new Param(c, "this", "qt.QMenu"), End),
            new Function(c, "popup", _n_popup0, None, Compiled,
                         qt_QMenu_popup_void_QMenu_QPoint_QAction, Return,
                         "void", Parameters, new Param(c, "this", "qt.QMenu"),
                         new Param(c, "p", "qt.QPoint"),
                         new Param(c, "atAction", "qt.QAction"), End),
            // PROP: separatorsCollapsible (bool; QMenu this)
            new Function(c, "setActiveAction", _n_setActiveAction0, None,
                         Compiled, qt_QMenu_setActiveAction_void_QMenu_QAction,
                         Return, "void", Parameters,
                         new Param(c, "this", "qt.QMenu"),
                         new Param(c, "act", "qt.QAction"), End),
            new Function(c, "setDefaultAction", _n_setDefaultAction0, None,
                         Compiled, qt_QMenu_setDefaultAction_void_QMenu_QAction,
                         Return, "void", Parameters,
                         new Param(c, "this", "qt.QMenu"),
                         new Param(c, "act", "qt.QAction"), End),
            // PROP: setIcon (void; QMenu this, QIcon icon)
            // PROP: setSeparatorsCollapsible (void; QMenu this, bool collapse)
            // PROP: setTearOffEnabled (void; QMenu this, bool _p4)
            // PROP: setTitle (void; QMenu this, string title)
            // PROP: setToolTipsVisible (void; QMenu this, bool visible)
            new Function(c, "showTearOffMenu", _n_showTearOffMenu0, None,
                         Compiled, qt_QMenu_showTearOffMenu_void_QMenu_QPoint,
                         Return, "void", Parameters,
                         new Param(c, "this", "qt.QMenu"),
                         new Param(c, "pos", "qt.QPoint"), End),
            new Function(c, "showTearOffMenu", _n_showTearOffMenu1, None,
                         Compiled, qt_QMenu_showTearOffMenu_void_QMenu, Return,
                         "void", Parameters, new Param(c, "this", "qt.QMenu"),
                         End),
            // PROP: title (string; QMenu this)
            // MISSING: toNSMenu ("NSMenu *"; QMenu this)
            // PROP: toolTipsVisible (bool; QMenu this)
            _func[0] = new MemberFunction(
                c, "sizeHint", _n_sizeHint0, None, Compiled,
                qt_QMenu_sizeHint_QSize_QMenu, Return, "qt.QSize", Parameters,
                new Param(c, "this", "qt.QMenu"), End),
            new Function(c, "columnCount", _n_columnCount0, None, Compiled,
                         qt_QMenu_columnCount_int_QMenu, Return, "int",
                         Parameters, new Param(c, "this", "qt.QMenu"), End),
            // MISSING: initStyleOption (void; QMenu this, "QStyleOptionMenuItem
            // *" option, QAction action) // protected MISSING: actionEvent
            // (void; QMenu this, "QActionEvent *" e) // protected
            _func[1] = new MemberFunction(
                c, "changeEvent", _n_changeEvent0, None, Compiled,
                qt_QMenu_changeEvent_void_QMenu_QEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QMenu"),
                new Param(c, "e", "qt.QEvent"), End),
            // MISSING: enterEvent (void; QMenu this, "QEnterEvent *" _p14) //
            // protected
            _func[2] = new MemberFunction(c, "event", _n_event0, None, Compiled,
                                          qt_QMenu_event_bool_QMenu_QEvent,
                                          Return, "bool", Parameters,
                                          new Param(c, "this", "qt.QMenu"),
                                          new Param(c, "e", "qt.QEvent"), End),
            _func[3] = new MemberFunction(
                c, "focusNextPrevChild", _n_focusNextPrevChild0, None, Compiled,
                qt_QMenu_focusNextPrevChild_bool_QMenu_bool, Return, "bool",
                Parameters, new Param(c, "this", "qt.QMenu"),
                new Param(c, "next", "bool"), End),
            _func[4] = new MemberFunction(
                c, "hideEvent", _n_hideEvent0, None, Compiled,
                qt_QMenu_hideEvent_void_QMenu_QHideEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QMenu"),
                new Param(c, "_p13", "qt.QHideEvent"), End),
            _func[5] = new MemberFunction(
                c, "keyPressEvent", _n_keyPressEvent0, None, Compiled,
                qt_QMenu_keyPressEvent_void_QMenu_QKeyEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QMenu"),
                new Param(c, "e", "qt.QKeyEvent"), End),
            _func[6] = new MemberFunction(
                c, "leaveEvent", _n_leaveEvent0, None, Compiled,
                qt_QMenu_leaveEvent_void_QMenu_QEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QMenu"),
                new Param(c, "_p9", "qt.QEvent"), End),
            _func[7] = new MemberFunction(
                c, "mouseMoveEvent", _n_mouseMoveEvent0, None, Compiled,
                qt_QMenu_mouseMoveEvent_void_QMenu_QMouseEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QMenu"),
                new Param(c, "e", "qt.QMouseEvent"), End),
            _func[8] = new MemberFunction(
                c, "mousePressEvent", _n_mousePressEvent0, None, Compiled,
                qt_QMenu_mousePressEvent_void_QMenu_QMouseEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QMenu"),
                new Param(c, "e", "qt.QMouseEvent"), End),
            _func[9] = new MemberFunction(
                c, "mouseReleaseEvent", _n_mouseReleaseEvent0, None, Compiled,
                qt_QMenu_mouseReleaseEvent_void_QMenu_QMouseEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QMenu"),
                new Param(c, "e", "qt.QMouseEvent"), End),
            _func[10] = new MemberFunction(
                c, "paintEvent", _n_paintEvent0, None, Compiled,
                qt_QMenu_paintEvent_void_QMenu_QPaintEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QMenu"),
                new Param(c, "e", "qt.QPaintEvent"), End),
            _func[11] = new MemberFunction(
                c, "timerEvent", _n_timerEvent0, None, Compiled,
                qt_QMenu_timerEvent_void_QMenu_QTimerEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QMenu"),
                new Param(c, "e", "qt.QTimerEvent"), End),
            _func[12] = new MemberFunction(
                c, "wheelEvent", _n_wheelEvent0, None, Compiled,
                qt_QMenu_wheelEvent_void_QMenu_QWheelEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QMenu"),
                new Param(c, "e", "qt.QWheelEvent"), End),
            _func[13] = new MemberFunction(
                c, "hasHeightForWidth", _n_hasHeightForWidth0, None, Compiled,
                qt_QMenu_hasHeightForWidth_bool_QMenu, Return, "bool",
                Parameters, new Param(c, "this", "qt.QMenu"), End),
            _func[14] = new MemberFunction(
                c, "heightForWidth", _n_heightForWidth0, None, Compiled,
                qt_QMenu_heightForWidth_int_QMenu_int, Return, "int",
                Parameters, new Param(c, "this", "qt.QMenu"),
                new Param(c, "w", "int"), End),
            _func[15] = new MemberFunction(
                c, "inputMethodQuery", _n_inputMethodQuery0, None, Compiled,
                qt_QMenu_inputMethodQuery_QVariant_QMenu_int, Return,
                "qt.QVariant", Parameters, new Param(c, "this", "qt.QMenu"),
                new Param(c, "query", "int"), End),
            _func[16] = new MemberFunction(
                c, "minimumSizeHint", _n_minimumSizeHint0, None, Compiled,
                qt_QMenu_minimumSizeHint_QSize_QMenu, Return, "qt.QSize",
                Parameters, new Param(c, "this", "qt.QMenu"), End),
            // MISSING: paintEngine ("QPaintEngine *"; QMenu this)
            _func[17] = new MemberFunction(
                c, "closeEvent", _n_closeEvent0, None, Compiled,
                qt_QMenu_closeEvent_void_QMenu_QCloseEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QMenu"),
                new Param(c, "event", "qt.QCloseEvent"), End),
            _func[18] = new MemberFunction(
                c, "contextMenuEvent", _n_contextMenuEvent0, None, Compiled,
                qt_QMenu_contextMenuEvent_void_QMenu_QContextMenuEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QMenu"),
                new Param(c, "event", "qt.QContextMenuEvent"), End),
            _func[19] = new MemberFunction(
                c, "dragEnterEvent", _n_dragEnterEvent0, None, Compiled,
                qt_QMenu_dragEnterEvent_void_QMenu_QDragEnterEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QMenu"),
                new Param(c, "event", "qt.QDragEnterEvent"), End),
            _func[20] = new MemberFunction(
                c, "dragLeaveEvent", _n_dragLeaveEvent0, None, Compiled,
                qt_QMenu_dragLeaveEvent_void_QMenu_QDragLeaveEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QMenu"),
                new Param(c, "event", "qt.QDragLeaveEvent"), End),
            _func[21] = new MemberFunction(
                c, "dragMoveEvent", _n_dragMoveEvent0, None, Compiled,
                qt_QMenu_dragMoveEvent_void_QMenu_QDragMoveEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QMenu"),
                new Param(c, "event", "qt.QDragMoveEvent"), End),
            _func[22] = new MemberFunction(
                c, "dropEvent", _n_dropEvent0, None, Compiled,
                qt_QMenu_dropEvent_void_QMenu_QDropEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QMenu"),
                new Param(c, "event", "qt.QDropEvent"), End),
            _func[23] = new MemberFunction(
                c, "focusInEvent", _n_focusInEvent0, None, Compiled,
                qt_QMenu_focusInEvent_void_QMenu_QFocusEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QMenu"),
                new Param(c, "event", "qt.QFocusEvent"), End),
            _func[24] = new MemberFunction(
                c, "focusOutEvent", _n_focusOutEvent0, None, Compiled,
                qt_QMenu_focusOutEvent_void_QMenu_QFocusEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QMenu"),
                new Param(c, "event", "qt.QFocusEvent"), End),
            // MISSING: inputMethodEvent (void; QMenu this, "QInputMethodEvent
            // *" event) // protected
            _func[25] = new MemberFunction(
                c, "keyReleaseEvent", _n_keyReleaseEvent0, None, Compiled,
                qt_QMenu_keyReleaseEvent_void_QMenu_QKeyEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QMenu"),
                new Param(c, "event", "qt.QKeyEvent"), End),
            _func[26] = new MemberFunction(
                c, "mouseDoubleClickEvent", _n_mouseDoubleClickEvent0, None,
                Compiled, qt_QMenu_mouseDoubleClickEvent_void_QMenu_QMouseEvent,
                Return, "void", Parameters, new Param(c, "this", "qt.QMenu"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[27] = new MemberFunction(
                c, "moveEvent", _n_moveEvent0, None, Compiled,
                qt_QMenu_moveEvent_void_QMenu_QMoveEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QMenu"),
                new Param(c, "event", "qt.QMoveEvent"), End),
            // MISSING: nativeEvent (bool; QMenu this, QByteArray eventType,
            // "void *" message, "qintptr *" result) // protected
            _func[28] = new MemberFunction(
                c, "resizeEvent", _n_resizeEvent0, None, Compiled,
                qt_QMenu_resizeEvent_void_QMenu_QResizeEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QMenu"),
                new Param(c, "event", "qt.QResizeEvent"), End),
            _func[29] = new MemberFunction(
                c, "showEvent", _n_showEvent0, None, Compiled,
                qt_QMenu_showEvent_void_QMenu_QShowEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QMenu"),
                new Param(c, "event", "qt.QShowEvent"), End),
            _func[30] = new MemberFunction(
                c, "tabletEvent", _n_tabletEvent0, None, Compiled,
                qt_QMenu_tabletEvent_void_QMenu_QTabletEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QMenu"),
                new Param(c, "event", "qt.QTabletEvent"), End),
            // MISSING: initPainter (void; QMenu this, "QPainter *" painter) //
            // protected
            _func[31] =
                new MemberFunction(c, "metric", _n_metric0, None, Compiled,
                                   qt_QMenu_metric_int_QMenu_int, Return, "int",
                                   Parameters, new Param(c, "this", "qt.QMenu"),
                                   new Param(c, "m", "int"), End),
            // static functions
            // MISSING: exec (QAction; "const QList<QAction * > &" actions,
            // QPoint pos, QAction at, QWidget parent)
            new Function(c, "menuInAction", _n_menuInAction0, None, Compiled,
                         qt_QMenu_menuInAction_QMenu_QAction, Return,
                         "qt.QMenu", Parameters,
                         new Param(c, "action", "qt.QAction"), End),
            EndArguments);
        globalScope()->addSymbols(EndArguments);
        scope()->addSymbols(EndArguments);

        const char** propExclusions = 0;

        populate(this, QMenu::staticMetaObject, propExclusions);
    }

} // namespace Mu
