//*****************************************************************************
// Copyright (c) 2024 Autodesk, Inc.
// All rights reserved.
//
// SPDX-License-Identifier: Apache-2.0
//
//*****************************************************************************

// IMPORTANT: This file (not the template) is auto-generated by qt2mu.py script.
//            The prefered way to do a fix is to handrolled it or modify the
//            qt2mu.py script. If it is not possible, manual editing is ok but
//            it could be lost in future generations.

#include <MuQt6/qtUtils.h>
#include <MuQt6/QSvgWidgetType.h>
#include <QtGui/QtGui>
#include <QtWidgets/QtWidgets>
#include <QtSvg/QtSvg>
#include <QSvgWidget>
#include <QtNetwork/QtNetwork>
#include <MuQt6/QWidgetType.h>
#include <MuQt6/QActionType.h>
#include <MuQt6/QIconType.h>
#include <Mu/BaseFunctions.h>
#include <Mu/Thread.h>
#include <Mu/Alias.h>
#include <Mu/SymbolicConstant.h>
#include <Mu/ClassInstance.h>
#include <Mu/Function.h>
#include <Mu/MemberFunction.h>
#include <Mu/MemberVariable.h>
#include <Mu/Node.h>
#include <Mu/Exception.h>
#include <Mu/ParameterVariable.h>
#include <Mu/ReferenceType.h>
#include <Mu/Value.h>
#include <MuLang/MuLangContext.h>
#include <MuLang/StringType.h>
#include <MuQt6/QSizeType.h>
#include <MuQt6/QDropEventType.h>
#include <MuQt6/QKeyEventType.h>
#include <MuQt6/QEventType.h>
#include <MuQt6/QMouseEventType.h>
#include <MuQt6/QCloseEventType.h>
#include <MuQt6/QTabletEventType.h>
#include <MuQt6/QDragMoveEventType.h>
#include <MuQt6/QShowEventType.h>
#include <MuQt6/QContextMenuEventType.h>
#include <MuQt6/QDragLeaveEventType.h>
#include <MuQt6/QFocusEventType.h>
#include <MuQt6/QMoveEventType.h>
#include <MuQt6/QResizeEventType.h>
#include <MuQt6/QWheelEventType.h>
#include <MuQt6/QVariantType.h>
#include <MuQt6/QPaintEventType.h>
#include <MuQt6/QDragEnterEventType.h>
#include <MuQt6/QHideEventType.h>

namespace Mu
{
    using namespace std;

    //----------------------------------------------------------------------
    //  INHERITABLE TYPE IMPLEMENTATION

    // destructor
    MuQt_QSvgWidget::~MuQt_QSvgWidget()
    {
        if (_obj)
        {
            *_obj->data<Pointer>() = Pointer(0);
            _obj->releaseExternal();
        }
        _obj = 0;
        _env = 0;
        _baseType = 0;
    }

    MuQt_QSvgWidget::MuQt_QSvgWidget(Pointer muobj, const CallEnvironment* ce,
                                     QWidget* parent)
        : QSvgWidget(parent)
    {
        _env = ce;
        _obj = reinterpret_cast<ClassInstance*>(muobj);
        _obj->retainExternal();
        MuLangContext* c = (MuLangContext*)_env->context();
        _baseType = c->findSymbolOfTypeByQualifiedName<QSvgWidgetType>(
            c->internName("qt.QSvgWidget"));
    }

    MuQt_QSvgWidget::MuQt_QSvgWidget(Pointer muobj, const CallEnvironment* ce,
                                     const QString& file, QWidget* parent)
        : QSvgWidget(file, parent)
    {
        _env = ce;
        _obj = reinterpret_cast<ClassInstance*>(muobj);
        _obj->retainExternal();
        MuLangContext* c = (MuLangContext*)_env->context();
        _baseType = c->findSymbolOfTypeByQualifiedName<QSvgWidgetType>(
            c->internName("qt.QSvgWidget"));
    }

    QSize MuQt_QSvgWidget::sizeHint() const
    {
        if (!_env)
            return QSvgWidget::sizeHint();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[0];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return getqtype<QSizeType>(rval._Pointer);
        }
        else
        {
            return QSvgWidget::sizeHint();
        }
    }

    void MuQt_QSvgWidget::paintEvent(QPaintEvent* event)
    {
        if (!_env)
        {
            QSvgWidget::paintEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[1];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QPaintEventType>(c, event, "qt.QPaintEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QSvgWidget::paintEvent(event);
        }
    }

    bool MuQt_QSvgWidget::hasHeightForWidth() const
    {
        if (!_env)
            return QSvgWidget::hasHeightForWidth();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[2];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QSvgWidget::hasHeightForWidth();
        }
    }

    int MuQt_QSvgWidget::heightForWidth(int w) const
    {
        if (!_env)
            return QSvgWidget::heightForWidth(w);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[3];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(w);
            Value rval = _env->call(F, args);
            return (int)(rval._int);
        }
        else
        {
            return QSvgWidget::heightForWidth(w);
        }
    }

    QVariant MuQt_QSvgWidget::inputMethodQuery(Qt::InputMethodQuery query) const
    {
        if (!_env)
            return QSvgWidget::inputMethodQuery(query);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[4];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(int(query));
            Value rval = _env->call(F, args);
            return getqtype<QVariantType>(rval._Pointer);
        }
        else
        {
            return QSvgWidget::inputMethodQuery(query);
        }
    }

    QSize MuQt_QSvgWidget::minimumSizeHint() const
    {
        if (!_env)
            return QSvgWidget::minimumSizeHint();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[5];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return getqtype<QSizeType>(rval._Pointer);
        }
        else
        {
            return QSvgWidget::minimumSizeHint();
        }
    }

    void MuQt_QSvgWidget::changeEvent(QEvent* event)
    {
        if (!_env)
        {
            QSvgWidget::changeEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[6];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, event, "qt.QEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QSvgWidget::changeEvent(event);
        }
    }

    void MuQt_QSvgWidget::closeEvent(QCloseEvent* event)
    {
        if (!_env)
        {
            QSvgWidget::closeEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[7];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QCloseEventType>(c, event, "qt.QCloseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QSvgWidget::closeEvent(event);
        }
    }

    void MuQt_QSvgWidget::contextMenuEvent(QContextMenuEvent* event)
    {
        if (!_env)
        {
            QSvgWidget::contextMenuEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[8];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QContextMenuEventType>(
                c, event, "qt.QContextMenuEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QSvgWidget::contextMenuEvent(event);
        }
    }

    void MuQt_QSvgWidget::dragEnterEvent(QDragEnterEvent* event)
    {
        if (!_env)
        {
            QSvgWidget::dragEnterEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[9];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QDragEnterEventType>(
                c, event, "qt.QDragEnterEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QSvgWidget::dragEnterEvent(event);
        }
    }

    void MuQt_QSvgWidget::dragLeaveEvent(QDragLeaveEvent* event)
    {
        if (!_env)
        {
            QSvgWidget::dragLeaveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[10];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QDragLeaveEventType>(
                c, event, "qt.QDragLeaveEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QSvgWidget::dragLeaveEvent(event);
        }
    }

    void MuQt_QSvgWidget::dragMoveEvent(QDragMoveEvent* event)
    {
        if (!_env)
        {
            QSvgWidget::dragMoveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[11];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QDragMoveEventType>(
                c, event, "qt.QDragMoveEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QSvgWidget::dragMoveEvent(event);
        }
    }

    void MuQt_QSvgWidget::dropEvent(QDropEvent* event)
    {
        if (!_env)
        {
            QSvgWidget::dropEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[12];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QDropEventType>(c, event, "qt.QDropEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QSvgWidget::dropEvent(event);
        }
    }

    void MuQt_QSvgWidget::focusInEvent(QFocusEvent* event)
    {
        if (!_env)
        {
            QSvgWidget::focusInEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[13];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QFocusEventType>(c, event, "qt.QFocusEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QSvgWidget::focusInEvent(event);
        }
    }

    bool MuQt_QSvgWidget::focusNextPrevChild(bool next)
    {
        if (!_env)
            return QSvgWidget::focusNextPrevChild(next);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[14];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(next);
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QSvgWidget::focusNextPrevChild(next);
        }
    }

    void MuQt_QSvgWidget::focusOutEvent(QFocusEvent* event)
    {
        if (!_env)
        {
            QSvgWidget::focusOutEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[15];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QFocusEventType>(c, event, "qt.QFocusEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QSvgWidget::focusOutEvent(event);
        }
    }

    void MuQt_QSvgWidget::hideEvent(QHideEvent* event)
    {
        if (!_env)
        {
            QSvgWidget::hideEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[16];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QHideEventType>(c, event, "qt.QHideEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QSvgWidget::hideEvent(event);
        }
    }

    void MuQt_QSvgWidget::keyPressEvent(QKeyEvent* event)
    {
        if (!_env)
        {
            QSvgWidget::keyPressEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[17];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QKeyEventType>(c, event, "qt.QKeyEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QSvgWidget::keyPressEvent(event);
        }
    }

    void MuQt_QSvgWidget::keyReleaseEvent(QKeyEvent* event)
    {
        if (!_env)
        {
            QSvgWidget::keyReleaseEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[18];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QKeyEventType>(c, event, "qt.QKeyEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QSvgWidget::keyReleaseEvent(event);
        }
    }

    void MuQt_QSvgWidget::leaveEvent(QEvent* event)
    {
        if (!_env)
        {
            QSvgWidget::leaveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[19];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, event, "qt.QEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QSvgWidget::leaveEvent(event);
        }
    }

    void MuQt_QSvgWidget::mouseDoubleClickEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QSvgWidget::mouseDoubleClickEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[20];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QSvgWidget::mouseDoubleClickEvent(event);
        }
    }

    void MuQt_QSvgWidget::mouseMoveEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QSvgWidget::mouseMoveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[21];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QSvgWidget::mouseMoveEvent(event);
        }
    }

    void MuQt_QSvgWidget::mousePressEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QSvgWidget::mousePressEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[22];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QSvgWidget::mousePressEvent(event);
        }
    }

    void MuQt_QSvgWidget::mouseReleaseEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QSvgWidget::mouseReleaseEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[23];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QSvgWidget::mouseReleaseEvent(event);
        }
    }

    void MuQt_QSvgWidget::moveEvent(QMoveEvent* event)
    {
        if (!_env)
        {
            QSvgWidget::moveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[24];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QMoveEventType>(c, event, "qt.QMoveEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QSvgWidget::moveEvent(event);
        }
    }

    void MuQt_QSvgWidget::resizeEvent(QResizeEvent* event)
    {
        if (!_env)
        {
            QSvgWidget::resizeEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[25];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QResizeEventType>(c, event, "qt.QResizeEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QSvgWidget::resizeEvent(event);
        }
    }

    void MuQt_QSvgWidget::showEvent(QShowEvent* event)
    {
        if (!_env)
        {
            QSvgWidget::showEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[26];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QShowEventType>(c, event, "qt.QShowEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QSvgWidget::showEvent(event);
        }
    }

    void MuQt_QSvgWidget::tabletEvent(QTabletEvent* event)
    {
        if (!_env)
        {
            QSvgWidget::tabletEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[27];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QTabletEventType>(c, event, "qt.QTabletEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QSvgWidget::tabletEvent(event);
        }
    }

    void MuQt_QSvgWidget::wheelEvent(QWheelEvent* event)
    {
        if (!_env)
        {
            QSvgWidget::wheelEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[28];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QWheelEventType>(c, event, "qt.QWheelEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QSvgWidget::wheelEvent(event);
        }
    }

    bool MuQt_QSvgWidget::event(QEvent* event_)
    {
        if (!_env)
            return QSvgWidget::event(event_);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[29];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, event_, "qt.QEvent"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QSvgWidget::event(event_);
        }
    }

    int MuQt_QSvgWidget::metric(QPaintDevice::PaintDeviceMetric m) const
    {
        if (!_env)
            return QSvgWidget::metric(m);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[30];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(int(m));
            Value rval = _env->call(F, args);
            return (int)(rval._int);
        }
        else
        {
            return QSvgWidget::metric(m);
        }
    }

    //----------------------------------------------------------------------
    //  Mu Type CONSTRUCTORS

    QSvgWidgetType::QSvgWidgetType(Context* c, const char* name, Class* super,
                                   Class* super2)
        : Class(c, name, vectorOf2(super, super2))
    {
    }

    QSvgWidgetType::~QSvgWidgetType() {}

    //----------------------------------------------------------------------
    //  PRE-COMPILED FUNCTIONS

    static Pointer QSvgWidget_QSvgWidget_QObject(Thread& NODE_THREAD,
                                                 Pointer obj)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        ClassInstance* widget = reinterpret_cast<ClassInstance*>(obj);

        if (!widget)
        {
            return 0;
        }
        else if (QSvgWidget* w = object<QSvgWidget>(widget))
        {
            QSvgWidgetType* type =
                c->findSymbolOfTypeByQualifiedName<QSvgWidgetType>(
                    c->internName("qt.QSvgWidget"), false);
            ClassInstance* o = ClassInstance::allocate(type);
            setobject(o, w);
            return o;
        }
        else
        {
            throw BadCastException();
        }
    }

    static NODE_IMPLEMENTATION(castFromObject, Pointer)
    {
        NODE_RETURN(
            QSvgWidget_QSvgWidget_QObject(NODE_THREAD, NODE_ARG(0, Pointer)));
    }

    Pointer qt_QSvgWidget_QSvgWidget_QSvgWidget_QSvgWidget_QWidget(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QWidget* arg1 = object<QWidget>(param_parent);
        setobject(param_this,
                  new MuQt_QSvgWidget(param_this,
                                      NODE_THREAD.process()->callEnv(), arg1));
        return param_this;
    }

    Pointer qt_QSvgWidget_QSvgWidget_QSvgWidget_QSvgWidget_string_QWidget(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_file,
        Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        const QString arg1 = qstring(param_file);
        QWidget* arg2 = object<QWidget>(param_parent);
        setobject(param_this, new MuQt_QSvgWidget(
                                  param_this, NODE_THREAD.process()->callEnv(),
                                  arg1, arg2));
        return param_this;
    }

    Pointer qt_QSvgWidget_sizeHint_QSize_QSvgWidget(Mu::Thread& NODE_THREAD,
                                                    Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QSvgWidget* arg0 = object<QSvgWidget>(param_this);
        return isMuQtObject(arg0)
                   ? makeqtype<QSizeType>(c, arg0->QSvgWidget::sizeHint(),
                                          "qt.QSize")
                   : makeqtype<QSizeType>(c, arg0->sizeHint(), "qt.QSize");
    }

    void qt_QSvgWidget_paintEvent_void_QSvgWidget_QPaintEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QSvgWidget* arg0 = object<QSvgWidget>(param_this);
        QPaintEvent* arg1 = getqpointer<QPaintEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QSvgWidget*)arg0)->paintEvent_pub_parent(arg1);
        else
            ((MuQt_QSvgWidget*)arg0)->paintEvent_pub(arg1);
    }

    bool
    qt_QSvgWidget_hasHeightForWidth_bool_QSvgWidget(Mu::Thread& NODE_THREAD,
                                                    Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QSvgWidget* arg0 = object<QSvgWidget>(param_this);
        return isMuQtObject(arg0) ? arg0->QSvgWidget::hasHeightForWidth()
                                  : arg0->hasHeightForWidth();
    }

    int qt_QSvgWidget_heightForWidth_int_QSvgWidget_int(Mu::Thread& NODE_THREAD,
                                                        Pointer param_this,
                                                        int param_w)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QSvgWidget* arg0 = object<QSvgWidget>(param_this);
        int arg1 = (int)(param_w);
        return isMuQtObject(arg0) ? arg0->QSvgWidget::heightForWidth(arg1)
                                  : arg0->heightForWidth(arg1);
    }

    Pointer qt_QSvgWidget_inputMethodQuery_QVariant_QSvgWidget_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_query)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QSvgWidget* arg0 = object<QSvgWidget>(param_this);
        Qt::InputMethodQuery arg1 = (Qt::InputMethodQuery)(param_query);
        return isMuQtObject(arg0)
                   ? makeqtype<QVariantType>(
                         c, arg0->QSvgWidget::inputMethodQuery(arg1),
                         "qt.QVariant")
                   : makeqtype<QVariantType>(c, arg0->inputMethodQuery(arg1),
                                             "qt.QVariant");
    }

    Pointer
    qt_QSvgWidget_minimumSizeHint_QSize_QSvgWidget(Mu::Thread& NODE_THREAD,
                                                   Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QSvgWidget* arg0 = object<QSvgWidget>(param_this);
        return isMuQtObject(arg0)
                   ? makeqtype<QSizeType>(
                         c, arg0->QSvgWidget::minimumSizeHint(), "qt.QSize")
                   : makeqtype<QSizeType>(c, arg0->minimumSizeHint(),
                                          "qt.QSize");
    }

    void qt_QSvgWidget_changeEvent_void_QSvgWidget_QEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QSvgWidget* arg0 = object<QSvgWidget>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QSvgWidget*)arg0)->changeEvent_pub_parent(arg1);
        else
            ((MuQt_QSvgWidget*)arg0)->changeEvent_pub(arg1);
    }

    void qt_QSvgWidget_closeEvent_void_QSvgWidget_QCloseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QSvgWidget* arg0 = object<QSvgWidget>(param_this);
        QCloseEvent* arg1 = getqpointer<QCloseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QSvgWidget*)arg0)->closeEvent_pub_parent(arg1);
        else
            ((MuQt_QSvgWidget*)arg0)->closeEvent_pub(arg1);
    }

    void qt_QSvgWidget_contextMenuEvent_void_QSvgWidget_QContextMenuEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QSvgWidget* arg0 = object<QSvgWidget>(param_this);
        QContextMenuEvent* arg1 =
            getqpointer<QContextMenuEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QSvgWidget*)arg0)->contextMenuEvent_pub_parent(arg1);
        else
            ((MuQt_QSvgWidget*)arg0)->contextMenuEvent_pub(arg1);
    }

    void qt_QSvgWidget_dragEnterEvent_void_QSvgWidget_QDragEnterEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QSvgWidget* arg0 = object<QSvgWidget>(param_this);
        QDragEnterEvent* arg1 = getqpointer<QDragEnterEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QSvgWidget*)arg0)->dragEnterEvent_pub_parent(arg1);
        else
            ((MuQt_QSvgWidget*)arg0)->dragEnterEvent_pub(arg1);
    }

    void qt_QSvgWidget_dragLeaveEvent_void_QSvgWidget_QDragLeaveEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QSvgWidget* arg0 = object<QSvgWidget>(param_this);
        QDragLeaveEvent* arg1 = getqpointer<QDragLeaveEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QSvgWidget*)arg0)->dragLeaveEvent_pub_parent(arg1);
        else
            ((MuQt_QSvgWidget*)arg0)->dragLeaveEvent_pub(arg1);
    }

    void qt_QSvgWidget_dragMoveEvent_void_QSvgWidget_QDragMoveEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QSvgWidget* arg0 = object<QSvgWidget>(param_this);
        QDragMoveEvent* arg1 = getqpointer<QDragMoveEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QSvgWidget*)arg0)->dragMoveEvent_pub_parent(arg1);
        else
            ((MuQt_QSvgWidget*)arg0)->dragMoveEvent_pub(arg1);
    }

    void qt_QSvgWidget_dropEvent_void_QSvgWidget_QDropEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QSvgWidget* arg0 = object<QSvgWidget>(param_this);
        QDropEvent* arg1 = getqpointer<QDropEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QSvgWidget*)arg0)->dropEvent_pub_parent(arg1);
        else
            ((MuQt_QSvgWidget*)arg0)->dropEvent_pub(arg1);
    }

    void qt_QSvgWidget_focusInEvent_void_QSvgWidget_QFocusEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QSvgWidget* arg0 = object<QSvgWidget>(param_this);
        QFocusEvent* arg1 = getqpointer<QFocusEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QSvgWidget*)arg0)->focusInEvent_pub_parent(arg1);
        else
            ((MuQt_QSvgWidget*)arg0)->focusInEvent_pub(arg1);
    }

    bool qt_QSvgWidget_focusNextPrevChild_bool_QSvgWidget_bool(
        Mu::Thread& NODE_THREAD, Pointer param_this, bool param_next)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QSvgWidget* arg0 = object<QSvgWidget>(param_this);
        bool arg1 = (bool)(param_next);
        return isMuQtObject(arg0)
                   ? ((MuQt_QSvgWidget*)arg0)
                         ->focusNextPrevChild_pub_parent(arg1)
                   : ((MuQt_QSvgWidget*)arg0)->focusNextPrevChild_pub(arg1);
    }

    void qt_QSvgWidget_focusOutEvent_void_QSvgWidget_QFocusEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QSvgWidget* arg0 = object<QSvgWidget>(param_this);
        QFocusEvent* arg1 = getqpointer<QFocusEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QSvgWidget*)arg0)->focusOutEvent_pub_parent(arg1);
        else
            ((MuQt_QSvgWidget*)arg0)->focusOutEvent_pub(arg1);
    }

    void qt_QSvgWidget_hideEvent_void_QSvgWidget_QHideEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QSvgWidget* arg0 = object<QSvgWidget>(param_this);
        QHideEvent* arg1 = getqpointer<QHideEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QSvgWidget*)arg0)->hideEvent_pub_parent(arg1);
        else
            ((MuQt_QSvgWidget*)arg0)->hideEvent_pub(arg1);
    }

    void qt_QSvgWidget_keyPressEvent_void_QSvgWidget_QKeyEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QSvgWidget* arg0 = object<QSvgWidget>(param_this);
        QKeyEvent* arg1 = getqpointer<QKeyEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QSvgWidget*)arg0)->keyPressEvent_pub_parent(arg1);
        else
            ((MuQt_QSvgWidget*)arg0)->keyPressEvent_pub(arg1);
    }

    void qt_QSvgWidget_keyReleaseEvent_void_QSvgWidget_QKeyEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QSvgWidget* arg0 = object<QSvgWidget>(param_this);
        QKeyEvent* arg1 = getqpointer<QKeyEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QSvgWidget*)arg0)->keyReleaseEvent_pub_parent(arg1);
        else
            ((MuQt_QSvgWidget*)arg0)->keyReleaseEvent_pub(arg1);
    }

    void qt_QSvgWidget_leaveEvent_void_QSvgWidget_QEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QSvgWidget* arg0 = object<QSvgWidget>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QSvgWidget*)arg0)->leaveEvent_pub_parent(arg1);
        else
            ((MuQt_QSvgWidget*)arg0)->leaveEvent_pub(arg1);
    }

    void qt_QSvgWidget_mouseDoubleClickEvent_void_QSvgWidget_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QSvgWidget* arg0 = object<QSvgWidget>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QSvgWidget*)arg0)->mouseDoubleClickEvent_pub_parent(arg1);
        else
            ((MuQt_QSvgWidget*)arg0)->mouseDoubleClickEvent_pub(arg1);
    }

    void qt_QSvgWidget_mouseMoveEvent_void_QSvgWidget_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QSvgWidget* arg0 = object<QSvgWidget>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QSvgWidget*)arg0)->mouseMoveEvent_pub_parent(arg1);
        else
            ((MuQt_QSvgWidget*)arg0)->mouseMoveEvent_pub(arg1);
    }

    void qt_QSvgWidget_mousePressEvent_void_QSvgWidget_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QSvgWidget* arg0 = object<QSvgWidget>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QSvgWidget*)arg0)->mousePressEvent_pub_parent(arg1);
        else
            ((MuQt_QSvgWidget*)arg0)->mousePressEvent_pub(arg1);
    }

    void qt_QSvgWidget_mouseReleaseEvent_void_QSvgWidget_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QSvgWidget* arg0 = object<QSvgWidget>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QSvgWidget*)arg0)->mouseReleaseEvent_pub_parent(arg1);
        else
            ((MuQt_QSvgWidget*)arg0)->mouseReleaseEvent_pub(arg1);
    }

    void qt_QSvgWidget_moveEvent_void_QSvgWidget_QMoveEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QSvgWidget* arg0 = object<QSvgWidget>(param_this);
        QMoveEvent* arg1 = getqpointer<QMoveEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QSvgWidget*)arg0)->moveEvent_pub_parent(arg1);
        else
            ((MuQt_QSvgWidget*)arg0)->moveEvent_pub(arg1);
    }

    void qt_QSvgWidget_resizeEvent_void_QSvgWidget_QResizeEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QSvgWidget* arg0 = object<QSvgWidget>(param_this);
        QResizeEvent* arg1 = getqpointer<QResizeEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QSvgWidget*)arg0)->resizeEvent_pub_parent(arg1);
        else
            ((MuQt_QSvgWidget*)arg0)->resizeEvent_pub(arg1);
    }

    void qt_QSvgWidget_showEvent_void_QSvgWidget_QShowEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QSvgWidget* arg0 = object<QSvgWidget>(param_this);
        QShowEvent* arg1 = getqpointer<QShowEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QSvgWidget*)arg0)->showEvent_pub_parent(arg1);
        else
            ((MuQt_QSvgWidget*)arg0)->showEvent_pub(arg1);
    }

    void qt_QSvgWidget_tabletEvent_void_QSvgWidget_QTabletEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QSvgWidget* arg0 = object<QSvgWidget>(param_this);
        QTabletEvent* arg1 = getqpointer<QTabletEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QSvgWidget*)arg0)->tabletEvent_pub_parent(arg1);
        else
            ((MuQt_QSvgWidget*)arg0)->tabletEvent_pub(arg1);
    }

    void qt_QSvgWidget_wheelEvent_void_QSvgWidget_QWheelEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QSvgWidget* arg0 = object<QSvgWidget>(param_this);
        QWheelEvent* arg1 = getqpointer<QWheelEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QSvgWidget*)arg0)->wheelEvent_pub_parent(arg1);
        else
            ((MuQt_QSvgWidget*)arg0)->wheelEvent_pub(arg1);
    }

    bool qt_QSvgWidget_event_bool_QSvgWidget_QEvent(Mu::Thread& NODE_THREAD,
                                                    Pointer param_this,
                                                    Pointer param_event_)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QSvgWidget* arg0 = object<QSvgWidget>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_event_);
        return isMuQtObject(arg0)
                   ? ((MuQt_QSvgWidget*)arg0)->event_pub_parent(arg1)
                   : ((MuQt_QSvgWidget*)arg0)->event_pub(arg1);
    }

    int qt_QSvgWidget_metric_int_QSvgWidget_int(Mu::Thread& NODE_THREAD,
                                                Pointer param_this, int param_m)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QSvgWidget* arg0 = object<QSvgWidget>(param_this);
        QPaintDevice::PaintDeviceMetric arg1 =
            (QPaintDevice::PaintDeviceMetric)(param_m);
        return isMuQtObject(arg0)
                   ? ((MuQt_QSvgWidget*)arg0)->metric_pub_parent(arg1)
                   : ((MuQt_QSvgWidget*)arg0)->metric_pub(arg1);
    }

    static NODE_IMPLEMENTATION(_n_QSvgWidget0, Pointer)
    {
        NODE_RETURN(qt_QSvgWidget_QSvgWidget_QSvgWidget_QSvgWidget_QWidget(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_QSvgWidget1, Pointer)
    {
        NODE_RETURN(
            qt_QSvgWidget_QSvgWidget_QSvgWidget_QSvgWidget_string_QWidget(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
                NODE_ARG(2, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_sizeHint0, Pointer)
    {
        NODE_RETURN(qt_QSvgWidget_sizeHint_QSize_QSvgWidget(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_paintEvent0, void)
    {
        qt_QSvgWidget_paintEvent_void_QSvgWidget_QPaintEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_hasHeightForWidth0, bool)
    {
        NODE_RETURN(qt_QSvgWidget_hasHeightForWidth_bool_QSvgWidget(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_heightForWidth0, int)
    {
        NODE_RETURN(qt_QSvgWidget_heightForWidth_int_QSvgWidget_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_inputMethodQuery0, Pointer)
    {
        NODE_RETURN(qt_QSvgWidget_inputMethodQuery_QVariant_QSvgWidget_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_minimumSizeHint0, Pointer)
    {
        NODE_RETURN(qt_QSvgWidget_minimumSizeHint_QSize_QSvgWidget(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_changeEvent0, void)
    {
        qt_QSvgWidget_changeEvent_void_QSvgWidget_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_closeEvent0, void)
    {
        qt_QSvgWidget_closeEvent_void_QSvgWidget_QCloseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_contextMenuEvent0, void)
    {
        qt_QSvgWidget_contextMenuEvent_void_QSvgWidget_QContextMenuEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dragEnterEvent0, void)
    {
        qt_QSvgWidget_dragEnterEvent_void_QSvgWidget_QDragEnterEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dragLeaveEvent0, void)
    {
        qt_QSvgWidget_dragLeaveEvent_void_QSvgWidget_QDragLeaveEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dragMoveEvent0, void)
    {
        qt_QSvgWidget_dragMoveEvent_void_QSvgWidget_QDragMoveEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dropEvent0, void)
    {
        qt_QSvgWidget_dropEvent_void_QSvgWidget_QDropEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_focusInEvent0, void)
    {
        qt_QSvgWidget_focusInEvent_void_QSvgWidget_QFocusEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_focusNextPrevChild0, bool)
    {
        NODE_RETURN(qt_QSvgWidget_focusNextPrevChild_bool_QSvgWidget_bool(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, bool)));
    }

    static NODE_IMPLEMENTATION(_n_focusOutEvent0, void)
    {
        qt_QSvgWidget_focusOutEvent_void_QSvgWidget_QFocusEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_hideEvent0, void)
    {
        qt_QSvgWidget_hideEvent_void_QSvgWidget_QHideEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_keyPressEvent0, void)
    {
        qt_QSvgWidget_keyPressEvent_void_QSvgWidget_QKeyEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_keyReleaseEvent0, void)
    {
        qt_QSvgWidget_keyReleaseEvent_void_QSvgWidget_QKeyEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_leaveEvent0, void)
    {
        qt_QSvgWidget_leaveEvent_void_QSvgWidget_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mouseDoubleClickEvent0, void)
    {
        qt_QSvgWidget_mouseDoubleClickEvent_void_QSvgWidget_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mouseMoveEvent0, void)
    {
        qt_QSvgWidget_mouseMoveEvent_void_QSvgWidget_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mousePressEvent0, void)
    {
        qt_QSvgWidget_mousePressEvent_void_QSvgWidget_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mouseReleaseEvent0, void)
    {
        qt_QSvgWidget_mouseReleaseEvent_void_QSvgWidget_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_moveEvent0, void)
    {
        qt_QSvgWidget_moveEvent_void_QSvgWidget_QMoveEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_resizeEvent0, void)
    {
        qt_QSvgWidget_resizeEvent_void_QSvgWidget_QResizeEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_showEvent0, void)
    {
        qt_QSvgWidget_showEvent_void_QSvgWidget_QShowEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_tabletEvent0, void)
    {
        qt_QSvgWidget_tabletEvent_void_QSvgWidget_QTabletEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_wheelEvent0, void)
    {
        qt_QSvgWidget_wheelEvent_void_QSvgWidget_QWheelEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_event0, bool)
    {
        NODE_RETURN(qt_QSvgWidget_event_bool_QSvgWidget_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_metric0, int)
    {
        NODE_RETURN(qt_QSvgWidget_metric_int_QSvgWidget_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    void QSvgWidgetType::load()
    {
        USING_MU_FUNCTION_SYMBOLS;
        MuLangContext* c = static_cast<MuLangContext*>(context());
        Module* global = globalModule();

        const string typeName = name();
        const string refTypeName = typeName + "&";
        const string fullTypeName = fullyQualifiedName();
        const string fullRefTypeName = fullTypeName + "&";
        const char* tn = typeName.c_str();
        const char* ftn = fullTypeName.c_str();
        const char* rtn = refTypeName.c_str();
        const char* frtn = fullRefTypeName.c_str();

        scope()->addSymbols(new ReferenceType(c, rtn, this),

                            new Function(c, tn, BaseFunctions::dereference,
                                         Cast, Return, ftn, Args, frtn, End),

                            EndArguments);

        addSymbols(new Function(c, "__allocate", BaseFunctions::classAllocate,
                                None, Return, ftn, End),

                   new Function(c, tn, castFromObject, Cast, Compiled,
                                QSvgWidget_QSvgWidget_QObject, Return, ftn,
                                Parameters,
                                new Param(c, "object", "qt.QObject"), End),

                   EndArguments);

        addSymbols(
            // enums
            // member functions
            new Function(c, "QSvgWidget", _n_QSvgWidget0, None, Compiled,
                         qt_QSvgWidget_QSvgWidget_QSvgWidget_QSvgWidget_QWidget,
                         Return, "qt.QSvgWidget", Parameters,
                         new Param(c, "this", "qt.QSvgWidget"),
                         new Param(c, "parent", "qt.QWidget"), End),
            new Function(
                c, "QSvgWidget", _n_QSvgWidget1, None, Compiled,
                qt_QSvgWidget_QSvgWidget_QSvgWidget_QSvgWidget_string_QWidget,
                Return, "qt.QSvgWidget", Parameters,
                new Param(c, "this", "qt.QSvgWidget"),
                new Param(c, "file", "string"),
                new Param(c, "parent", "qt.QWidget"), End),
            // MISSING: renderer ("QSvgRenderer *"; QSvgWidget this)
            _func[0] = new MemberFunction(
                c, "sizeHint", _n_sizeHint0, None, Compiled,
                qt_QSvgWidget_sizeHint_QSize_QSvgWidget, Return, "qt.QSize",
                Parameters, new Param(c, "this", "qt.QSvgWidget"), End),
            _func[1] = new MemberFunction(
                c, "paintEvent", _n_paintEvent0, None, Compiled,
                qt_QSvgWidget_paintEvent_void_QSvgWidget_QPaintEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QSvgWidget"),
                new Param(c, "event", "qt.QPaintEvent"), End),
            _func[2] = new MemberFunction(
                c, "hasHeightForWidth", _n_hasHeightForWidth0, None, Compiled,
                qt_QSvgWidget_hasHeightForWidth_bool_QSvgWidget, Return, "bool",
                Parameters, new Param(c, "this", "qt.QSvgWidget"), End),
            _func[3] = new MemberFunction(
                c, "heightForWidth", _n_heightForWidth0, None, Compiled,
                qt_QSvgWidget_heightForWidth_int_QSvgWidget_int, Return, "int",
                Parameters, new Param(c, "this", "qt.QSvgWidget"),
                new Param(c, "w", "int"), End),
            _func[4] = new MemberFunction(
                c, "inputMethodQuery", _n_inputMethodQuery0, None, Compiled,
                qt_QSvgWidget_inputMethodQuery_QVariant_QSvgWidget_int, Return,
                "qt.QVariant", Parameters,
                new Param(c, "this", "qt.QSvgWidget"),
                new Param(c, "query", "int"), End),
            _func[5] = new MemberFunction(
                c, "minimumSizeHint", _n_minimumSizeHint0, None, Compiled,
                qt_QSvgWidget_minimumSizeHint_QSize_QSvgWidget, Return,
                "qt.QSize", Parameters, new Param(c, "this", "qt.QSvgWidget"),
                End),
            // MISSING: paintEngine ("QPaintEngine *"; QSvgWidget this)
            // MISSING: actionEvent (void; QSvgWidget this, "QActionEvent *"
            // event) // protected
            _func[6] = new MemberFunction(
                c, "changeEvent", _n_changeEvent0, None, Compiled,
                qt_QSvgWidget_changeEvent_void_QSvgWidget_QEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QSvgWidget"),
                new Param(c, "event", "qt.QEvent"), End),
            _func[7] = new MemberFunction(
                c, "closeEvent", _n_closeEvent0, None, Compiled,
                qt_QSvgWidget_closeEvent_void_QSvgWidget_QCloseEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QSvgWidget"),
                new Param(c, "event", "qt.QCloseEvent"), End),
            _func[8] = new MemberFunction(
                c, "contextMenuEvent", _n_contextMenuEvent0, None, Compiled,
                qt_QSvgWidget_contextMenuEvent_void_QSvgWidget_QContextMenuEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QSvgWidget"),
                new Param(c, "event", "qt.QContextMenuEvent"), End),
            _func[9] = new MemberFunction(
                c, "dragEnterEvent", _n_dragEnterEvent0, None, Compiled,
                qt_QSvgWidget_dragEnterEvent_void_QSvgWidget_QDragEnterEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QSvgWidget"),
                new Param(c, "event", "qt.QDragEnterEvent"), End),
            _func[10] = new MemberFunction(
                c, "dragLeaveEvent", _n_dragLeaveEvent0, None, Compiled,
                qt_QSvgWidget_dragLeaveEvent_void_QSvgWidget_QDragLeaveEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QSvgWidget"),
                new Param(c, "event", "qt.QDragLeaveEvent"), End),
            _func[11] = new MemberFunction(
                c, "dragMoveEvent", _n_dragMoveEvent0, None, Compiled,
                qt_QSvgWidget_dragMoveEvent_void_QSvgWidget_QDragMoveEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QSvgWidget"),
                new Param(c, "event", "qt.QDragMoveEvent"), End),
            _func[12] = new MemberFunction(
                c, "dropEvent", _n_dropEvent0, None, Compiled,
                qt_QSvgWidget_dropEvent_void_QSvgWidget_QDropEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QSvgWidget"),
                new Param(c, "event", "qt.QDropEvent"), End),
            // MISSING: enterEvent (void; QSvgWidget this, "QEnterEvent *"
            // event) // protected
            _func[13] = new MemberFunction(
                c, "focusInEvent", _n_focusInEvent0, None, Compiled,
                qt_QSvgWidget_focusInEvent_void_QSvgWidget_QFocusEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QSvgWidget"),
                new Param(c, "event", "qt.QFocusEvent"), End),
            _func[14] = new MemberFunction(
                c, "focusNextPrevChild", _n_focusNextPrevChild0, None, Compiled,
                qt_QSvgWidget_focusNextPrevChild_bool_QSvgWidget_bool, Return,
                "bool", Parameters, new Param(c, "this", "qt.QSvgWidget"),
                new Param(c, "next", "bool"), End),
            _func[15] = new MemberFunction(
                c, "focusOutEvent", _n_focusOutEvent0, None, Compiled,
                qt_QSvgWidget_focusOutEvent_void_QSvgWidget_QFocusEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QSvgWidget"),
                new Param(c, "event", "qt.QFocusEvent"), End),
            _func[16] = new MemberFunction(
                c, "hideEvent", _n_hideEvent0, None, Compiled,
                qt_QSvgWidget_hideEvent_void_QSvgWidget_QHideEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QSvgWidget"),
                new Param(c, "event", "qt.QHideEvent"), End),
            // MISSING: inputMethodEvent (void; QSvgWidget this,
            // "QInputMethodEvent *" event) // protected
            _func[17] = new MemberFunction(
                c, "keyPressEvent", _n_keyPressEvent0, None, Compiled,
                qt_QSvgWidget_keyPressEvent_void_QSvgWidget_QKeyEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QSvgWidget"),
                new Param(c, "event", "qt.QKeyEvent"), End),
            _func[18] = new MemberFunction(
                c, "keyReleaseEvent", _n_keyReleaseEvent0, None, Compiled,
                qt_QSvgWidget_keyReleaseEvent_void_QSvgWidget_QKeyEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QSvgWidget"),
                new Param(c, "event", "qt.QKeyEvent"), End),
            _func[19] = new MemberFunction(
                c, "leaveEvent", _n_leaveEvent0, None, Compiled,
                qt_QSvgWidget_leaveEvent_void_QSvgWidget_QEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QSvgWidget"),
                new Param(c, "event", "qt.QEvent"), End),
            _func[20] = new MemberFunction(
                c, "mouseDoubleClickEvent", _n_mouseDoubleClickEvent0, None,
                Compiled,
                qt_QSvgWidget_mouseDoubleClickEvent_void_QSvgWidget_QMouseEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QSvgWidget"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[21] = new MemberFunction(
                c, "mouseMoveEvent", _n_mouseMoveEvent0, None, Compiled,
                qt_QSvgWidget_mouseMoveEvent_void_QSvgWidget_QMouseEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QSvgWidget"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[22] = new MemberFunction(
                c, "mousePressEvent", _n_mousePressEvent0, None, Compiled,
                qt_QSvgWidget_mousePressEvent_void_QSvgWidget_QMouseEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QSvgWidget"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[23] = new MemberFunction(
                c, "mouseReleaseEvent", _n_mouseReleaseEvent0, None, Compiled,
                qt_QSvgWidget_mouseReleaseEvent_void_QSvgWidget_QMouseEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QSvgWidget"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[24] = new MemberFunction(
                c, "moveEvent", _n_moveEvent0, None, Compiled,
                qt_QSvgWidget_moveEvent_void_QSvgWidget_QMoveEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QSvgWidget"),
                new Param(c, "event", "qt.QMoveEvent"), End),
            // MISSING: nativeEvent (bool; QSvgWidget this, QByteArray
            // eventType, "void *" message, "qintptr *" result) // protected
            _func[25] = new MemberFunction(
                c, "resizeEvent", _n_resizeEvent0, None, Compiled,
                qt_QSvgWidget_resizeEvent_void_QSvgWidget_QResizeEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QSvgWidget"),
                new Param(c, "event", "qt.QResizeEvent"), End),
            _func[26] = new MemberFunction(
                c, "showEvent", _n_showEvent0, None, Compiled,
                qt_QSvgWidget_showEvent_void_QSvgWidget_QShowEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QSvgWidget"),
                new Param(c, "event", "qt.QShowEvent"), End),
            _func[27] = new MemberFunction(
                c, "tabletEvent", _n_tabletEvent0, None, Compiled,
                qt_QSvgWidget_tabletEvent_void_QSvgWidget_QTabletEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QSvgWidget"),
                new Param(c, "event", "qt.QTabletEvent"), End),
            _func[28] = new MemberFunction(
                c, "wheelEvent", _n_wheelEvent0, None, Compiled,
                qt_QSvgWidget_wheelEvent_void_QSvgWidget_QWheelEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QSvgWidget"),
                new Param(c, "event", "qt.QWheelEvent"), End),
            _func[29] = new MemberFunction(
                c, "event", _n_event0, None, Compiled,
                qt_QSvgWidget_event_bool_QSvgWidget_QEvent, Return, "bool",
                Parameters, new Param(c, "this", "qt.QSvgWidget"),
                new Param(c, "event_", "qt.QEvent"), End),
            // MISSING: initPainter (void; QSvgWidget this, "QPainter *"
            // painter) // protected
            _func[30] = new MemberFunction(
                c, "metric", _n_metric0, None, Compiled,
                qt_QSvgWidget_metric_int_QSvgWidget_int, Return, "int",
                Parameters, new Param(c, "this", "qt.QSvgWidget"),
                new Param(c, "m", "int"), End),
            // static functions
            EndArguments);
        globalScope()->addSymbols(EndArguments);
        scope()->addSymbols(EndArguments);

        const char** propExclusions = 0;

        populate(this, QSvgWidget::staticMetaObject, propExclusions);
    }

} // namespace Mu
