//*****************************************************************************
// Copyright (c) 2024 Autodesk, Inc.
// All rights reserved.
//
// SPDX-License-Identifier: Apache-2.0
//
//*****************************************************************************

// IMPORTANT: This file (not the template) is auto-generated by qt2mu.py script.
//            The prefered way to do a fix is to handrolled it or modify the
//            qt2mu.py script. If it is not possible, manual editing is ok but
//            it could be lost in future generations.

#include <MuQt6/qtUtils.h>
#include <MuQt6/QTableViewType.h>
#include <QtGui/QtGui>
#include <QtWidgets/QtWidgets>
#include <QtSvg/QtSvg>
#include <QSvgWidget>
#include <QtNetwork/QtNetwork>
#include <MuQt6/QWidgetType.h>
#include <MuQt6/QActionType.h>
#include <MuQt6/QIconType.h>
#include <Mu/BaseFunctions.h>
#include <Mu/Thread.h>
#include <Mu/Alias.h>
#include <Mu/SymbolicConstant.h>
#include <Mu/ClassInstance.h>
#include <Mu/Function.h>
#include <Mu/MemberFunction.h>
#include <Mu/MemberVariable.h>
#include <Mu/Node.h>
#include <Mu/Exception.h>
#include <Mu/ParameterVariable.h>
#include <Mu/ReferenceType.h>
#include <Mu/Value.h>
#include <MuLang/MuLangContext.h>
#include <MuLang/StringType.h>
#include <MuQt6/QObjectType.h>
#include <MuQt6/QDragMoveEventType.h>
#include <MuQt6/QHeaderViewType.h>
#include <MuQt6/QResizeEventType.h>
#include <MuQt6/QAbstractItemModelType.h>
#include <MuQt6/QMouseEventType.h>
#include <MuQt6/QModelIndexType.h>
#include <MuQt6/QFocusEventType.h>
#include <MuQt6/QDragEnterEventType.h>
#include <MuQt6/QSizeType.h>
#include <MuQt6/QDropEventType.h>
#include <MuQt6/QPaintEventType.h>
#include <MuQt6/QDragLeaveEventType.h>
#include <MuQt6/QItemSelectionType.h>
#include <MuQt6/QTimerEventType.h>
#include <MuQt6/QItemSelectionModelType.h>
#include <MuQt6/QEventType.h>
#include <MuQt6/QRectType.h>
#include <MuQt6/QKeyEventType.h>
#include <MuQt6/QRegionType.h>
#include <MuQt6/QVariantType.h>
#include <MuQt6/QPointType.h>

namespace Mu
{
    using namespace std;

    //----------------------------------------------------------------------
    //  INHERITABLE TYPE IMPLEMENTATION

    // destructor
    MuQt_QTableView::~MuQt_QTableView()
    {
        if (_obj)
        {
            *_obj->data<Pointer>() = Pointer(0);
            _obj->releaseExternal();
        }
        _obj = 0;
        _env = 0;
        _baseType = 0;
    }

    MuQt_QTableView::MuQt_QTableView(Pointer muobj, const CallEnvironment* ce,
                                     QWidget* parent)
        : QTableView(parent)
    {
        _env = ce;
        _obj = reinterpret_cast<ClassInstance*>(muobj);
        _obj->retainExternal();
        MuLangContext* c = (MuLangContext*)_env->context();
        _baseType = c->findSymbolOfTypeByQualifiedName<QTableViewType>(
            c->internName("qt.QTableView"));
    }

    QModelIndex MuQt_QTableView::indexAt(const QPoint& pos) const
    {
        if (!_env)
            return QTableView::indexAt(pos);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[0];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqtype<QPointType>(c, pos, "qt.QPoint"));
            Value rval = _env->call(F, args);
            return getqtype<QModelIndexType>(rval._Pointer);
        }
        else
        {
            return QTableView::indexAt(pos);
        }
    }

    void MuQt_QTableView::scrollTo(const QModelIndex& index,
                                   QAbstractItemView::ScrollHint hint)
    {
        if (!_env)
        {
            QTableView::scrollTo(index, hint);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[1];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(3);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, index, "qt.QModelIndex"));
            args[2] = Value(int(hint));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTableView::scrollTo(index, hint);
        }
    }

    void MuQt_QTableView::setModel(QAbstractItemModel* model)
    {
        if (!_env)
        {
            QTableView::setModel(model);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[2];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeinstance<QAbstractItemModelType>(
                c, model, "qt.QAbstractItemModel"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTableView::setModel(model);
        }
    }

    void MuQt_QTableView::setRootIndex(const QModelIndex& index)
    {
        if (!_env)
        {
            QTableView::setRootIndex(index);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[3];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, index, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTableView::setRootIndex(index);
        }
    }

    void MuQt_QTableView::setSelectionModel(QItemSelectionModel* selectionModel)
    {
        if (!_env)
        {
            QTableView::setSelectionModel(selectionModel);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[4];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeinstance<QItemSelectionModelType>(
                c, selectionModel, "qt.QItemSelectionModel"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTableView::setSelectionModel(selectionModel);
        }
    }

    QRect MuQt_QTableView::visualRect(const QModelIndex& index) const
    {
        if (!_env)
            return QTableView::visualRect(index);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[5];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, index, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return getqtype<QRectType>(rval._Pointer);
        }
        else
        {
            return QTableView::visualRect(index);
        }
    }

    void MuQt_QTableView::currentChanged(const QModelIndex& current,
                                         const QModelIndex& previous)
    {
        if (!_env)
        {
            QTableView::currentChanged(current, previous);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[6];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(3);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, current, "qt.QModelIndex"));
            args[2] = Value(
                makeqtype<QModelIndexType>(c, previous, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTableView::currentChanged(current, previous);
        }
    }

    int MuQt_QTableView::horizontalOffset() const
    {
        if (!_env)
            return QTableView::horizontalOffset();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[7];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return (int)(rval._int);
        }
        else
        {
            return QTableView::horizontalOffset();
        }
    }

    bool MuQt_QTableView::isIndexHidden(const QModelIndex& index) const
    {
        if (!_env)
            return QTableView::isIndexHidden(index);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[8];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, index, "qt.QModelIndex"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QTableView::isIndexHidden(index);
        }
    }

    void MuQt_QTableView::paintEvent(QPaintEvent* event)
    {
        if (!_env)
        {
            QTableView::paintEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[9];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QPaintEventType>(c, event, "qt.QPaintEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTableView::paintEvent(event);
        }
    }

    void MuQt_QTableView::scrollContentsBy(int dx, int dy)
    {
        if (!_env)
        {
            QTableView::scrollContentsBy(dx, dy);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[10];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(3);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(dx);
            args[2] = Value(dy);
            Value rval = _env->call(F, args);
        }
        else
        {
            QTableView::scrollContentsBy(dx, dy);
        }
    }

    QModelIndexList MuQt_QTableView::selectedIndexes() const
    {
        if (!_env)
            return QTableView::selectedIndexes();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[11];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return qmodelindexlist(rval._Pointer);
        }
        else
        {
            return QTableView::selectedIndexes();
        }
    }

    void MuQt_QTableView::selectionChanged(const QItemSelection& selected,
                                           const QItemSelection& deselected)
    {
        if (!_env)
        {
            QTableView::selectionChanged(selected, deselected);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[12];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(3);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqtype<QItemSelectionType>(c, selected,
                                                          "qt.QItemSelection"));
            args[2] = Value(makeqtype<QItemSelectionType>(c, deselected,
                                                          "qt.QItemSelection"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTableView::selectionChanged(selected, deselected);
        }
    }

    void
    MuQt_QTableView::setSelection(const QRect& rect,
                                  QItemSelectionModel::SelectionFlags flags)
    {
        if (!_env)
        {
            QTableView::setSelection(rect, flags);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[13];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(3);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqtype<QRectType>(c, rect, "qt.QRect"));
            args[2] = Value(int(flags));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTableView::setSelection(rect, flags);
        }
    }

    int MuQt_QTableView::sizeHintForColumn(int column) const
    {
        if (!_env)
            return QTableView::sizeHintForColumn(column);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[14];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(column);
            Value rval = _env->call(F, args);
            return (int)(rval._int);
        }
        else
        {
            return QTableView::sizeHintForColumn(column);
        }
    }

    int MuQt_QTableView::sizeHintForRow(int row) const
    {
        if (!_env)
            return QTableView::sizeHintForRow(row);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[15];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(row);
            Value rval = _env->call(F, args);
            return (int)(rval._int);
        }
        else
        {
            return QTableView::sizeHintForRow(row);
        }
    }

    void MuQt_QTableView::timerEvent(QTimerEvent* event)
    {
        if (!_env)
        {
            QTableView::timerEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[16];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QTimerEventType>(c, event, "qt.QTimerEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTableView::timerEvent(event);
        }
    }

    void MuQt_QTableView::updateGeometries()
    {
        if (!_env)
        {
            QTableView::updateGeometries();
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[17];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTableView::updateGeometries();
        }
    }

    int MuQt_QTableView::verticalOffset() const
    {
        if (!_env)
            return QTableView::verticalOffset();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[18];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return (int)(rval._int);
        }
        else
        {
            return QTableView::verticalOffset();
        }
    }

    QSize MuQt_QTableView::viewportSizeHint() const
    {
        if (!_env)
            return QTableView::viewportSizeHint();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[19];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return getqtype<QSizeType>(rval._Pointer);
        }
        else
        {
            return QTableView::viewportSizeHint();
        }
    }

    QRegion MuQt_QTableView::visualRegionForSelection(
        const QItemSelection& selection) const
    {
        if (!_env)
            return QTableView::visualRegionForSelection(selection);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[20];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqtype<QItemSelectionType>(c, selection,
                                                          "qt.QItemSelection"));
            Value rval = _env->call(F, args);
            return getqtype<QRegionType>(rval._Pointer);
        }
        else
        {
            return QTableView::visualRegionForSelection(selection);
        }
    }

    void MuQt_QTableView::keyboardSearch(const QString& search)
    {
        if (!_env)
        {
            QTableView::keyboardSearch(search);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[21];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makestring(c, search));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTableView::keyboardSearch(search);
        }
    }

    QVariant MuQt_QTableView::inputMethodQuery(Qt::InputMethodQuery query) const
    {
        if (!_env)
            return QTableView::inputMethodQuery(query);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[22];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(int(query));
            Value rval = _env->call(F, args);
            return getqtype<QVariantType>(rval._Pointer);
        }
        else
        {
            return QTableView::inputMethodQuery(query);
        }
    }

    bool MuQt_QTableView::edit(const QModelIndex& index,
                               QAbstractItemView::EditTrigger trigger,
                               QEvent* event)
    {
        if (!_env)
            return QTableView::edit(index, trigger, event);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[23];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(4);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, index, "qt.QModelIndex"));
            args[2] = Value(int(trigger));
            args[3] = Value(makeqpointer<QEventType>(c, event, "qt.QEvent"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QTableView::edit(index, trigger, event);
        }
    }

    QItemSelectionModel::SelectionFlags
    MuQt_QTableView::selectionCommand(const QModelIndex& index,
                                      const QEvent* event) const
    {
        if (!_env)
            return QTableView::selectionCommand(index, event);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[24];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(3);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqtype<QModelIndexType>(c, index, "qt.QModelIndex"));
            args[2] = Value(makeqpointer<QEventType>(c, event, "qt.QEvent"));
            Value rval = _env->call(F, args);
            return (QItemSelectionModel::SelectionFlags)(rval._int);
        }
        else
        {
            return QTableView::selectionCommand(index, event);
        }
    }

    void MuQt_QTableView::startDrag(Qt::DropActions supportedActions)
    {
        if (!_env)
        {
            QTableView::startDrag(supportedActions);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[25];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(int(supportedActions));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTableView::startDrag(supportedActions);
        }
    }

    void MuQt_QTableView::dragEnterEvent(QDragEnterEvent* event)
    {
        if (!_env)
        {
            QTableView::dragEnterEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[26];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QDragEnterEventType>(
                c, event, "qt.QDragEnterEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTableView::dragEnterEvent(event);
        }
    }

    void MuQt_QTableView::dragLeaveEvent(QDragLeaveEvent* event)
    {
        if (!_env)
        {
            QTableView::dragLeaveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[27];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QDragLeaveEventType>(
                c, event, "qt.QDragLeaveEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTableView::dragLeaveEvent(event);
        }
    }

    void MuQt_QTableView::dragMoveEvent(QDragMoveEvent* event)
    {
        if (!_env)
        {
            QTableView::dragMoveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[28];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QDragMoveEventType>(
                c, event, "qt.QDragMoveEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTableView::dragMoveEvent(event);
        }
    }

    void MuQt_QTableView::dropEvent(QDropEvent* event)
    {
        if (!_env)
        {
            QTableView::dropEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[29];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QDropEventType>(c, event, "qt.QDropEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTableView::dropEvent(event);
        }
    }

    bool MuQt_QTableView::event(QEvent* event_)
    {
        if (!_env)
            return QTableView::event(event_);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[30];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, event_, "qt.QEvent"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QTableView::event(event_);
        }
    }

    bool MuQt_QTableView::eventFilter(QObject* object, QEvent* event)
    {
        if (!_env)
            return QTableView::eventFilter(object, event);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[31];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(3);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeinstance<QObjectType>(c, object, "qt.QObject"));
            args[2] = Value(makeqpointer<QEventType>(c, event, "qt.QEvent"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QTableView::eventFilter(object, event);
        }
    }

    void MuQt_QTableView::focusInEvent(QFocusEvent* event)
    {
        if (!_env)
        {
            QTableView::focusInEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[32];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QFocusEventType>(c, event, "qt.QFocusEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTableView::focusInEvent(event);
        }
    }

    bool MuQt_QTableView::focusNextPrevChild(bool next)
    {
        if (!_env)
            return QTableView::focusNextPrevChild(next);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[33];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(next);
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QTableView::focusNextPrevChild(next);
        }
    }

    void MuQt_QTableView::focusOutEvent(QFocusEvent* event)
    {
        if (!_env)
        {
            QTableView::focusOutEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[34];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QFocusEventType>(c, event, "qt.QFocusEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTableView::focusOutEvent(event);
        }
    }

    void MuQt_QTableView::keyPressEvent(QKeyEvent* event)
    {
        if (!_env)
        {
            QTableView::keyPressEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[35];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QKeyEventType>(c, event, "qt.QKeyEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTableView::keyPressEvent(event);
        }
    }

    void MuQt_QTableView::mouseDoubleClickEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QTableView::mouseDoubleClickEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[36];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTableView::mouseDoubleClickEvent(event);
        }
    }

    void MuQt_QTableView::mouseMoveEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QTableView::mouseMoveEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[37];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTableView::mouseMoveEvent(event);
        }
    }

    void MuQt_QTableView::mousePressEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QTableView::mousePressEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[38];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTableView::mousePressEvent(event);
        }
    }

    void MuQt_QTableView::mouseReleaseEvent(QMouseEvent* event)
    {
        if (!_env)
        {
            QTableView::mouseReleaseEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[39];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QMouseEventType>(c, event, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTableView::mouseReleaseEvent(event);
        }
    }

    void MuQt_QTableView::resizeEvent(QResizeEvent* event)
    {
        if (!_env)
        {
            QTableView::resizeEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[40];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QResizeEventType>(c, event, "qt.QResizeEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTableView::resizeEvent(event);
        }
    }

    bool MuQt_QTableView::viewportEvent(QEvent* event)
    {
        if (!_env)
            return QTableView::viewportEvent(event);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[41];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, event, "qt.QEvent"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QTableView::viewportEvent(event);
        }
    }

    //----------------------------------------------------------------------
    //  Mu Type CONSTRUCTORS

    QTableViewType::QTableViewType(Context* c, const char* name, Class* super,
                                   Class* super2)
        : Class(c, name, vectorOf2(super, super2))
    {
    }

    QTableViewType::~QTableViewType() {}

    //----------------------------------------------------------------------
    //  PRE-COMPILED FUNCTIONS

    static Pointer QTableView_QTableView_QObject(Thread& NODE_THREAD,
                                                 Pointer obj)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        ClassInstance* widget = reinterpret_cast<ClassInstance*>(obj);

        if (!widget)
        {
            return 0;
        }
        else if (QTableView* w = object<QTableView>(widget))
        {
            QTableViewType* type =
                c->findSymbolOfTypeByQualifiedName<QTableViewType>(
                    c->internName("qt.QTableView"), false);
            ClassInstance* o = ClassInstance::allocate(type);
            setobject(o, w);
            return o;
        }
        else
        {
            throw BadCastException();
        }
    }

    static NODE_IMPLEMENTATION(castFromObject, Pointer)
    {
        NODE_RETURN(
            QTableView_QTableView_QObject(NODE_THREAD, NODE_ARG(0, Pointer)));
    }

    Pointer qt_QTableView_QTableView_QTableView_QTableView_QWidget(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QWidget* arg1 = object<QWidget>(param_parent);
        setobject(param_this,
                  new MuQt_QTableView(param_this,
                                      NODE_THREAD.process()->callEnv(), arg1));
        return param_this;
    }

    void qt_QTableView_clearSpans_void_QTableView(Mu::Thread& NODE_THREAD,
                                                  Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        arg0->clearSpans();
    }

    int qt_QTableView_columnAt_int_QTableView_int(Mu::Thread& NODE_THREAD,
                                                  Pointer param_this,
                                                  int param_x)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        int arg1 = (int)(param_x);
        return arg0->columnAt(arg1);
    }

    int qt_QTableView_columnSpan_int_QTableView_int_int(Mu::Thread& NODE_THREAD,
                                                        Pointer param_this,
                                                        int param_row,
                                                        int param_column)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        int arg1 = (int)(param_row);
        int arg2 = (int)(param_column);
        return arg0->columnSpan(arg1, arg2);
    }

    int qt_QTableView_columnViewportPosition_int_QTableView_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_column)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        int arg1 = (int)(param_column);
        return arg0->columnViewportPosition(arg1);
    }

    int qt_QTableView_columnWidth_int_QTableView_int(Mu::Thread& NODE_THREAD,
                                                     Pointer param_this,
                                                     int param_column)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        int arg1 = (int)(param_column);
        return arg0->columnWidth(arg1);
    }

    Pointer qt_QTableView_horizontalHeader_QHeaderView_QTableView(
        Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        return makeinstance<QHeaderViewType>(c, arg0->horizontalHeader(),
                                             "qt.QHeaderView");
    }

    bool qt_QTableView_isColumnHidden_bool_QTableView_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_column)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        int arg1 = (int)(param_column);
        return arg0->isColumnHidden(arg1);
    }

    bool qt_QTableView_isRowHidden_bool_QTableView_int(Mu::Thread& NODE_THREAD,
                                                       Pointer param_this,
                                                       int param_row)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        int arg1 = (int)(param_row);
        return arg0->isRowHidden(arg1);
    }

    int qt_QTableView_rowAt_int_QTableView_int(Mu::Thread& NODE_THREAD,
                                               Pointer param_this, int param_y)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        int arg1 = (int)(param_y);
        return arg0->rowAt(arg1);
    }

    int qt_QTableView_rowHeight_int_QTableView_int(Mu::Thread& NODE_THREAD,
                                                   Pointer param_this,
                                                   int param_row)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        int arg1 = (int)(param_row);
        return arg0->rowHeight(arg1);
    }

    int qt_QTableView_rowSpan_int_QTableView_int_int(Mu::Thread& NODE_THREAD,
                                                     Pointer param_this,
                                                     int param_row,
                                                     int param_column)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        int arg1 = (int)(param_row);
        int arg2 = (int)(param_column);
        return arg0->rowSpan(arg1, arg2);
    }

    int qt_QTableView_rowViewportPosition_int_QTableView_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_row)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        int arg1 = (int)(param_row);
        return arg0->rowViewportPosition(arg1);
    }

    void qt_QTableView_setColumnHidden_void_QTableView_int_bool(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_column,
        bool param_hide)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        int arg1 = (int)(param_column);
        bool arg2 = (bool)(param_hide);
        arg0->setColumnHidden(arg1, arg2);
    }

    void qt_QTableView_setColumnWidth_void_QTableView_int_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_column,
        int param_width)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        int arg1 = (int)(param_column);
        int arg2 = (int)(param_width);
        arg0->setColumnWidth(arg1, arg2);
    }

    void qt_QTableView_setHorizontalHeader_void_QTableView_QHeaderView(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_header)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        QHeaderView* arg1 = object<QHeaderView>(param_header);
        arg0->setHorizontalHeader(arg1);
    }

    void qt_QTableView_setRowHeight_void_QTableView_int_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_row,
        int param_height)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        int arg1 = (int)(param_row);
        int arg2 = (int)(param_height);
        arg0->setRowHeight(arg1, arg2);
    }

    void qt_QTableView_setRowHidden_void_QTableView_int_bool(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_row,
        bool param_hide)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        int arg1 = (int)(param_row);
        bool arg2 = (bool)(param_hide);
        arg0->setRowHidden(arg1, arg2);
    }

    void qt_QTableView_setSortingEnabled_void_QTableView_bool(
        Mu::Thread& NODE_THREAD, Pointer param_this, bool param_enable)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        bool arg1 = (bool)(param_enable);
        arg0->setSortingEnabled(arg1);
    }

    void qt_QTableView_setSpan_void_QTableView_int_int_int_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_row,
        int param_column, int param_rowSpanCount, int param_columnSpanCount)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        int arg1 = (int)(param_row);
        int arg2 = (int)(param_column);
        int arg3 = (int)(param_rowSpanCount);
        int arg4 = (int)(param_columnSpanCount);
        arg0->setSpan(arg1, arg2, arg3, arg4);
    }

    void qt_QTableView_setVerticalHeader_void_QTableView_QHeaderView(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_header)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        QHeaderView* arg1 = object<QHeaderView>(param_header);
        arg0->setVerticalHeader(arg1);
    }

    Pointer
    qt_QTableView_verticalHeader_QHeaderView_QTableView(Mu::Thread& NODE_THREAD,
                                                        Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        return makeinstance<QHeaderViewType>(c, arg0->verticalHeader(),
                                             "qt.QHeaderView");
    }

    Pointer qt_QTableView_indexAt_QModelIndex_QTableView_QPoint(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_pos)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        const QPoint arg1 = getqtype<QPointType>(param_pos);
        return isMuQtObject(arg0)
                   ? makeqtype<QModelIndexType>(
                         c, arg0->QTableView::indexAt(arg1), "qt.QModelIndex")
                   : makeqtype<QModelIndexType>(c, arg0->indexAt(arg1),
                                                "qt.QModelIndex");
    }

    void qt_QTableView_scrollTo_void_QTableView_QModelIndex_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_index,
        int param_hint)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_index);
        QAbstractItemView::ScrollHint arg2 =
            (QAbstractItemView::ScrollHint)(param_hint);
        if (isMuQtObject(arg0))
            arg0->QTableView::scrollTo(arg1, arg2);
        else
            arg0->scrollTo(arg1, arg2);
    }

    void qt_QTableView_setModel_void_QTableView_QAbstractItemModel(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_model)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        QAbstractItemModel* arg1 = object<QAbstractItemModel>(param_model);
        if (isMuQtObject(arg0))
            arg0->QTableView::setModel(arg1);
        else
            arg0->setModel(arg1);
    }

    void qt_QTableView_setRootIndex_void_QTableView_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_index)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_index);
        if (isMuQtObject(arg0))
            arg0->QTableView::setRootIndex(arg1);
        else
            arg0->setRootIndex(arg1);
    }

    void qt_QTableView_setSelectionModel_void_QTableView_QItemSelectionModel(
        Mu::Thread& NODE_THREAD, Pointer param_this,
        Pointer param_selectionModel)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        QItemSelectionModel* arg1 =
            object<QItemSelectionModel>(param_selectionModel);
        if (isMuQtObject(arg0))
            arg0->QTableView::setSelectionModel(arg1);
        else
            arg0->setSelectionModel(arg1);
    }

    Pointer qt_QTableView_visualRect_QRect_QTableView_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_index)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_index);
        return isMuQtObject(arg0)
                   ? makeqtype<QRectType>(c, arg0->QTableView::visualRect(arg1),
                                          "qt.QRect")
                   : makeqtype<QRectType>(c, arg0->visualRect(arg1),
                                          "qt.QRect");
    }

    void qt_QTableView_currentChanged_void_QTableView_QModelIndex_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_current,
        Pointer param_previous)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_current);
        const QModelIndex arg2 = getqtype<QModelIndexType>(param_previous);
        if (isMuQtObject(arg0))
            ((MuQt_QTableView*)arg0)->currentChanged_pub_parent(arg1, arg2);
        else
            ((MuQt_QTableView*)arg0)->currentChanged_pub(arg1, arg2);
    }

    int qt_QTableView_horizontalOffset_int_QTableView(Mu::Thread& NODE_THREAD,
                                                      Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        return isMuQtObject(arg0)
                   ? ((MuQt_QTableView*)arg0)->horizontalOffset_pub_parent()
                   : ((MuQt_QTableView*)arg0)->horizontalOffset_pub();
    }

    bool qt_QTableView_isIndexHidden_bool_QTableView_QModelIndex(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_index)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_index);
        return isMuQtObject(arg0)
                   ? ((MuQt_QTableView*)arg0)->isIndexHidden_pub_parent(arg1)
                   : ((MuQt_QTableView*)arg0)->isIndexHidden_pub(arg1);
    }

    void qt_QTableView_paintEvent_void_QTableView_QPaintEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        QPaintEvent* arg1 = getqpointer<QPaintEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QTableView*)arg0)->paintEvent_pub_parent(arg1);
        else
            ((MuQt_QTableView*)arg0)->paintEvent_pub(arg1);
    }

    void qt_QTableView_scrollContentsBy_void_QTableView_int_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_dx, int param_dy)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        int arg1 = (int)(param_dx);
        int arg2 = (int)(param_dy);
        if (isMuQtObject(arg0))
            ((MuQt_QTableView*)arg0)->scrollContentsBy_pub_parent(arg1, arg2);
        else
            ((MuQt_QTableView*)arg0)->scrollContentsBy_pub(arg1, arg2);
    }

    Pointer qt_QTableView_selectedIndexes_qt__QModelIndexBSB_ESB__QTableView(
        Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        return isMuQtObject(arg0)
                   ? makeqmodelindexlist(
                         c,
                         ((MuQt_QTableView*)arg0)->selectedIndexes_pub_parent())
                   : makeqmodelindexlist(
                         c, ((MuQt_QTableView*)arg0)->selectedIndexes_pub());
    }

    void
    qt_QTableView_selectionChanged_void_QTableView_QItemSelection_QItemSelection(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_selected,
        Pointer param_deselected)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        const QItemSelection arg1 =
            getqtype<QItemSelectionType>(param_selected);
        const QItemSelection arg2 =
            getqtype<QItemSelectionType>(param_deselected);
        if (isMuQtObject(arg0))
            ((MuQt_QTableView*)arg0)->selectionChanged_pub_parent(arg1, arg2);
        else
            ((MuQt_QTableView*)arg0)->selectionChanged_pub(arg1, arg2);
    }

    void qt_QTableView_setSelection_void_QTableView_QRect_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_rect,
        int param_flags)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        const QRect arg1 = getqtype<QRectType>(param_rect);
        QItemSelectionModel::SelectionFlags arg2 =
            (QItemSelectionModel::SelectionFlags)(param_flags);
        if (isMuQtObject(arg0))
            ((MuQt_QTableView*)arg0)->setSelection_pub_parent(arg1, arg2);
        else
            ((MuQt_QTableView*)arg0)->setSelection_pub(arg1, arg2);
    }

    int qt_QTableView_sizeHintForColumn_int_QTableView_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_column)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        int arg1 = (int)(param_column);
        return isMuQtObject(arg0)
                   ? ((MuQt_QTableView*)arg0)
                         ->sizeHintForColumn_pub_parent(arg1)
                   : ((MuQt_QTableView*)arg0)->sizeHintForColumn_pub(arg1);
    }

    int qt_QTableView_sizeHintForRow_int_QTableView_int(Mu::Thread& NODE_THREAD,
                                                        Pointer param_this,
                                                        int param_row)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        int arg1 = (int)(param_row);
        return isMuQtObject(arg0)
                   ? ((MuQt_QTableView*)arg0)->sizeHintForRow_pub_parent(arg1)
                   : ((MuQt_QTableView*)arg0)->sizeHintForRow_pub(arg1);
    }

    void qt_QTableView_timerEvent_void_QTableView_QTimerEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        QTimerEvent* arg1 = getqpointer<QTimerEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QTableView*)arg0)->timerEvent_pub_parent(arg1);
        else
            ((MuQt_QTableView*)arg0)->timerEvent_pub(arg1);
    }

    void qt_QTableView_updateGeometries_void_QTableView(Mu::Thread& NODE_THREAD,
                                                        Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        if (isMuQtObject(arg0))
            ((MuQt_QTableView*)arg0)->updateGeometries_pub_parent();
        else
            ((MuQt_QTableView*)arg0)->updateGeometries_pub();
    }

    int qt_QTableView_verticalOffset_int_QTableView(Mu::Thread& NODE_THREAD,
                                                    Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        return isMuQtObject(arg0)
                   ? ((MuQt_QTableView*)arg0)->verticalOffset_pub_parent()
                   : ((MuQt_QTableView*)arg0)->verticalOffset_pub();
    }

    Pointer
    qt_QTableView_viewportSizeHint_QSize_QTableView(Mu::Thread& NODE_THREAD,
                                                    Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        return isMuQtObject(arg0)
                   ? makeqtype<QSizeType>(c,
                                          ((MuQt_QTableView*)arg0)
                                              ->viewportSizeHint_pub_parent(),
                                          "qt.QSize")
                   : makeqtype<QSizeType>(
                         c, ((MuQt_QTableView*)arg0)->viewportSizeHint_pub(),
                         "qt.QSize");
    }

    Pointer
    qt_QTableView_visualRegionForSelection_QRegion_QTableView_QItemSelection(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_selection)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        const QItemSelection arg1 =
            getqtype<QItemSelectionType>(param_selection);
        return isMuQtObject(arg0)
                   ? makeqtype<QRegionType>(
                         c,
                         ((MuQt_QTableView*)arg0)
                             ->visualRegionForSelection_pub_parent(arg1),
                         "qt.QRegion")
                   : makeqtype<QRegionType>(
                         c,
                         ((MuQt_QTableView*)arg0)
                             ->visualRegionForSelection_pub(arg1),
                         "qt.QRegion");
    }

    void qt_QTableView_keyboardSearch_void_QTableView_string(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_search)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        const QString arg1 = qstring(param_search);
        if (isMuQtObject(arg0))
            arg0->QTableView::keyboardSearch(arg1);
        else
            arg0->keyboardSearch(arg1);
    }

    Pointer qt_QTableView_inputMethodQuery_QVariant_QTableView_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_query)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        Qt::InputMethodQuery arg1 = (Qt::InputMethodQuery)(param_query);
        return isMuQtObject(arg0)
                   ? makeqtype<QVariantType>(
                         c, arg0->QTableView::inputMethodQuery(arg1),
                         "qt.QVariant")
                   : makeqtype<QVariantType>(c, arg0->inputMethodQuery(arg1),
                                             "qt.QVariant");
    }

    bool qt_QTableView_edit_bool_QTableView_QModelIndex_int_QEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_index,
        int param_trigger, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_index);
        QAbstractItemView::EditTrigger arg2 =
            (QAbstractItemView::EditTrigger)(param_trigger);
        QEvent* arg3 = getqpointer<QEventType>(param_event);
        return isMuQtObject(arg0)
                   ? ((MuQt_QTableView*)arg0)->edit_pub_parent(arg1, arg2, arg3)
                   : ((MuQt_QTableView*)arg0)->edit_pub(arg1, arg2, arg3);
    }

    int qt_QTableView_selectionCommand_int_QTableView_QModelIndex_QEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_index,
        Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        const QModelIndex arg1 = getqtype<QModelIndexType>(param_index);
        const QEvent* arg2 = getqpointer<QEventType>(param_event);
        return isMuQtObject(arg0)
                   ? int(((MuQt_QTableView*)arg0)
                             ->selectionCommand_pub_parent(arg1, arg2))
                   : int(((MuQt_QTableView*)arg0)
                             ->selectionCommand_pub(arg1, arg2));
    }

    void qt_QTableView_startDrag_void_QTableView_int(Mu::Thread& NODE_THREAD,
                                                     Pointer param_this,
                                                     int param_supportedActions)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        Qt::DropActions arg1 = (Qt::DropActions)(param_supportedActions);
        if (isMuQtObject(arg0))
            ((MuQt_QTableView*)arg0)->startDrag_pub_parent(arg1);
        else
            ((MuQt_QTableView*)arg0)->startDrag_pub(arg1);
    }

    void qt_QTableView_dragEnterEvent_void_QTableView_QDragEnterEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        QDragEnterEvent* arg1 = getqpointer<QDragEnterEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QTableView*)arg0)->dragEnterEvent_pub_parent(arg1);
        else
            ((MuQt_QTableView*)arg0)->dragEnterEvent_pub(arg1);
    }

    void qt_QTableView_dragLeaveEvent_void_QTableView_QDragLeaveEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        QDragLeaveEvent* arg1 = getqpointer<QDragLeaveEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QTableView*)arg0)->dragLeaveEvent_pub_parent(arg1);
        else
            ((MuQt_QTableView*)arg0)->dragLeaveEvent_pub(arg1);
    }

    void qt_QTableView_dragMoveEvent_void_QTableView_QDragMoveEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        QDragMoveEvent* arg1 = getqpointer<QDragMoveEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QTableView*)arg0)->dragMoveEvent_pub_parent(arg1);
        else
            ((MuQt_QTableView*)arg0)->dragMoveEvent_pub(arg1);
    }

    void qt_QTableView_dropEvent_void_QTableView_QDropEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        QDropEvent* arg1 = getqpointer<QDropEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QTableView*)arg0)->dropEvent_pub_parent(arg1);
        else
            ((MuQt_QTableView*)arg0)->dropEvent_pub(arg1);
    }

    bool qt_QTableView_event_bool_QTableView_QEvent(Mu::Thread& NODE_THREAD,
                                                    Pointer param_this,
                                                    Pointer param_event_)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_event_);
        return isMuQtObject(arg0)
                   ? ((MuQt_QTableView*)arg0)->event_pub_parent(arg1)
                   : ((MuQt_QTableView*)arg0)->event_pub(arg1);
    }

    bool qt_QTableView_eventFilter_bool_QTableView_QObject_QEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_object,
        Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        QObject* arg1 = object<QObject>(param_object);
        QEvent* arg2 = getqpointer<QEventType>(param_event);
        return isMuQtObject(arg0)
                   ? ((MuQt_QTableView*)arg0)
                         ->eventFilter_pub_parent(arg1, arg2)
                   : ((MuQt_QTableView*)arg0)->eventFilter_pub(arg1, arg2);
    }

    void qt_QTableView_focusInEvent_void_QTableView_QFocusEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        QFocusEvent* arg1 = getqpointer<QFocusEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QTableView*)arg0)->focusInEvent_pub_parent(arg1);
        else
            ((MuQt_QTableView*)arg0)->focusInEvent_pub(arg1);
    }

    bool qt_QTableView_focusNextPrevChild_bool_QTableView_bool(
        Mu::Thread& NODE_THREAD, Pointer param_this, bool param_next)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        bool arg1 = (bool)(param_next);
        return isMuQtObject(arg0)
                   ? ((MuQt_QTableView*)arg0)
                         ->focusNextPrevChild_pub_parent(arg1)
                   : ((MuQt_QTableView*)arg0)->focusNextPrevChild_pub(arg1);
    }

    void qt_QTableView_focusOutEvent_void_QTableView_QFocusEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        QFocusEvent* arg1 = getqpointer<QFocusEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QTableView*)arg0)->focusOutEvent_pub_parent(arg1);
        else
            ((MuQt_QTableView*)arg0)->focusOutEvent_pub(arg1);
    }

    void qt_QTableView_keyPressEvent_void_QTableView_QKeyEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        QKeyEvent* arg1 = getqpointer<QKeyEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QTableView*)arg0)->keyPressEvent_pub_parent(arg1);
        else
            ((MuQt_QTableView*)arg0)->keyPressEvent_pub(arg1);
    }

    void qt_QTableView_mouseDoubleClickEvent_void_QTableView_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QTableView*)arg0)->mouseDoubleClickEvent_pub_parent(arg1);
        else
            ((MuQt_QTableView*)arg0)->mouseDoubleClickEvent_pub(arg1);
    }

    void qt_QTableView_mouseMoveEvent_void_QTableView_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QTableView*)arg0)->mouseMoveEvent_pub_parent(arg1);
        else
            ((MuQt_QTableView*)arg0)->mouseMoveEvent_pub(arg1);
    }

    void qt_QTableView_mousePressEvent_void_QTableView_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QTableView*)arg0)->mousePressEvent_pub_parent(arg1);
        else
            ((MuQt_QTableView*)arg0)->mousePressEvent_pub(arg1);
    }

    void qt_QTableView_mouseReleaseEvent_void_QTableView_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QTableView*)arg0)->mouseReleaseEvent_pub_parent(arg1);
        else
            ((MuQt_QTableView*)arg0)->mouseReleaseEvent_pub(arg1);
    }

    void qt_QTableView_resizeEvent_void_QTableView_QResizeEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        QResizeEvent* arg1 = getqpointer<QResizeEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QTableView*)arg0)->resizeEvent_pub_parent(arg1);
        else
            ((MuQt_QTableView*)arg0)->resizeEvent_pub(arg1);
    }

    bool qt_QTableView_viewportEvent_bool_QTableView_QEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTableView* arg0 = object<QTableView>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_event);
        return isMuQtObject(arg0)
                   ? ((MuQt_QTableView*)arg0)->viewportEvent_pub_parent(arg1)
                   : ((MuQt_QTableView*)arg0)->viewportEvent_pub(arg1);
    }

    static NODE_IMPLEMENTATION(_n_QTableView0, Pointer)
    {
        NODE_RETURN(qt_QTableView_QTableView_QTableView_QTableView_QWidget(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_clearSpans0, void)
    {
        qt_QTableView_clearSpans_void_QTableView(NODE_THREAD,
                                                 NONNIL_NODE_ARG(0, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_columnAt0, int)
    {
        NODE_RETURN(qt_QTableView_columnAt_int_QTableView_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_columnSpan0, int)
    {
        NODE_RETURN(qt_QTableView_columnSpan_int_QTableView_int_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
            NODE_ARG(2, int)));
    }

    static NODE_IMPLEMENTATION(_n_columnViewportPosition0, int)
    {
        NODE_RETURN(qt_QTableView_columnViewportPosition_int_QTableView_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_columnWidth0, int)
    {
        NODE_RETURN(qt_QTableView_columnWidth_int_QTableView_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_horizontalHeader0, Pointer)
    {
        NODE_RETURN(qt_QTableView_horizontalHeader_QHeaderView_QTableView(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_isColumnHidden0, bool)
    {
        NODE_RETURN(qt_QTableView_isColumnHidden_bool_QTableView_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_isRowHidden0, bool)
    {
        NODE_RETURN(qt_QTableView_isRowHidden_bool_QTableView_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_rowAt0, int)
    {
        NODE_RETURN(qt_QTableView_rowAt_int_QTableView_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_rowHeight0, int)
    {
        NODE_RETURN(qt_QTableView_rowHeight_int_QTableView_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_rowSpan0, int)
    {
        NODE_RETURN(qt_QTableView_rowSpan_int_QTableView_int_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
            NODE_ARG(2, int)));
    }

    static NODE_IMPLEMENTATION(_n_rowViewportPosition0, int)
    {
        NODE_RETURN(qt_QTableView_rowViewportPosition_int_QTableView_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_setColumnHidden0, void)
    {
        qt_QTableView_setColumnHidden_void_QTableView_int_bool(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
            NODE_ARG(2, bool));
    }

    static NODE_IMPLEMENTATION(_n_setColumnWidth0, void)
    {
        qt_QTableView_setColumnWidth_void_QTableView_int_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
            NODE_ARG(2, int));
    }

    static NODE_IMPLEMENTATION(_n_setHorizontalHeader0, void)
    {
        qt_QTableView_setHorizontalHeader_void_QTableView_QHeaderView(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_setRowHeight0, void)
    {
        qt_QTableView_setRowHeight_void_QTableView_int_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
            NODE_ARG(2, int));
    }

    static NODE_IMPLEMENTATION(_n_setRowHidden0, void)
    {
        qt_QTableView_setRowHidden_void_QTableView_int_bool(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
            NODE_ARG(2, bool));
    }

    static NODE_IMPLEMENTATION(_n_setSortingEnabled0, void)
    {
        qt_QTableView_setSortingEnabled_void_QTableView_bool(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, bool));
    }

    static NODE_IMPLEMENTATION(_n_setSpan0, void)
    {
        qt_QTableView_setSpan_void_QTableView_int_int_int_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
            NODE_ARG(2, int), NODE_ARG(3, int), NODE_ARG(4, int));
    }

    static NODE_IMPLEMENTATION(_n_setVerticalHeader0, void)
    {
        qt_QTableView_setVerticalHeader_void_QTableView_QHeaderView(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_verticalHeader0, Pointer)
    {
        NODE_RETURN(qt_QTableView_verticalHeader_QHeaderView_QTableView(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_indexAt0, Pointer)
    {
        NODE_RETURN(qt_QTableView_indexAt_QModelIndex_QTableView_QPoint(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_scrollTo0, void)
    {
        qt_QTableView_scrollTo_void_QTableView_QModelIndex_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, int));
    }

    static NODE_IMPLEMENTATION(_n_setModel0, void)
    {
        qt_QTableView_setModel_void_QTableView_QAbstractItemModel(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_setRootIndex0, void)
    {
        qt_QTableView_setRootIndex_void_QTableView_QModelIndex(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_setSelectionModel0, void)
    {
        qt_QTableView_setSelectionModel_void_QTableView_QItemSelectionModel(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_visualRect0, Pointer)
    {
        NODE_RETURN(qt_QTableView_visualRect_QRect_QTableView_QModelIndex(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_currentChanged0, void)
    {
        qt_QTableView_currentChanged_void_QTableView_QModelIndex_QModelIndex(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_horizontalOffset0, int)
    {
        NODE_RETURN(qt_QTableView_horizontalOffset_int_QTableView(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_isIndexHidden0, bool)
    {
        NODE_RETURN(qt_QTableView_isIndexHidden_bool_QTableView_QModelIndex(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_paintEvent0, void)
    {
        qt_QTableView_paintEvent_void_QTableView_QPaintEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_scrollContentsBy0, void)
    {
        qt_QTableView_scrollContentsBy_void_QTableView_int_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
            NODE_ARG(2, int));
    }

    static NODE_IMPLEMENTATION(_n_selectedIndexes0, Pointer)
    {
        NODE_RETURN(
            qt_QTableView_selectedIndexes_qt__QModelIndexBSB_ESB__QTableView(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_selectionChanged0, void)
    {
        qt_QTableView_selectionChanged_void_QTableView_QItemSelection_QItemSelection(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_setSelection0, void)
    {
        qt_QTableView_setSelection_void_QTableView_QRect_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, int));
    }

    static NODE_IMPLEMENTATION(_n_sizeHintForColumn0, int)
    {
        NODE_RETURN(qt_QTableView_sizeHintForColumn_int_QTableView_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_sizeHintForRow0, int)
    {
        NODE_RETURN(qt_QTableView_sizeHintForRow_int_QTableView_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_timerEvent0, void)
    {
        qt_QTableView_timerEvent_void_QTableView_QTimerEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_updateGeometries0, void)
    {
        qt_QTableView_updateGeometries_void_QTableView(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_verticalOffset0, int)
    {
        NODE_RETURN(qt_QTableView_verticalOffset_int_QTableView(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_viewportSizeHint0, Pointer)
    {
        NODE_RETURN(qt_QTableView_viewportSizeHint_QSize_QTableView(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_visualRegionForSelection0, Pointer)
    {
        NODE_RETURN(
            qt_QTableView_visualRegionForSelection_QRegion_QTableView_QItemSelection(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer),
                NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_keyboardSearch0, void)
    {
        qt_QTableView_keyboardSearch_void_QTableView_string(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_inputMethodQuery0, Pointer)
    {
        NODE_RETURN(qt_QTableView_inputMethodQuery_QVariant_QTableView_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_edit0, bool)
    {
        NODE_RETURN(qt_QTableView_edit_bool_QTableView_QModelIndex_int_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, int), NODE_ARG(3, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_selectionCommand0, int)
    {
        NODE_RETURN(
            qt_QTableView_selectionCommand_int_QTableView_QModelIndex_QEvent(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
                NODE_ARG(2, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_startDrag0, void)
    {
        qt_QTableView_startDrag_void_QTableView_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int));
    }

    static NODE_IMPLEMENTATION(_n_dragEnterEvent0, void)
    {
        qt_QTableView_dragEnterEvent_void_QTableView_QDragEnterEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dragLeaveEvent0, void)
    {
        qt_QTableView_dragLeaveEvent_void_QTableView_QDragLeaveEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dragMoveEvent0, void)
    {
        qt_QTableView_dragMoveEvent_void_QTableView_QDragMoveEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dropEvent0, void)
    {
        qt_QTableView_dropEvent_void_QTableView_QDropEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_event0, bool)
    {
        NODE_RETURN(qt_QTableView_event_bool_QTableView_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_eventFilter0, bool)
    {
        NODE_RETURN(qt_QTableView_eventFilter_bool_QTableView_QObject_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_focusInEvent0, void)
    {
        qt_QTableView_focusInEvent_void_QTableView_QFocusEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_focusNextPrevChild0, bool)
    {
        NODE_RETURN(qt_QTableView_focusNextPrevChild_bool_QTableView_bool(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, bool)));
    }

    static NODE_IMPLEMENTATION(_n_focusOutEvent0, void)
    {
        qt_QTableView_focusOutEvent_void_QTableView_QFocusEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_keyPressEvent0, void)
    {
        qt_QTableView_keyPressEvent_void_QTableView_QKeyEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mouseDoubleClickEvent0, void)
    {
        qt_QTableView_mouseDoubleClickEvent_void_QTableView_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mouseMoveEvent0, void)
    {
        qt_QTableView_mouseMoveEvent_void_QTableView_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mousePressEvent0, void)
    {
        qt_QTableView_mousePressEvent_void_QTableView_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mouseReleaseEvent0, void)
    {
        qt_QTableView_mouseReleaseEvent_void_QTableView_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_resizeEvent0, void)
    {
        qt_QTableView_resizeEvent_void_QTableView_QResizeEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_viewportEvent0, bool)
    {
        NODE_RETURN(qt_QTableView_viewportEvent_bool_QTableView_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    void QTableViewType::load()
    {
        USING_MU_FUNCTION_SYMBOLS;
        MuLangContext* c = static_cast<MuLangContext*>(context());
        Module* global = globalModule();

        const string typeName = name();
        const string refTypeName = typeName + "&";
        const string fullTypeName = fullyQualifiedName();
        const string fullRefTypeName = fullTypeName + "&";
        const char* tn = typeName.c_str();
        const char* ftn = fullTypeName.c_str();
        const char* rtn = refTypeName.c_str();
        const char* frtn = fullRefTypeName.c_str();

        scope()->addSymbols(new ReferenceType(c, rtn, this),

                            new Function(c, tn, BaseFunctions::dereference,
                                         Cast, Return, ftn, Args, frtn, End),

                            EndArguments);

        addSymbols(new Function(c, "__allocate", BaseFunctions::classAllocate,
                                None, Return, ftn, End),

                   new Function(c, tn, castFromObject, Cast, Compiled,
                                QTableView_QTableView_QObject, Return, ftn,
                                Parameters,
                                new Param(c, "object", "qt.QObject"), End),

                   EndArguments);

        addSymbols(
            // enums
            // member functions
            new Function(c, "QTableView", _n_QTableView0, None, Compiled,
                         qt_QTableView_QTableView_QTableView_QTableView_QWidget,
                         Return, "qt.QTableView", Parameters,
                         new Param(c, "this", "qt.QTableView"),
                         new Param(c, "parent", "qt.QWidget"), End),
            new Function(c, "clearSpans", _n_clearSpans0, None, Compiled,
                         qt_QTableView_clearSpans_void_QTableView, Return,
                         "void", Parameters,
                         new Param(c, "this", "qt.QTableView"), End),
            new Function(c, "columnAt", _n_columnAt0, None, Compiled,
                         qt_QTableView_columnAt_int_QTableView_int, Return,
                         "int", Parameters,
                         new Param(c, "this", "qt.QTableView"),
                         new Param(c, "x", "int"), End),
            new Function(
                c, "columnSpan", _n_columnSpan0, None, Compiled,
                qt_QTableView_columnSpan_int_QTableView_int_int, Return, "int",
                Parameters, new Param(c, "this", "qt.QTableView"),
                new Param(c, "row", "int"), new Param(c, "column", "int"), End),
            new Function(
                c, "columnViewportPosition", _n_columnViewportPosition0, None,
                Compiled,
                qt_QTableView_columnViewportPosition_int_QTableView_int, Return,
                "int", Parameters, new Param(c, "this", "qt.QTableView"),
                new Param(c, "column", "int"), End),
            new Function(c, "columnWidth", _n_columnWidth0, None, Compiled,
                         qt_QTableView_columnWidth_int_QTableView_int, Return,
                         "int", Parameters,
                         new Param(c, "this", "qt.QTableView"),
                         new Param(c, "column", "int"), End),
            // PROP: gridStyle (flags Qt::PenStyle; QTableView this)
            new Function(c, "horizontalHeader", _n_horizontalHeader0, None,
                         Compiled,
                         qt_QTableView_horizontalHeader_QHeaderView_QTableView,
                         Return, "qt.QHeaderView", Parameters,
                         new Param(c, "this", "qt.QTableView"), End),
            new Function(
                c, "isColumnHidden", _n_isColumnHidden0, None, Compiled,
                qt_QTableView_isColumnHidden_bool_QTableView_int, Return,
                "bool", Parameters, new Param(c, "this", "qt.QTableView"),
                new Param(c, "column", "int"), End),
            // PROP: isCornerButtonEnabled (bool; QTableView this)
            new Function(c, "isRowHidden", _n_isRowHidden0, None, Compiled,
                         qt_QTableView_isRowHidden_bool_QTableView_int, Return,
                         "bool", Parameters,
                         new Param(c, "this", "qt.QTableView"),
                         new Param(c, "row", "int"), End),
            // PROP: isSortingEnabled (bool; QTableView this)
            new Function(c, "rowAt", _n_rowAt0, None, Compiled,
                         qt_QTableView_rowAt_int_QTableView_int, Return, "int",
                         Parameters, new Param(c, "this", "qt.QTableView"),
                         new Param(c, "y", "int"), End),
            new Function(c, "rowHeight", _n_rowHeight0, None, Compiled,
                         qt_QTableView_rowHeight_int_QTableView_int, Return,
                         "int", Parameters,
                         new Param(c, "this", "qt.QTableView"),
                         new Param(c, "row", "int"), End),
            new Function(
                c, "rowSpan", _n_rowSpan0, None, Compiled,
                qt_QTableView_rowSpan_int_QTableView_int_int, Return, "int",
                Parameters, new Param(c, "this", "qt.QTableView"),
                new Param(c, "row", "int"), new Param(c, "column", "int"), End),
            new Function(c, "rowViewportPosition", _n_rowViewportPosition0,
                         None, Compiled,
                         qt_QTableView_rowViewportPosition_int_QTableView_int,
                         Return, "int", Parameters,
                         new Param(c, "this", "qt.QTableView"),
                         new Param(c, "row", "int"), End),
            new Function(
                c, "setColumnHidden", _n_setColumnHidden0, None, Compiled,
                qt_QTableView_setColumnHidden_void_QTableView_int_bool, Return,
                "void", Parameters, new Param(c, "this", "qt.QTableView"),
                new Param(c, "column", "int"), new Param(c, "hide", "bool"),
                End),
            new Function(
                c, "setColumnWidth", _n_setColumnWidth0, None, Compiled,
                qt_QTableView_setColumnWidth_void_QTableView_int_int, Return,
                "void", Parameters, new Param(c, "this", "qt.QTableView"),
                new Param(c, "column", "int"), new Param(c, "width", "int"),
                End),
            // PROP: setCornerButtonEnabled (void; QTableView this, bool enable)
            // PROP: setGridStyle (void; QTableView this, flags Qt::PenStyle
            // style)
            new Function(
                c, "setHorizontalHeader", _n_setHorizontalHeader0, None,
                Compiled,
                qt_QTableView_setHorizontalHeader_void_QTableView_QHeaderView,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QTableView"),
                new Param(c, "header", "qt.QHeaderView"), End),
            new Function(
                c, "setRowHeight", _n_setRowHeight0, None, Compiled,
                qt_QTableView_setRowHeight_void_QTableView_int_int, Return,
                "void", Parameters, new Param(c, "this", "qt.QTableView"),
                new Param(c, "row", "int"), new Param(c, "height", "int"), End),
            new Function(
                c, "setRowHidden", _n_setRowHidden0, None, Compiled,
                qt_QTableView_setRowHidden_void_QTableView_int_bool, Return,
                "void", Parameters, new Param(c, "this", "qt.QTableView"),
                new Param(c, "row", "int"), new Param(c, "hide", "bool"), End),
            new Function(
                c, "setSortingEnabled", _n_setSortingEnabled0, None, Compiled,
                qt_QTableView_setSortingEnabled_void_QTableView_bool, Return,
                "void", Parameters, new Param(c, "this", "qt.QTableView"),
                new Param(c, "enable", "bool"), End),
            new Function(
                c, "setSpan", _n_setSpan0, None, Compiled,
                qt_QTableView_setSpan_void_QTableView_int_int_int_int, Return,
                "void", Parameters, new Param(c, "this", "qt.QTableView"),
                new Param(c, "row", "int"), new Param(c, "column", "int"),
                new Param(c, "rowSpanCount", "int"),
                new Param(c, "columnSpanCount", "int"), End),
            new Function(
                c, "setVerticalHeader", _n_setVerticalHeader0, None, Compiled,
                qt_QTableView_setVerticalHeader_void_QTableView_QHeaderView,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QTableView"),
                new Param(c, "header", "qt.QHeaderView"), End),
            // PROP: setWordWrap (void; QTableView this, bool on)
            // PROP: showGrid (bool; QTableView this)
            new Function(c, "verticalHeader", _n_verticalHeader0, None,
                         Compiled,
                         qt_QTableView_verticalHeader_QHeaderView_QTableView,
                         Return, "qt.QHeaderView", Parameters,
                         new Param(c, "this", "qt.QTableView"), End),
            // PROP: wordWrap (bool; QTableView this)
            _func[0] = new MemberFunction(
                c, "indexAt", _n_indexAt0, None, Compiled,
                qt_QTableView_indexAt_QModelIndex_QTableView_QPoint, Return,
                "qt.QModelIndex", Parameters,
                new Param(c, "this", "qt.QTableView"),
                new Param(c, "pos", "qt.QPoint"), End),
            _func[1] = new MemberFunction(
                c, "scrollTo", _n_scrollTo0, None, Compiled,
                qt_QTableView_scrollTo_void_QTableView_QModelIndex_int, Return,
                "void", Parameters, new Param(c, "this", "qt.QTableView"),
                new Param(c, "index", "qt.QModelIndex"),
                new Param(c, "hint", "int",
                          Value((int)QAbstractItemView::EnsureVisible)),
                End),
            _func[2] = new MemberFunction(
                c, "setModel", _n_setModel0, None, Compiled,
                qt_QTableView_setModel_void_QTableView_QAbstractItemModel,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QTableView"),
                new Param(c, "model", "qt.QAbstractItemModel"), End),
            _func[3] = new MemberFunction(
                c, "setRootIndex", _n_setRootIndex0, None, Compiled,
                qt_QTableView_setRootIndex_void_QTableView_QModelIndex, Return,
                "void", Parameters, new Param(c, "this", "qt.QTableView"),
                new Param(c, "index", "qt.QModelIndex"), End),
            _func[4] = new MemberFunction(
                c, "setSelectionModel", _n_setSelectionModel0, None, Compiled,
                qt_QTableView_setSelectionModel_void_QTableView_QItemSelectionModel,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QTableView"),
                new Param(c, "selectionModel", "qt.QItemSelectionModel"), End),
            _func[5] = new MemberFunction(
                c, "visualRect", _n_visualRect0, None, Compiled,
                qt_QTableView_visualRect_QRect_QTableView_QModelIndex, Return,
                "qt.QRect", Parameters, new Param(c, "this", "qt.QTableView"),
                new Param(c, "index", "qt.QModelIndex"), End),
            _func[6] = new MemberFunction(
                c, "currentChanged", _n_currentChanged0, None, Compiled,
                qt_QTableView_currentChanged_void_QTableView_QModelIndex_QModelIndex,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QTableView"),
                new Param(c, "current", "qt.QModelIndex"),
                new Param(c, "previous", "qt.QModelIndex"), End),
            _func[7] = new MemberFunction(
                c, "horizontalOffset", _n_horizontalOffset0, None, Compiled,
                qt_QTableView_horizontalOffset_int_QTableView, Return, "int",
                Parameters, new Param(c, "this", "qt.QTableView"), End),
            // MISSING: initViewItemOption (void; QTableView this,
            // "QStyleOptionViewItem *" option) // protected
            _func[8] = new MemberFunction(
                c, "isIndexHidden", _n_isIndexHidden0, None, Compiled,
                qt_QTableView_isIndexHidden_bool_QTableView_QModelIndex, Return,
                "bool", Parameters, new Param(c, "this", "qt.QTableView"),
                new Param(c, "index", "qt.QModelIndex"), End),
            _func[9] = new MemberFunction(
                c, "paintEvent", _n_paintEvent0, None, Compiled,
                qt_QTableView_paintEvent_void_QTableView_QPaintEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QTableView"),
                new Param(c, "event", "qt.QPaintEvent"), End),
            _func[10] = new MemberFunction(
                c, "scrollContentsBy", _n_scrollContentsBy0, None, Compiled,
                qt_QTableView_scrollContentsBy_void_QTableView_int_int, Return,
                "void", Parameters, new Param(c, "this", "qt.QTableView"),
                new Param(c, "dx", "int"), new Param(c, "dy", "int"), End),
            _func[11] = new MemberFunction(
                c, "selectedIndexes", _n_selectedIndexes0, None, Compiled,
                qt_QTableView_selectedIndexes_qt__QModelIndexBSB_ESB__QTableView,
                Return, "qt.QModelIndex[]", Parameters,
                new Param(c, "this", "qt.QTableView"), End),
            _func[12] = new MemberFunction(
                c, "selectionChanged", _n_selectionChanged0, None, Compiled,
                qt_QTableView_selectionChanged_void_QTableView_QItemSelection_QItemSelection,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QTableView"),
                new Param(c, "selected", "qt.QItemSelection"),
                new Param(c, "deselected", "qt.QItemSelection"), End),
            _func[13] = new MemberFunction(
                c, "setSelection", _n_setSelection0, None, Compiled,
                qt_QTableView_setSelection_void_QTableView_QRect_int, Return,
                "void", Parameters, new Param(c, "this", "qt.QTableView"),
                new Param(c, "rect", "qt.QRect"), new Param(c, "flags", "int"),
                End),
            _func[14] = new MemberFunction(
                c, "sizeHintForColumn", _n_sizeHintForColumn0, None, Compiled,
                qt_QTableView_sizeHintForColumn_int_QTableView_int, Return,
                "int", Parameters, new Param(c, "this", "qt.QTableView"),
                new Param(c, "column", "int"), End),
            _func[15] = new MemberFunction(
                c, "sizeHintForRow", _n_sizeHintForRow0, None, Compiled,
                qt_QTableView_sizeHintForRow_int_QTableView_int, Return, "int",
                Parameters, new Param(c, "this", "qt.QTableView"),
                new Param(c, "row", "int"), End),
            _func[16] = new MemberFunction(
                c, "timerEvent", _n_timerEvent0, None, Compiled,
                qt_QTableView_timerEvent_void_QTableView_QTimerEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QTableView"),
                new Param(c, "event", "qt.QTimerEvent"), End),
            _func[17] = new MemberFunction(
                c, "updateGeometries", _n_updateGeometries0, None, Compiled,
                qt_QTableView_updateGeometries_void_QTableView, Return, "void",
                Parameters, new Param(c, "this", "qt.QTableView"), End),
            _func[18] = new MemberFunction(
                c, "verticalOffset", _n_verticalOffset0, None, Compiled,
                qt_QTableView_verticalOffset_int_QTableView, Return, "int",
                Parameters, new Param(c, "this", "qt.QTableView"), End),
            _func[19] = new MemberFunction(
                c, "viewportSizeHint", _n_viewportSizeHint0, None, Compiled,
                qt_QTableView_viewportSizeHint_QSize_QTableView, Return,
                "qt.QSize", Parameters, new Param(c, "this", "qt.QTableView"),
                End),
            _func[20] = new MemberFunction(
                c, "visualRegionForSelection", _n_visualRegionForSelection0,
                None, Compiled,
                qt_QTableView_visualRegionForSelection_QRegion_QTableView_QItemSelection,
                Return, "qt.QRegion", Parameters,
                new Param(c, "this", "qt.QTableView"),
                new Param(c, "selection", "qt.QItemSelection"), End),
            // MISSING: itemDelegateForIndex ("QAbstractItemDelegate *";
            // QTableView this, QModelIndex index)
            _func[21] = new MemberFunction(
                c, "keyboardSearch", _n_keyboardSearch0, None, Compiled,
                qt_QTableView_keyboardSearch_void_QTableView_string, Return,
                "void", Parameters, new Param(c, "this", "qt.QTableView"),
                new Param(c, "search", "string"), End),
            _func[22] = new MemberFunction(
                c, "inputMethodQuery", _n_inputMethodQuery0, None, Compiled,
                qt_QTableView_inputMethodQuery_QVariant_QTableView_int, Return,
                "qt.QVariant", Parameters,
                new Param(c, "this", "qt.QTableView"),
                new Param(c, "query", "int"), End),
            _func[23] = new MemberFunction(
                c, "edit", _n_edit0, None, Compiled,
                qt_QTableView_edit_bool_QTableView_QModelIndex_int_QEvent,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QTableView"),
                new Param(c, "index", "qt.QModelIndex"),
                new Param(c, "trigger", "int"),
                new Param(c, "event", "qt.QEvent"), End),
            _func[24] = new MemberFunction(
                c, "selectionCommand", _n_selectionCommand0, None, Compiled,
                qt_QTableView_selectionCommand_int_QTableView_QModelIndex_QEvent,
                Return, "int", Parameters,
                new Param(c, "this", "qt.QTableView"),
                new Param(c, "index", "qt.QModelIndex"),
                new Param(c, "event", "qt.QEvent"), End),
            _func[25] = new MemberFunction(
                c, "startDrag", _n_startDrag0, None, Compiled,
                qt_QTableView_startDrag_void_QTableView_int, Return, "void",
                Parameters, new Param(c, "this", "qt.QTableView"),
                new Param(c, "supportedActions", "int"), End),
            _func[26] = new MemberFunction(
                c, "dragEnterEvent", _n_dragEnterEvent0, None, Compiled,
                qt_QTableView_dragEnterEvent_void_QTableView_QDragEnterEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QTableView"),
                new Param(c, "event", "qt.QDragEnterEvent"), End),
            _func[27] = new MemberFunction(
                c, "dragLeaveEvent", _n_dragLeaveEvent0, None, Compiled,
                qt_QTableView_dragLeaveEvent_void_QTableView_QDragLeaveEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QTableView"),
                new Param(c, "event", "qt.QDragLeaveEvent"), End),
            _func[28] = new MemberFunction(
                c, "dragMoveEvent", _n_dragMoveEvent0, None, Compiled,
                qt_QTableView_dragMoveEvent_void_QTableView_QDragMoveEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QTableView"),
                new Param(c, "event", "qt.QDragMoveEvent"), End),
            _func[29] = new MemberFunction(
                c, "dropEvent", _n_dropEvent0, None, Compiled,
                qt_QTableView_dropEvent_void_QTableView_QDropEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QTableView"),
                new Param(c, "event", "qt.QDropEvent"), End),
            _func[30] = new MemberFunction(
                c, "event", _n_event0, None, Compiled,
                qt_QTableView_event_bool_QTableView_QEvent, Return, "bool",
                Parameters, new Param(c, "this", "qt.QTableView"),
                new Param(c, "event_", "qt.QEvent"), End),
            _func[31] = new MemberFunction(
                c, "eventFilter", _n_eventFilter0, None, Compiled,
                qt_QTableView_eventFilter_bool_QTableView_QObject_QEvent,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QTableView"),
                new Param(c, "object", "qt.QObject"),
                new Param(c, "event", "qt.QEvent"), End),
            _func[32] = new MemberFunction(
                c, "focusInEvent", _n_focusInEvent0, None, Compiled,
                qt_QTableView_focusInEvent_void_QTableView_QFocusEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QTableView"),
                new Param(c, "event", "qt.QFocusEvent"), End),
            _func[33] = new MemberFunction(
                c, "focusNextPrevChild", _n_focusNextPrevChild0, None, Compiled,
                qt_QTableView_focusNextPrevChild_bool_QTableView_bool, Return,
                "bool", Parameters, new Param(c, "this", "qt.QTableView"),
                new Param(c, "next", "bool"), End),
            _func[34] = new MemberFunction(
                c, "focusOutEvent", _n_focusOutEvent0, None, Compiled,
                qt_QTableView_focusOutEvent_void_QTableView_QFocusEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QTableView"),
                new Param(c, "event", "qt.QFocusEvent"), End),
            // MISSING: inputMethodEvent (void; QTableView this,
            // "QInputMethodEvent *" event) // protected
            _func[35] = new MemberFunction(
                c, "keyPressEvent", _n_keyPressEvent0, None, Compiled,
                qt_QTableView_keyPressEvent_void_QTableView_QKeyEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QTableView"),
                new Param(c, "event", "qt.QKeyEvent"), End),
            _func[36] = new MemberFunction(
                c, "mouseDoubleClickEvent", _n_mouseDoubleClickEvent0, None,
                Compiled,
                qt_QTableView_mouseDoubleClickEvent_void_QTableView_QMouseEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QTableView"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[37] = new MemberFunction(
                c, "mouseMoveEvent", _n_mouseMoveEvent0, None, Compiled,
                qt_QTableView_mouseMoveEvent_void_QTableView_QMouseEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QTableView"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[38] = new MemberFunction(
                c, "mousePressEvent", _n_mousePressEvent0, None, Compiled,
                qt_QTableView_mousePressEvent_void_QTableView_QMouseEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QTableView"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[39] = new MemberFunction(
                c, "mouseReleaseEvent", _n_mouseReleaseEvent0, None, Compiled,
                qt_QTableView_mouseReleaseEvent_void_QTableView_QMouseEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QTableView"),
                new Param(c, "event", "qt.QMouseEvent"), End),
            _func[40] = new MemberFunction(
                c, "resizeEvent", _n_resizeEvent0, None, Compiled,
                qt_QTableView_resizeEvent_void_QTableView_QResizeEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QTableView"),
                new Param(c, "event", "qt.QResizeEvent"), End),
            _func[41] = new MemberFunction(
                c, "viewportEvent", _n_viewportEvent0, None, Compiled,
                qt_QTableView_viewportEvent_bool_QTableView_QEvent, Return,
                "bool", Parameters, new Param(c, "this", "qt.QTableView"),
                new Param(c, "event", "qt.QEvent"), End),
            // static functions
            EndArguments);
        globalScope()->addSymbols(EndArguments);
        scope()->addSymbols(EndArguments);

        const char** propExclusions = 0;

        populate(this, QTableView::staticMetaObject, propExclusions);
    }

} // namespace Mu
