//*****************************************************************************
// Copyright (c) 2024 Autodesk, Inc.
// All rights reserved.
//
// SPDX-License-Identifier: Apache-2.0
//
//*****************************************************************************

// IMPORTANT: This file (not the template) is auto-generated by qt2mu.py script.
//            The prefered way to do a fix is to handrolled it or modify the
//            qt2mu.py script. If it is not possible, manual editing is ok but
//            it could be lost in future generations.

#include <MuQt6/qtUtils.h>
#include <MuQt6/QTextEditType.h>
#include <QtGui/QtGui>
#include <QtWidgets/QtWidgets>
#include <QtSvg/QtSvg>
#include <QSvgWidget>
#include <QtNetwork/QtNetwork>
#include <MuQt6/QWidgetType.h>
#include <MuQt6/QActionType.h>
#include <MuQt6/QIconType.h>
#include <Mu/BaseFunctions.h>
#include <Mu/Thread.h>
#include <Mu/Alias.h>
#include <Mu/SymbolicConstant.h>
#include <Mu/ClassInstance.h>
#include <Mu/Function.h>
#include <Mu/MemberFunction.h>
#include <Mu/MemberVariable.h>
#include <Mu/Node.h>
#include <Mu/Exception.h>
#include <Mu/ParameterVariable.h>
#include <Mu/ReferenceType.h>
#include <Mu/Value.h>
#include <MuLang/MuLangContext.h>
#include <MuLang/StringType.h>
#include <MuQt6/QDragMoveEventType.h>
#include <MuQt6/QMenuType.h>
#include <MuQt6/QPointType.h>
#include <MuQt6/QRegularExpressionType.h>
#include <MuQt6/QWheelEventType.h>
#include <MuQt6/QMouseEventType.h>
#include <MuQt6/QMimeDataType.h>
#include <MuQt6/QFocusEventType.h>
#include <MuQt6/QShowEventType.h>
#include <MuQt6/QFontType.h>
#include <MuQt6/QSizeType.h>
#include <MuQt6/QDropEventType.h>
#include <MuQt6/QPaintEventType.h>
#include <MuQt6/QWidgetType.h>
#include <MuQt6/QDragLeaveEventType.h>
#include <MuQt6/QTextCursorType.h>
#include <MuQt6/QUrlType.h>
#include <MuQt6/QDragEnterEventType.h>
#include <MuQt6/QColorType.h>
#include <MuQt6/QEventType.h>
#include <MuQt6/QRectType.h>
#include <MuQt6/QContextMenuEventType.h>
#include <MuQt6/QKeyEventType.h>
#include <MuQt6/QVariantType.h>
#include <MuQt6/QResizeEventType.h>

namespace Mu
{
    using namespace std;

    //----------------------------------------------------------------------
    //  INHERITABLE TYPE IMPLEMENTATION

    // destructor
    MuQt_QTextEdit::~MuQt_QTextEdit()
    {
        if (_obj)
        {
            *_obj->data<Pointer>() = Pointer(0);
            _obj->releaseExternal();
        }
        _obj = 0;
        _env = 0;
        _baseType = 0;
    }

    MuQt_QTextEdit::MuQt_QTextEdit(Pointer muobj, const CallEnvironment* ce,
                                   QWidget* parent)
        : QTextEdit(parent)
    {
        _env = ce;
        _obj = reinterpret_cast<ClassInstance*>(muobj);
        _obj->retainExternal();
        MuLangContext* c = (MuLangContext*)_env->context();
        _baseType = c->findSymbolOfTypeByQualifiedName<QTextEditType>(
            c->internName("qt.QTextEdit"));
    }

    MuQt_QTextEdit::MuQt_QTextEdit(Pointer muobj, const CallEnvironment* ce,
                                   const QString& text, QWidget* parent)
        : QTextEdit(text, parent)
    {
        _env = ce;
        _obj = reinterpret_cast<ClassInstance*>(muobj);
        _obj->retainExternal();
        MuLangContext* c = (MuLangContext*)_env->context();
        _baseType = c->findSymbolOfTypeByQualifiedName<QTextEditType>(
            c->internName("qt.QTextEdit"));
    }

    QVariant MuQt_QTextEdit::loadResource(int type, const QUrl& name)
    {
        if (!_env)
            return QTextEdit::loadResource(type, name);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[0];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(3);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(type);
            args[2] = Value(makeqtype<QUrlType>(c, name, "qt.QUrl"));
            Value rval = _env->call(F, args);
            return getqtype<QVariantType>(rval._Pointer);
        }
        else
        {
            return QTextEdit::loadResource(type, name);
        }
    }

    QVariant
    MuQt_QTextEdit::inputMethodQuery(Qt::InputMethodQuery property) const
    {
        if (!_env)
            return QTextEdit::inputMethodQuery(property);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[1];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(int(property));
            Value rval = _env->call(F, args);
            return getqtype<QVariantType>(rval._Pointer);
        }
        else
        {
            return QTextEdit::inputMethodQuery(property);
        }
    }

    bool MuQt_QTextEdit::canInsertFromMimeData(const QMimeData* source) const
    {
        if (!_env)
            return QTextEdit::canInsertFromMimeData(source);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[2];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeinstance<QMimeDataType>(c, source, "qt.QMimeData"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QTextEdit::canInsertFromMimeData(source);
        }
    }

    QMimeData* MuQt_QTextEdit::createMimeDataFromSelection() const
    {
        if (!_env)
            return QTextEdit::createMimeDataFromSelection();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[3];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return object<QMimeData>(rval._Pointer);
        }
        else
        {
            return QTextEdit::createMimeDataFromSelection();
        }
    }

    void MuQt_QTextEdit::insertFromMimeData(const QMimeData* source)
    {
        if (!_env)
        {
            QTextEdit::insertFromMimeData(source);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[4];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeinstance<QMimeDataType>(c, source, "qt.QMimeData"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTextEdit::insertFromMimeData(source);
        }
    }

    void MuQt_QTextEdit::changeEvent(QEvent* e)
    {
        if (!_env)
        {
            QTextEdit::changeEvent(e);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[5];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, e, "qt.QEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTextEdit::changeEvent(e);
        }
    }

    void MuQt_QTextEdit::contextMenuEvent(QContextMenuEvent* event)
    {
        if (!_env)
        {
            QTextEdit::contextMenuEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[6];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QContextMenuEventType>(
                c, event, "qt.QContextMenuEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTextEdit::contextMenuEvent(event);
        }
    }

    void MuQt_QTextEdit::dragEnterEvent(QDragEnterEvent* e)
    {
        if (!_env)
        {
            QTextEdit::dragEnterEvent(e);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[7];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QDragEnterEventType>(c, e, "qt.QDragEnterEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTextEdit::dragEnterEvent(e);
        }
    }

    void MuQt_QTextEdit::dragLeaveEvent(QDragLeaveEvent* e)
    {
        if (!_env)
        {
            QTextEdit::dragLeaveEvent(e);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[8];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QDragLeaveEventType>(c, e, "qt.QDragLeaveEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTextEdit::dragLeaveEvent(e);
        }
    }

    void MuQt_QTextEdit::dragMoveEvent(QDragMoveEvent* e)
    {
        if (!_env)
        {
            QTextEdit::dragMoveEvent(e);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[9];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QDragMoveEventType>(c, e, "qt.QDragMoveEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTextEdit::dragMoveEvent(e);
        }
    }

    void MuQt_QTextEdit::dropEvent(QDropEvent* e)
    {
        if (!_env)
        {
            QTextEdit::dropEvent(e);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[10];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QDropEventType>(c, e, "qt.QDropEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTextEdit::dropEvent(e);
        }
    }

    void MuQt_QTextEdit::focusInEvent(QFocusEvent* e)
    {
        if (!_env)
        {
            QTextEdit::focusInEvent(e);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[11];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QFocusEventType>(c, e, "qt.QFocusEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTextEdit::focusInEvent(e);
        }
    }

    bool MuQt_QTextEdit::focusNextPrevChild(bool next)
    {
        if (!_env)
            return QTextEdit::focusNextPrevChild(next);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[12];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(next);
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QTextEdit::focusNextPrevChild(next);
        }
    }

    void MuQt_QTextEdit::focusOutEvent(QFocusEvent* e)
    {
        if (!_env)
        {
            QTextEdit::focusOutEvent(e);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[13];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QFocusEventType>(c, e, "qt.QFocusEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTextEdit::focusOutEvent(e);
        }
    }

    void MuQt_QTextEdit::keyPressEvent(QKeyEvent* e)
    {
        if (!_env)
        {
            QTextEdit::keyPressEvent(e);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[14];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QKeyEventType>(c, e, "qt.QKeyEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTextEdit::keyPressEvent(e);
        }
    }

    void MuQt_QTextEdit::keyReleaseEvent(QKeyEvent* e)
    {
        if (!_env)
        {
            QTextEdit::keyReleaseEvent(e);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[15];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QKeyEventType>(c, e, "qt.QKeyEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTextEdit::keyReleaseEvent(e);
        }
    }

    void MuQt_QTextEdit::mouseDoubleClickEvent(QMouseEvent* e)
    {
        if (!_env)
        {
            QTextEdit::mouseDoubleClickEvent(e);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[16];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QMouseEventType>(c, e, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTextEdit::mouseDoubleClickEvent(e);
        }
    }

    void MuQt_QTextEdit::mouseMoveEvent(QMouseEvent* e)
    {
        if (!_env)
        {
            QTextEdit::mouseMoveEvent(e);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[17];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QMouseEventType>(c, e, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTextEdit::mouseMoveEvent(e);
        }
    }

    void MuQt_QTextEdit::mousePressEvent(QMouseEvent* e)
    {
        if (!_env)
        {
            QTextEdit::mousePressEvent(e);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[18];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QMouseEventType>(c, e, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTextEdit::mousePressEvent(e);
        }
    }

    void MuQt_QTextEdit::mouseReleaseEvent(QMouseEvent* e)
    {
        if (!_env)
        {
            QTextEdit::mouseReleaseEvent(e);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[19];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QMouseEventType>(c, e, "qt.QMouseEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTextEdit::mouseReleaseEvent(e);
        }
    }

    void MuQt_QTextEdit::paintEvent(QPaintEvent* event)
    {
        if (!_env)
        {
            QTextEdit::paintEvent(event);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[20];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(
                makeqpointer<QPaintEventType>(c, event, "qt.QPaintEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTextEdit::paintEvent(event);
        }
    }

    void MuQt_QTextEdit::resizeEvent(QResizeEvent* e)
    {
        if (!_env)
        {
            QTextEdit::resizeEvent(e);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[21];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QResizeEventType>(c, e, "qt.QResizeEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTextEdit::resizeEvent(e);
        }
    }

    void MuQt_QTextEdit::scrollContentsBy(int dx, int dy)
    {
        if (!_env)
        {
            QTextEdit::scrollContentsBy(dx, dy);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[22];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(3);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(dx);
            args[2] = Value(dy);
            Value rval = _env->call(F, args);
        }
        else
        {
            QTextEdit::scrollContentsBy(dx, dy);
        }
    }

    void MuQt_QTextEdit::showEvent(QShowEvent* _p13)
    {
        if (!_env)
        {
            QTextEdit::showEvent(_p13);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[23];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QShowEventType>(c, _p13, "qt.QShowEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTextEdit::showEvent(_p13);
        }
    }

    void MuQt_QTextEdit::wheelEvent(QWheelEvent* e)
    {
        if (!_env)
        {
            QTextEdit::wheelEvent(e);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[24];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeqpointer<QWheelEventType>(c, e, "qt.QWheelEvent"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTextEdit::wheelEvent(e);
        }
    }

    void MuQt_QTextEdit::setupViewport(QWidget* viewport)
    {
        if (!_env)
        {
            QTextEdit::setupViewport(viewport);
            return;
        }
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[25];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] =
                Value(makeinstance<QWidgetType>(c, viewport, "qt.QWidget"));
            Value rval = _env->call(F, args);
        }
        else
        {
            QTextEdit::setupViewport(viewport);
        }
    }

    QSize MuQt_QTextEdit::minimumSizeHint() const
    {
        if (!_env)
            return QTextEdit::minimumSizeHint();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[26];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return getqtype<QSizeType>(rval._Pointer);
        }
        else
        {
            return QTextEdit::minimumSizeHint();
        }
    }

    QSize MuQt_QTextEdit::sizeHint() const
    {
        if (!_env)
            return QTextEdit::sizeHint();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[27];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return getqtype<QSizeType>(rval._Pointer);
        }
        else
        {
            return QTextEdit::sizeHint();
        }
    }

    bool MuQt_QTextEdit::viewportEvent(QEvent* event)
    {
        if (!_env)
            return QTextEdit::viewportEvent(event);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[28];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, event, "qt.QEvent"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QTextEdit::viewportEvent(event);
        }
    }

    QSize MuQt_QTextEdit::viewportSizeHint() const
    {
        if (!_env)
            return QTextEdit::viewportSizeHint();
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[29];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(1);
            args[0] = Value(Pointer(_obj));
            Value rval = _env->call(F, args);
            return getqtype<QSizeType>(rval._Pointer);
        }
        else
        {
            return QTextEdit::viewportSizeHint();
        }
    }

    bool MuQt_QTextEdit::event(QEvent* event_)
    {
        if (!_env)
            return QTextEdit::event(event_);
        MuLangContext* c = (MuLangContext*)_env->context();
        const MemberFunction* F0 = _baseType->_func[30];
        const MemberFunction* F = _obj->classType()->dynamicLookup(F0);
        if (F != F0)
        {
            Function::ArgumentVector args(2);
            args[0] = Value(Pointer(_obj));
            args[1] = Value(makeqpointer<QEventType>(c, event_, "qt.QEvent"));
            Value rval = _env->call(F, args);
            return (bool)(rval._bool);
        }
        else
        {
            return QTextEdit::event(event_);
        }
    }

    //----------------------------------------------------------------------
    //  Mu Type CONSTRUCTORS

    QTextEditType::QTextEditType(Context* c, const char* name, Class* super,
                                 Class* super2)
        : Class(c, name, vectorOf2(super, super2))
    {
    }

    QTextEditType::~QTextEditType() {}

    //----------------------------------------------------------------------
    //  PRE-COMPILED FUNCTIONS

    static Pointer QTextEdit_QTextEdit_QObject(Thread& NODE_THREAD, Pointer obj)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        ClassInstance* widget = reinterpret_cast<ClassInstance*>(obj);

        if (!widget)
        {
            return 0;
        }
        else if (QTextEdit* w = object<QTextEdit>(widget))
        {
            QTextEditType* type =
                c->findSymbolOfTypeByQualifiedName<QTextEditType>(
                    c->internName("qt.QTextEdit"), false);
            ClassInstance* o = ClassInstance::allocate(type);
            setobject(o, w);
            return o;
        }
        else
        {
            throw BadCastException();
        }
    }

    static NODE_IMPLEMENTATION(castFromObject, Pointer)
    {
        NODE_RETURN(
            QTextEdit_QTextEdit_QObject(NODE_THREAD, NODE_ARG(0, Pointer)));
    }

    Pointer qt_QTextEdit_QTextEdit_QTextEdit_QTextEdit_QWidget(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QWidget* arg1 = object<QWidget>(param_parent);
        setobject(param_this,
                  new MuQt_QTextEdit(param_this,
                                     NODE_THREAD.process()->callEnv(), arg1));
        return param_this;
    }

    Pointer qt_QTextEdit_QTextEdit_QTextEdit_QTextEdit_string_QWidget(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_text,
        Pointer param_parent)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        const QString arg1 = qstring(param_text);
        QWidget* arg2 = object<QWidget>(param_parent);
        setobject(param_this, new MuQt_QTextEdit(
                                  param_this, NODE_THREAD.process()->callEnv(),
                                  arg1, arg2));
        return param_this;
    }

    int qt_QTextEdit_alignment_int_QTextEdit(Mu::Thread& NODE_THREAD,
                                             Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        return int(arg0->alignment());
    }

    Pointer qt_QTextEdit_anchorAt_string_QTextEdit_QPoint(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_pos)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        const QPoint arg1 = getqtype<QPointType>(param_pos);
        return makestring(c, arg0->anchorAt(arg1));
    }

    bool qt_QTextEdit_canPaste_bool_QTextEdit(Mu::Thread& NODE_THREAD,
                                              Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        return arg0->canPaste();
    }

    Pointer qt_QTextEdit_createStandardContextMenu_QMenu_QTextEdit(
        Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        return makeinstance<QMenuType>(c, arg0->createStandardContextMenu(),
                                       "qt.QMenu");
    }

    Pointer qt_QTextEdit_createStandardContextMenu_QMenu_QTextEdit_QPoint(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_position)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        const QPoint arg1 = getqtype<QPointType>(param_position);
        return makeinstance<QMenuType>(c, arg0->createStandardContextMenu(arg1),
                                       "qt.QMenu");
    }

    Pointer qt_QTextEdit_currentFont_QFont_QTextEdit(Mu::Thread& NODE_THREAD,
                                                     Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        return makeqtype<QFontType>(c, arg0->currentFont(), "qt.QFont");
    }

    Pointer qt_QTextEdit_cursorForPosition_QTextCursor_QTextEdit_QPoint(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_pos)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        const QPoint arg1 = getqtype<QPointType>(param_pos);
        return makeqtype<QTextCursorType>(c, arg0->cursorForPosition(arg1),
                                          "qt.QTextCursor");
    }

    Pointer qt_QTextEdit_cursorRect_QRect_QTextEdit_QTextCursor(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_cursor)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        const QTextCursor arg1 = getqtype<QTextCursorType>(param_cursor);
        return makeqtype<QRectType>(c, arg0->cursorRect(arg1), "qt.QRect");
    }

    Pointer qt_QTextEdit_cursorRect_QRect_QTextEdit(Mu::Thread& NODE_THREAD,
                                                    Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        return makeqtype<QRectType>(c, arg0->cursorRect(), "qt.QRect");
    }

    void
    qt_QTextEdit_ensureCursorVisible_void_QTextEdit(Mu::Thread& NODE_THREAD,
                                                    Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        arg0->ensureCursorVisible();
    }

    bool qt_QTextEdit_find_bool_QTextEdit_string_int(Mu::Thread& NODE_THREAD,
                                                     Pointer param_this,
                                                     Pointer param_exp,
                                                     int param_options)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        const QString arg1 = qstring(param_exp);
        QTextDocument::FindFlags arg2 =
            (QTextDocument::FindFlags)(param_options);
        return arg0->find(arg1, arg2);
    }

    bool qt_QTextEdit_find_bool_QTextEdit_QRegularExpression_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_exp,
        int param_options)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        const QRegularExpression arg1 =
            getqtype<QRegularExpressionType>(param_exp);
        QTextDocument::FindFlags arg2 =
            (QTextDocument::FindFlags)(param_options);
        return arg0->find(arg1, arg2);
    }

    Pointer qt_QTextEdit_fontFamily_string_QTextEdit(Mu::Thread& NODE_THREAD,
                                                     Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        return makestring(c, arg0->fontFamily());
    }

    bool qt_QTextEdit_fontItalic_bool_QTextEdit(Mu::Thread& NODE_THREAD,
                                                Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        return arg0->fontItalic();
    }

    double qt_QTextEdit_fontPointSize_double_QTextEdit(Mu::Thread& NODE_THREAD,
                                                       Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        return arg0->fontPointSize();
    }

    bool qt_QTextEdit_fontUnderline_bool_QTextEdit(Mu::Thread& NODE_THREAD,
                                                   Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        return arg0->fontUnderline();
    }

    int qt_QTextEdit_fontWeight_int_QTextEdit(Mu::Thread& NODE_THREAD,
                                              Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        return arg0->fontWeight();
    }

    Pointer qt_QTextEdit_loadResource_QVariant_QTextEdit_int_QUrl(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_type,
        Pointer param_name)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        int arg1 = (int)(param_type);
        const QUrl arg2 = getqtype<QUrlType>(param_name);
        return isMuQtObject(arg0)
                   ? makeqtype<QVariantType>(
                         c, arg0->QTextEdit::loadResource(arg1, arg2),
                         "qt.QVariant")
                   : makeqtype<QVariantType>(c, arg0->loadResource(arg1, arg2),
                                             "qt.QVariant");
    }

    void qt_QTextEdit_moveCursor_void_QTextEdit_int_int(Mu::Thread& NODE_THREAD,
                                                        Pointer param_this,
                                                        int param_operation,
                                                        int param_mode)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        QTextCursor::MoveOperation arg1 =
            (QTextCursor::MoveOperation)(param_operation);
        QTextCursor::MoveMode arg2 = (QTextCursor::MoveMode)(param_mode);
        arg0->moveCursor(arg1, arg2);
    }

    void qt_QTextEdit_setTextCursor_void_QTextEdit_QTextCursor(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_cursor)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        const QTextCursor arg1 = getqtype<QTextCursorType>(param_cursor);
        arg0->setTextCursor(arg1);
    }

    Pointer
    qt_QTextEdit_textBackgroundColor_QColor_QTextEdit(Mu::Thread& NODE_THREAD,
                                                      Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        return makeqtype<QColorType>(c, arg0->textBackgroundColor(),
                                     "qt.QColor");
    }

    Pointer qt_QTextEdit_textColor_QColor_QTextEdit(Mu::Thread& NODE_THREAD,
                                                    Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        return makeqtype<QColorType>(c, arg0->textColor(), "qt.QColor");
    }

    Pointer
    qt_QTextEdit_textCursor_QTextCursor_QTextEdit(Mu::Thread& NODE_THREAD,
                                                  Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        return makeqtype<QTextCursorType>(c, arg0->textCursor(),
                                          "qt.QTextCursor");
    }

    Pointer qt_QTextEdit_toPlainText_string_QTextEdit(Mu::Thread& NODE_THREAD,
                                                      Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        return makestring(c, arg0->toPlainText());
    }

    Pointer qt_QTextEdit_inputMethodQuery_QVariant_QTextEdit_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_property)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        Qt::InputMethodQuery arg1 = (Qt::InputMethodQuery)(param_property);
        return isMuQtObject(arg0)
                   ? makeqtype<QVariantType>(
                         c, arg0->QTextEdit::inputMethodQuery(arg1),
                         "qt.QVariant")
                   : makeqtype<QVariantType>(c, arg0->inputMethodQuery(arg1),
                                             "qt.QVariant");
    }

    bool qt_QTextEdit_canInsertFromMimeData_bool_QTextEdit_QMimeData(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_source)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        const QMimeData* arg1 = object<QMimeData>(param_source);
        return isMuQtObject(arg0)
                   ? ((MuQt_QTextEdit*)arg0)
                         ->canInsertFromMimeData_pub_parent(arg1)
                   : ((MuQt_QTextEdit*)arg0)->canInsertFromMimeData_pub(arg1);
    }

    Pointer qt_QTextEdit_createMimeDataFromSelection_QMimeData_QTextEdit(
        Mu::Thread& NODE_THREAD, Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        return isMuQtObject(arg0)
                   ? makeinstance<QMimeDataType>(
                         c,
                         ((MuQt_QTextEdit*)arg0)
                             ->createMimeDataFromSelection_pub_parent(),
                         "qt.QMimeData")
                   : makeinstance<QMimeDataType>(
                         c,
                         ((MuQt_QTextEdit*)arg0)
                             ->createMimeDataFromSelection_pub(),
                         "qt.QMimeData");
    }

    void qt_QTextEdit_insertFromMimeData_void_QTextEdit_QMimeData(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_source)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        const QMimeData* arg1 = object<QMimeData>(param_source);
        if (isMuQtObject(arg0))
            ((MuQt_QTextEdit*)arg0)->insertFromMimeData_pub_parent(arg1);
        else
            ((MuQt_QTextEdit*)arg0)->insertFromMimeData_pub(arg1);
    }

    void qt_QTextEdit_changeEvent_void_QTextEdit_QEvent(Mu::Thread& NODE_THREAD,
                                                        Pointer param_this,
                                                        Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_e);
        if (isMuQtObject(arg0))
            ((MuQt_QTextEdit*)arg0)->changeEvent_pub_parent(arg1);
        else
            ((MuQt_QTextEdit*)arg0)->changeEvent_pub(arg1);
    }

    void qt_QTextEdit_contextMenuEvent_void_QTextEdit_QContextMenuEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        QContextMenuEvent* arg1 =
            getqpointer<QContextMenuEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QTextEdit*)arg0)->contextMenuEvent_pub_parent(arg1);
        else
            ((MuQt_QTextEdit*)arg0)->contextMenuEvent_pub(arg1);
    }

    void qt_QTextEdit_dragEnterEvent_void_QTextEdit_QDragEnterEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        QDragEnterEvent* arg1 = getqpointer<QDragEnterEventType>(param_e);
        if (isMuQtObject(arg0))
            ((MuQt_QTextEdit*)arg0)->dragEnterEvent_pub_parent(arg1);
        else
            ((MuQt_QTextEdit*)arg0)->dragEnterEvent_pub(arg1);
    }

    void qt_QTextEdit_dragLeaveEvent_void_QTextEdit_QDragLeaveEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        QDragLeaveEvent* arg1 = getqpointer<QDragLeaveEventType>(param_e);
        if (isMuQtObject(arg0))
            ((MuQt_QTextEdit*)arg0)->dragLeaveEvent_pub_parent(arg1);
        else
            ((MuQt_QTextEdit*)arg0)->dragLeaveEvent_pub(arg1);
    }

    void qt_QTextEdit_dragMoveEvent_void_QTextEdit_QDragMoveEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        QDragMoveEvent* arg1 = getqpointer<QDragMoveEventType>(param_e);
        if (isMuQtObject(arg0))
            ((MuQt_QTextEdit*)arg0)->dragMoveEvent_pub_parent(arg1);
        else
            ((MuQt_QTextEdit*)arg0)->dragMoveEvent_pub(arg1);
    }

    void qt_QTextEdit_dropEvent_void_QTextEdit_QDropEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        QDropEvent* arg1 = getqpointer<QDropEventType>(param_e);
        if (isMuQtObject(arg0))
            ((MuQt_QTextEdit*)arg0)->dropEvent_pub_parent(arg1);
        else
            ((MuQt_QTextEdit*)arg0)->dropEvent_pub(arg1);
    }

    void qt_QTextEdit_focusInEvent_void_QTextEdit_QFocusEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        QFocusEvent* arg1 = getqpointer<QFocusEventType>(param_e);
        if (isMuQtObject(arg0))
            ((MuQt_QTextEdit*)arg0)->focusInEvent_pub_parent(arg1);
        else
            ((MuQt_QTextEdit*)arg0)->focusInEvent_pub(arg1);
    }

    bool qt_QTextEdit_focusNextPrevChild_bool_QTextEdit_bool(
        Mu::Thread& NODE_THREAD, Pointer param_this, bool param_next)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        bool arg1 = (bool)(param_next);
        return isMuQtObject(arg0)
                   ? ((MuQt_QTextEdit*)arg0)
                         ->focusNextPrevChild_pub_parent(arg1)
                   : ((MuQt_QTextEdit*)arg0)->focusNextPrevChild_pub(arg1);
    }

    void qt_QTextEdit_focusOutEvent_void_QTextEdit_QFocusEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        QFocusEvent* arg1 = getqpointer<QFocusEventType>(param_e);
        if (isMuQtObject(arg0))
            ((MuQt_QTextEdit*)arg0)->focusOutEvent_pub_parent(arg1);
        else
            ((MuQt_QTextEdit*)arg0)->focusOutEvent_pub(arg1);
    }

    void qt_QTextEdit_keyPressEvent_void_QTextEdit_QKeyEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        QKeyEvent* arg1 = getqpointer<QKeyEventType>(param_e);
        if (isMuQtObject(arg0))
            ((MuQt_QTextEdit*)arg0)->keyPressEvent_pub_parent(arg1);
        else
            ((MuQt_QTextEdit*)arg0)->keyPressEvent_pub(arg1);
    }

    void qt_QTextEdit_keyReleaseEvent_void_QTextEdit_QKeyEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        QKeyEvent* arg1 = getqpointer<QKeyEventType>(param_e);
        if (isMuQtObject(arg0))
            ((MuQt_QTextEdit*)arg0)->keyReleaseEvent_pub_parent(arg1);
        else
            ((MuQt_QTextEdit*)arg0)->keyReleaseEvent_pub(arg1);
    }

    void qt_QTextEdit_mouseDoubleClickEvent_void_QTextEdit_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_e);
        if (isMuQtObject(arg0))
            ((MuQt_QTextEdit*)arg0)->mouseDoubleClickEvent_pub_parent(arg1);
        else
            ((MuQt_QTextEdit*)arg0)->mouseDoubleClickEvent_pub(arg1);
    }

    void qt_QTextEdit_mouseMoveEvent_void_QTextEdit_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_e);
        if (isMuQtObject(arg0))
            ((MuQt_QTextEdit*)arg0)->mouseMoveEvent_pub_parent(arg1);
        else
            ((MuQt_QTextEdit*)arg0)->mouseMoveEvent_pub(arg1);
    }

    void qt_QTextEdit_mousePressEvent_void_QTextEdit_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_e);
        if (isMuQtObject(arg0))
            ((MuQt_QTextEdit*)arg0)->mousePressEvent_pub_parent(arg1);
        else
            ((MuQt_QTextEdit*)arg0)->mousePressEvent_pub(arg1);
    }

    void qt_QTextEdit_mouseReleaseEvent_void_QTextEdit_QMouseEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        QMouseEvent* arg1 = getqpointer<QMouseEventType>(param_e);
        if (isMuQtObject(arg0))
            ((MuQt_QTextEdit*)arg0)->mouseReleaseEvent_pub_parent(arg1);
        else
            ((MuQt_QTextEdit*)arg0)->mouseReleaseEvent_pub(arg1);
    }

    void qt_QTextEdit_paintEvent_void_QTextEdit_QPaintEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        QPaintEvent* arg1 = getqpointer<QPaintEventType>(param_event);
        if (isMuQtObject(arg0))
            ((MuQt_QTextEdit*)arg0)->paintEvent_pub_parent(arg1);
        else
            ((MuQt_QTextEdit*)arg0)->paintEvent_pub(arg1);
    }

    void qt_QTextEdit_resizeEvent_void_QTextEdit_QResizeEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        QResizeEvent* arg1 = getqpointer<QResizeEventType>(param_e);
        if (isMuQtObject(arg0))
            ((MuQt_QTextEdit*)arg0)->resizeEvent_pub_parent(arg1);
        else
            ((MuQt_QTextEdit*)arg0)->resizeEvent_pub(arg1);
    }

    void qt_QTextEdit_scrollContentsBy_void_QTextEdit_int_int(
        Mu::Thread& NODE_THREAD, Pointer param_this, int param_dx, int param_dy)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        int arg1 = (int)(param_dx);
        int arg2 = (int)(param_dy);
        if (isMuQtObject(arg0))
            ((MuQt_QTextEdit*)arg0)->scrollContentsBy_pub_parent(arg1, arg2);
        else
            ((MuQt_QTextEdit*)arg0)->scrollContentsBy_pub(arg1, arg2);
    }

    void qt_QTextEdit_showEvent_void_QTextEdit_QShowEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param__p13)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        QShowEvent* arg1 = getqpointer<QShowEventType>(param__p13);
        if (isMuQtObject(arg0))
            ((MuQt_QTextEdit*)arg0)->showEvent_pub_parent(arg1);
        else
            ((MuQt_QTextEdit*)arg0)->showEvent_pub(arg1);
    }

    void qt_QTextEdit_wheelEvent_void_QTextEdit_QWheelEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_e)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        QWheelEvent* arg1 = getqpointer<QWheelEventType>(param_e);
        if (isMuQtObject(arg0))
            ((MuQt_QTextEdit*)arg0)->wheelEvent_pub_parent(arg1);
        else
            ((MuQt_QTextEdit*)arg0)->wheelEvent_pub(arg1);
    }

    void qt_QTextEdit_setupViewport_void_QTextEdit_QWidget(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_viewport)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        QWidget* arg1 = object<QWidget>(param_viewport);
        if (isMuQtObject(arg0))
            arg0->QTextEdit::setupViewport(arg1);
        else
            arg0->setupViewport(arg1);
    }

    Pointer
    qt_QTextEdit_minimumSizeHint_QSize_QTextEdit(Mu::Thread& NODE_THREAD,
                                                 Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        return isMuQtObject(arg0)
                   ? makeqtype<QSizeType>(c, arg0->QTextEdit::minimumSizeHint(),
                                          "qt.QSize")
                   : makeqtype<QSizeType>(c, arg0->minimumSizeHint(),
                                          "qt.QSize");
    }

    Pointer qt_QTextEdit_sizeHint_QSize_QTextEdit(Mu::Thread& NODE_THREAD,
                                                  Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        return isMuQtObject(arg0)
                   ? makeqtype<QSizeType>(c, arg0->QTextEdit::sizeHint(),
                                          "qt.QSize")
                   : makeqtype<QSizeType>(c, arg0->sizeHint(), "qt.QSize");
    }

    bool qt_QTextEdit_viewportEvent_bool_QTextEdit_QEvent(
        Mu::Thread& NODE_THREAD, Pointer param_this, Pointer param_event)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_event);
        return isMuQtObject(arg0)
                   ? ((MuQt_QTextEdit*)arg0)->viewportEvent_pub_parent(arg1)
                   : ((MuQt_QTextEdit*)arg0)->viewportEvent_pub(arg1);
    }

    Pointer
    qt_QTextEdit_viewportSizeHint_QSize_QTextEdit(Mu::Thread& NODE_THREAD,
                                                  Pointer param_this)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        return isMuQtObject(arg0)
                   ? makeqtype<QSizeType>(
                         c,
                         ((MuQt_QTextEdit*)arg0)->viewportSizeHint_pub_parent(),
                         "qt.QSize")
                   : makeqtype<QSizeType>(
                         c, ((MuQt_QTextEdit*)arg0)->viewportSizeHint_pub(),
                         "qt.QSize");
    }

    bool qt_QTextEdit_event_bool_QTextEdit_QEvent(Mu::Thread& NODE_THREAD,
                                                  Pointer param_this,
                                                  Pointer param_event_)
    {
        MuLangContext* c = static_cast<MuLangContext*>(NODE_THREAD.context());
        QTextEdit* arg0 = object<QTextEdit>(param_this);
        QEvent* arg1 = getqpointer<QEventType>(param_event_);
        return isMuQtObject(arg0)
                   ? ((MuQt_QTextEdit*)arg0)->event_pub_parent(arg1)
                   : ((MuQt_QTextEdit*)arg0)->event_pub(arg1);
    }

    static NODE_IMPLEMENTATION(_n_QTextEdit0, Pointer)
    {
        NODE_RETURN(qt_QTextEdit_QTextEdit_QTextEdit_QTextEdit_QWidget(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_QTextEdit1, Pointer)
    {
        NODE_RETURN(qt_QTextEdit_QTextEdit_QTextEdit_QTextEdit_string_QWidget(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_alignment0, int)
    {
        NODE_RETURN(qt_QTextEdit_alignment_int_QTextEdit(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_anchorAt0, Pointer)
    {
        NODE_RETURN(qt_QTextEdit_anchorAt_string_QTextEdit_QPoint(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_canPaste0, bool)
    {
        NODE_RETURN(qt_QTextEdit_canPaste_bool_QTextEdit(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_createStandardContextMenu0, Pointer)
    {
        NODE_RETURN(qt_QTextEdit_createStandardContextMenu_QMenu_QTextEdit(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_createStandardContextMenu1, Pointer)
    {
        NODE_RETURN(
            qt_QTextEdit_createStandardContextMenu_QMenu_QTextEdit_QPoint(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer),
                NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_currentFont0, Pointer)
    {
        NODE_RETURN(qt_QTextEdit_currentFont_QFont_QTextEdit(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_cursorForPosition0, Pointer)
    {
        NODE_RETURN(qt_QTextEdit_cursorForPosition_QTextCursor_QTextEdit_QPoint(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_cursorRect0, Pointer)
    {
        NODE_RETURN(qt_QTextEdit_cursorRect_QRect_QTextEdit_QTextCursor(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_cursorRect1, Pointer)
    {
        NODE_RETURN(qt_QTextEdit_cursorRect_QRect_QTextEdit(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_ensureCursorVisible0, void)
    {
        qt_QTextEdit_ensureCursorVisible_void_QTextEdit(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_find0, bool)
    {
        NODE_RETURN(qt_QTextEdit_find_bool_QTextEdit_string_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, int)));
    }

    static NODE_IMPLEMENTATION(_n_find1, bool)
    {
        NODE_RETURN(qt_QTextEdit_find_bool_QTextEdit_QRegularExpression_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer),
            NODE_ARG(2, int)));
    }

    static NODE_IMPLEMENTATION(_n_fontFamily0, Pointer)
    {
        NODE_RETURN(qt_QTextEdit_fontFamily_string_QTextEdit(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_fontItalic0, bool)
    {
        NODE_RETURN(qt_QTextEdit_fontItalic_bool_QTextEdit(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_fontPointSize0, double)
    {
        NODE_RETURN(qt_QTextEdit_fontPointSize_double_QTextEdit(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_fontUnderline0, bool)
    {
        NODE_RETURN(qt_QTextEdit_fontUnderline_bool_QTextEdit(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_fontWeight0, int)
    {
        NODE_RETURN(qt_QTextEdit_fontWeight_int_QTextEdit(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_loadResource0, Pointer)
    {
        NODE_RETURN(qt_QTextEdit_loadResource_QVariant_QTextEdit_int_QUrl(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
            NODE_ARG(2, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_moveCursor0, void)
    {
        qt_QTextEdit_moveCursor_void_QTextEdit_int_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
            NODE_ARG(2, int));
    }

    static NODE_IMPLEMENTATION(_n_setTextCursor0, void)
    {
        qt_QTextEdit_setTextCursor_void_QTextEdit_QTextCursor(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_textBackgroundColor0, Pointer)
    {
        NODE_RETURN(qt_QTextEdit_textBackgroundColor_QColor_QTextEdit(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_textColor0, Pointer)
    {
        NODE_RETURN(qt_QTextEdit_textColor_QColor_QTextEdit(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_textCursor0, Pointer)
    {
        NODE_RETURN(qt_QTextEdit_textCursor_QTextCursor_QTextEdit(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_toPlainText0, Pointer)
    {
        NODE_RETURN(qt_QTextEdit_toPlainText_string_QTextEdit(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_inputMethodQuery0, Pointer)
    {
        NODE_RETURN(qt_QTextEdit_inputMethodQuery_QVariant_QTextEdit_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int)));
    }

    static NODE_IMPLEMENTATION(_n_canInsertFromMimeData0, bool)
    {
        NODE_RETURN(qt_QTextEdit_canInsertFromMimeData_bool_QTextEdit_QMimeData(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_createMimeDataFromSelection0, Pointer)
    {
        NODE_RETURN(
            qt_QTextEdit_createMimeDataFromSelection_QMimeData_QTextEdit(
                NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_insertFromMimeData0, void)
    {
        qt_QTextEdit_insertFromMimeData_void_QTextEdit_QMimeData(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_changeEvent0, void)
    {
        qt_QTextEdit_changeEvent_void_QTextEdit_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_contextMenuEvent0, void)
    {
        qt_QTextEdit_contextMenuEvent_void_QTextEdit_QContextMenuEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dragEnterEvent0, void)
    {
        qt_QTextEdit_dragEnterEvent_void_QTextEdit_QDragEnterEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dragLeaveEvent0, void)
    {
        qt_QTextEdit_dragLeaveEvent_void_QTextEdit_QDragLeaveEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dragMoveEvent0, void)
    {
        qt_QTextEdit_dragMoveEvent_void_QTextEdit_QDragMoveEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_dropEvent0, void)
    {
        qt_QTextEdit_dropEvent_void_QTextEdit_QDropEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_focusInEvent0, void)
    {
        qt_QTextEdit_focusInEvent_void_QTextEdit_QFocusEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_focusNextPrevChild0, bool)
    {
        NODE_RETURN(qt_QTextEdit_focusNextPrevChild_bool_QTextEdit_bool(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, bool)));
    }

    static NODE_IMPLEMENTATION(_n_focusOutEvent0, void)
    {
        qt_QTextEdit_focusOutEvent_void_QTextEdit_QFocusEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_keyPressEvent0, void)
    {
        qt_QTextEdit_keyPressEvent_void_QTextEdit_QKeyEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_keyReleaseEvent0, void)
    {
        qt_QTextEdit_keyReleaseEvent_void_QTextEdit_QKeyEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mouseDoubleClickEvent0, void)
    {
        qt_QTextEdit_mouseDoubleClickEvent_void_QTextEdit_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mouseMoveEvent0, void)
    {
        qt_QTextEdit_mouseMoveEvent_void_QTextEdit_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mousePressEvent0, void)
    {
        qt_QTextEdit_mousePressEvent_void_QTextEdit_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_mouseReleaseEvent0, void)
    {
        qt_QTextEdit_mouseReleaseEvent_void_QTextEdit_QMouseEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_paintEvent0, void)
    {
        qt_QTextEdit_paintEvent_void_QTextEdit_QPaintEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_resizeEvent0, void)
    {
        qt_QTextEdit_resizeEvent_void_QTextEdit_QResizeEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_scrollContentsBy0, void)
    {
        qt_QTextEdit_scrollContentsBy_void_QTextEdit_int_int(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, int),
            NODE_ARG(2, int));
    }

    static NODE_IMPLEMENTATION(_n_showEvent0, void)
    {
        qt_QTextEdit_showEvent_void_QTextEdit_QShowEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_wheelEvent0, void)
    {
        qt_QTextEdit_wheelEvent_void_QTextEdit_QWheelEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_setupViewport0, void)
    {
        qt_QTextEdit_setupViewport_void_QTextEdit_QWidget(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer));
    }

    static NODE_IMPLEMENTATION(_n_minimumSizeHint0, Pointer)
    {
        NODE_RETURN(qt_QTextEdit_minimumSizeHint_QSize_QTextEdit(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_sizeHint0, Pointer)
    {
        NODE_RETURN(qt_QTextEdit_sizeHint_QSize_QTextEdit(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_viewportEvent0, bool)
    {
        NODE_RETURN(qt_QTextEdit_viewportEvent_bool_QTextEdit_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_viewportSizeHint0, Pointer)
    {
        NODE_RETURN(qt_QTextEdit_viewportSizeHint_QSize_QTextEdit(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer)));
    }

    static NODE_IMPLEMENTATION(_n_event0, bool)
    {
        NODE_RETURN(qt_QTextEdit_event_bool_QTextEdit_QEvent(
            NODE_THREAD, NONNIL_NODE_ARG(0, Pointer), NODE_ARG(1, Pointer)));
    }

    void QTextEditType::load()
    {
        USING_MU_FUNCTION_SYMBOLS;
        MuLangContext* c = static_cast<MuLangContext*>(context());
        Module* global = globalModule();

        const string typeName = name();
        const string refTypeName = typeName + "&";
        const string fullTypeName = fullyQualifiedName();
        const string fullRefTypeName = fullTypeName + "&";
        const char* tn = typeName.c_str();
        const char* ftn = fullTypeName.c_str();
        const char* rtn = refTypeName.c_str();
        const char* frtn = fullRefTypeName.c_str();

        scope()->addSymbols(new ReferenceType(c, rtn, this),

                            new Function(c, tn, BaseFunctions::dereference,
                                         Cast, Return, ftn, Args, frtn, End),

                            EndArguments);

        addSymbols(new Function(c, "__allocate", BaseFunctions::classAllocate,
                                None, Return, ftn, End),

                   new Function(c, tn, castFromObject, Cast, Compiled,
                                QTextEdit_QTextEdit_QObject, Return, ftn,
                                Parameters,
                                new Param(c, "object", "qt.QObject"), End),

                   EndArguments);

        addSymbols(
            // enums
            // member functions
            new Function(c, "QTextEdit", _n_QTextEdit0, None, Compiled,
                         qt_QTextEdit_QTextEdit_QTextEdit_QTextEdit_QWidget,
                         Return, "qt.QTextEdit", Parameters,
                         new Param(c, "this", "qt.QTextEdit"),
                         new Param(c, "parent", "qt.QWidget"), End),
            new Function(
                c, "QTextEdit", _n_QTextEdit1, None, Compiled,
                qt_QTextEdit_QTextEdit_QTextEdit_QTextEdit_string_QWidget,
                Return, "qt.QTextEdit", Parameters,
                new Param(c, "this", "qt.QTextEdit"),
                new Param(c, "text", "string"),
                new Param(c, "parent", "qt.QWidget"), End),
            // PROP: acceptRichText (bool; QTextEdit this)
            new Function(c, "alignment", _n_alignment0, None, Compiled,
                         qt_QTextEdit_alignment_int_QTextEdit, Return, "int",
                         Parameters, new Param(c, "this", "qt.QTextEdit"), End),
            new Function(c, "anchorAt", _n_anchorAt0, None, Compiled,
                         qt_QTextEdit_anchorAt_string_QTextEdit_QPoint, Return,
                         "string", Parameters,
                         new Param(c, "this", "qt.QTextEdit"),
                         new Param(c, "pos", "qt.QPoint"), End),
            // PROP: autoFormatting (flags QTextEdit::AutoFormatting; QTextEdit
            // this)
            new Function(c, "canPaste", _n_canPaste0, None, Compiled,
                         qt_QTextEdit_canPaste_bool_QTextEdit, Return, "bool",
                         Parameters, new Param(c, "this", "qt.QTextEdit"), End),
            new Function(c, "createStandardContextMenu",
                         _n_createStandardContextMenu0, None, Compiled,
                         qt_QTextEdit_createStandardContextMenu_QMenu_QTextEdit,
                         Return, "qt.QMenu", Parameters,
                         new Param(c, "this", "qt.QTextEdit"), End),
            new Function(
                c, "createStandardContextMenu", _n_createStandardContextMenu1,
                None, Compiled,
                qt_QTextEdit_createStandardContextMenu_QMenu_QTextEdit_QPoint,
                Return, "qt.QMenu", Parameters,
                new Param(c, "this", "qt.QTextEdit"),
                new Param(c, "position", "qt.QPoint"), End),
            // MISSING: currentCharFormat ("QTextCharFormat"; QTextEdit this)
            new Function(c, "currentFont", _n_currentFont0, None, Compiled,
                         qt_QTextEdit_currentFont_QFont_QTextEdit, Return,
                         "qt.QFont", Parameters,
                         new Param(c, "this", "qt.QTextEdit"), End),
            new Function(
                c, "cursorForPosition", _n_cursorForPosition0, None, Compiled,
                qt_QTextEdit_cursorForPosition_QTextCursor_QTextEdit_QPoint,
                Return, "qt.QTextCursor", Parameters,
                new Param(c, "this", "qt.QTextEdit"),
                new Param(c, "pos", "qt.QPoint"), End),
            new Function(c, "cursorRect", _n_cursorRect0, None, Compiled,
                         qt_QTextEdit_cursorRect_QRect_QTextEdit_QTextCursor,
                         Return, "qt.QRect", Parameters,
                         new Param(c, "this", "qt.QTextEdit"),
                         new Param(c, "cursor", "qt.QTextCursor"), End),
            new Function(c, "cursorRect", _n_cursorRect1, None, Compiled,
                         qt_QTextEdit_cursorRect_QRect_QTextEdit, Return,
                         "qt.QRect", Parameters,
                         new Param(c, "this", "qt.QTextEdit"), End),
            // PROP: cursorWidth (int; QTextEdit this)
            // PROP: document (QTextDocument; QTextEdit this)
            // PROP: documentTitle (string; QTextEdit this)
            new Function(c, "ensureCursorVisible", _n_ensureCursorVisible0,
                         None, Compiled,
                         qt_QTextEdit_ensureCursorVisible_void_QTextEdit,
                         Return, "void", Parameters,
                         new Param(c, "this", "qt.QTextEdit"), End),
            new Function(c, "find", _n_find0, None, Compiled,
                         qt_QTextEdit_find_bool_QTextEdit_string_int, Return,
                         "bool", Parameters,
                         new Param(c, "this", "qt.QTextEdit"),
                         new Param(c, "exp", "string"),
                         new Param(c, "options", "int",
                                   Value((int)QTextDocument::FindFlags())),
                         End),
            new Function(
                c, "find", _n_find1, None, Compiled,
                qt_QTextEdit_find_bool_QTextEdit_QRegularExpression_int, Return,
                "bool", Parameters, new Param(c, "this", "qt.QTextEdit"),
                new Param(c, "exp", "qt.QRegularExpression"),
                new Param(c, "options", "int",
                          Value((int)QTextDocument::FindFlags())),
                End),
            new Function(c, "fontFamily", _n_fontFamily0, None, Compiled,
                         qt_QTextEdit_fontFamily_string_QTextEdit, Return,
                         "string", Parameters,
                         new Param(c, "this", "qt.QTextEdit"), End),
            new Function(c, "fontItalic", _n_fontItalic0, None, Compiled,
                         qt_QTextEdit_fontItalic_bool_QTextEdit, Return, "bool",
                         Parameters, new Param(c, "this", "qt.QTextEdit"), End),
            new Function(c, "fontPointSize", _n_fontPointSize0, None, Compiled,
                         qt_QTextEdit_fontPointSize_double_QTextEdit, Return,
                         "double", Parameters,
                         new Param(c, "this", "qt.QTextEdit"), End),
            new Function(c, "fontUnderline", _n_fontUnderline0, None, Compiled,
                         qt_QTextEdit_fontUnderline_bool_QTextEdit, Return,
                         "bool", Parameters,
                         new Param(c, "this", "qt.QTextEdit"), End),
            new Function(c, "fontWeight", _n_fontWeight0, None, Compiled,
                         qt_QTextEdit_fontWeight_int_QTextEdit, Return, "int",
                         Parameters, new Param(c, "this", "qt.QTextEdit"), End),
            // PROP: isReadOnly (bool; QTextEdit this)
            // PROP: isUndoRedoEnabled (bool; QTextEdit this)
            // PROP: lineWrapColumnOrWidth (int; QTextEdit this)
            // PROP: lineWrapMode (flags QTextEdit::LineWrapMode; QTextEdit
            // this)
            _func[0] = new MemberFunction(
                c, "loadResource", _n_loadResource0, None, Compiled,
                qt_QTextEdit_loadResource_QVariant_QTextEdit_int_QUrl, Return,
                "qt.QVariant", Parameters, new Param(c, "this", "qt.QTextEdit"),
                new Param(c, "type", "int"), new Param(c, "name", "qt.QUrl"),
                End),
            // MISSING: mergeCurrentCharFormat (void; QTextEdit this, "const
            // QTextCharFormat &" modifier)
            new Function(c, "moveCursor", _n_moveCursor0, None, Compiled,
                         qt_QTextEdit_moveCursor_void_QTextEdit_int_int, Return,
                         "void", Parameters,
                         new Param(c, "this", "qt.QTextEdit"),
                         new Param(c, "operation", "int"),
                         new Param(c, "mode", "int",
                                   Value((int)QTextCursor::MoveAnchor)),
                         End),
            // PROP: overwriteMode (bool; QTextEdit this)
            // PROP: placeholderText (string; QTextEdit this)
            // MISSING: print (void; QTextEdit this, "QPagedPaintDevice *"
            // printer) PROP: setAcceptRichText (void; QTextEdit this, bool
            // accept) PROP: setAutoFormatting (void; QTextEdit this, flags
            // QTextEdit::AutoFormatting features) MISSING: setCurrentCharFormat
            // (void; QTextEdit this, "const QTextCharFormat &" format) PROP:
            // setCursorWidth (void; QTextEdit this, int width) PROP:
            // setDocument (void; QTextEdit this, QTextDocument document) PROP:
            // setDocumentTitle (void; QTextEdit this, string title) PROP:
            // setLineWrapColumnOrWidth (void; QTextEdit this, int w) PROP:
            // setLineWrapMode (void; QTextEdit this, flags
            // QTextEdit::LineWrapMode mode) PROP: setOverwriteMode (void;
            // QTextEdit this, bool overwrite) PROP: setPlaceholderText (void;
            // QTextEdit this, string placeholderText) PROP: setReadOnly (void;
            // QTextEdit this, bool ro) PROP: setTabChangesFocus (void;
            // QTextEdit this, bool b) PROP: setTabStopDistance (void; QTextEdit
            // this, double distance)
            new Function(c, "setTextCursor", _n_setTextCursor0, None, Compiled,
                         qt_QTextEdit_setTextCursor_void_QTextEdit_QTextCursor,
                         Return, "void", Parameters,
                         new Param(c, "this", "qt.QTextEdit"),
                         new Param(c, "cursor", "qt.QTextCursor"), End),
            // PROP: setTextInteractionFlags (void; QTextEdit this, flags
            // Qt::TextInteractionFlags flags) PROP: setUndoRedoEnabled (void;
            // QTextEdit this, bool enable) PROP: setWordWrapMode (void;
            // QTextEdit this, flags QTextOption::WrapMode policy) PROP:
            // tabChangesFocus (bool; QTextEdit this) PROP: tabStopDistance
            // (double; QTextEdit this)
            new Function(c, "textBackgroundColor", _n_textBackgroundColor0,
                         None, Compiled,
                         qt_QTextEdit_textBackgroundColor_QColor_QTextEdit,
                         Return, "qt.QColor", Parameters,
                         new Param(c, "this", "qt.QTextEdit"), End),
            new Function(c, "textColor", _n_textColor0, None, Compiled,
                         qt_QTextEdit_textColor_QColor_QTextEdit, Return,
                         "qt.QColor", Parameters,
                         new Param(c, "this", "qt.QTextEdit"), End),
            new Function(c, "textCursor", _n_textCursor0, None, Compiled,
                         qt_QTextEdit_textCursor_QTextCursor_QTextEdit, Return,
                         "qt.QTextCursor", Parameters,
                         new Param(c, "this", "qt.QTextEdit"), End),
            // PROP: textInteractionFlags (flags Qt::TextInteractionFlags;
            // QTextEdit this) PROP: toHtml (string; QTextEdit this) PROP:
            // toMarkdown (string; QTextEdit this, flags
            // QTextDocument::MarkdownFeatures features)
            new Function(c, "toPlainText", _n_toPlainText0, None, Compiled,
                         qt_QTextEdit_toPlainText_string_QTextEdit, Return,
                         "string", Parameters,
                         new Param(c, "this", "qt.QTextEdit"), End),
            // PROP: wordWrapMode (flags QTextOption::WrapMode; QTextEdit this)
            _func[1] = new MemberFunction(
                c, "inputMethodQuery", _n_inputMethodQuery0, None, Compiled,
                qt_QTextEdit_inputMethodQuery_QVariant_QTextEdit_int, Return,
                "qt.QVariant", Parameters, new Param(c, "this", "qt.QTextEdit"),
                new Param(c, "property", "int"), End),
            _func[2] = new MemberFunction(
                c, "canInsertFromMimeData", _n_canInsertFromMimeData0, None,
                Compiled,
                qt_QTextEdit_canInsertFromMimeData_bool_QTextEdit_QMimeData,
                Return, "bool", Parameters,
                new Param(c, "this", "qt.QTextEdit"),
                new Param(c, "source", "qt.QMimeData"), End),
            _func[3] = new MemberFunction(
                c, "createMimeDataFromSelection",
                _n_createMimeDataFromSelection0, None, Compiled,
                qt_QTextEdit_createMimeDataFromSelection_QMimeData_QTextEdit,
                Return, "qt.QMimeData", Parameters,
                new Param(c, "this", "qt.QTextEdit"), End),
            _func[4] = new MemberFunction(
                c, "insertFromMimeData", _n_insertFromMimeData0, None, Compiled,
                qt_QTextEdit_insertFromMimeData_void_QTextEdit_QMimeData,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QTextEdit"),
                new Param(c, "source", "qt.QMimeData"), End),
            _func[5] = new MemberFunction(
                c, "changeEvent", _n_changeEvent0, None, Compiled,
                qt_QTextEdit_changeEvent_void_QTextEdit_QEvent, Return, "void",
                Parameters, new Param(c, "this", "qt.QTextEdit"),
                new Param(c, "e", "qt.QEvent"), End),
            _func[6] = new MemberFunction(
                c, "contextMenuEvent", _n_contextMenuEvent0, None, Compiled,
                qt_QTextEdit_contextMenuEvent_void_QTextEdit_QContextMenuEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QTextEdit"),
                new Param(c, "event", "qt.QContextMenuEvent"), End),
            _func[7] = new MemberFunction(
                c, "dragEnterEvent", _n_dragEnterEvent0, None, Compiled,
                qt_QTextEdit_dragEnterEvent_void_QTextEdit_QDragEnterEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QTextEdit"),
                new Param(c, "e", "qt.QDragEnterEvent"), End),
            _func[8] = new MemberFunction(
                c, "dragLeaveEvent", _n_dragLeaveEvent0, None, Compiled,
                qt_QTextEdit_dragLeaveEvent_void_QTextEdit_QDragLeaveEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QTextEdit"),
                new Param(c, "e", "qt.QDragLeaveEvent"), End),
            _func[9] = new MemberFunction(
                c, "dragMoveEvent", _n_dragMoveEvent0, None, Compiled,
                qt_QTextEdit_dragMoveEvent_void_QTextEdit_QDragMoveEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QTextEdit"),
                new Param(c, "e", "qt.QDragMoveEvent"), End),
            _func[10] = new MemberFunction(
                c, "dropEvent", _n_dropEvent0, None, Compiled,
                qt_QTextEdit_dropEvent_void_QTextEdit_QDropEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QTextEdit"),
                new Param(c, "e", "qt.QDropEvent"), End),
            _func[11] = new MemberFunction(
                c, "focusInEvent", _n_focusInEvent0, None, Compiled,
                qt_QTextEdit_focusInEvent_void_QTextEdit_QFocusEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QTextEdit"),
                new Param(c, "e", "qt.QFocusEvent"), End),
            _func[12] = new MemberFunction(
                c, "focusNextPrevChild", _n_focusNextPrevChild0, None, Compiled,
                qt_QTextEdit_focusNextPrevChild_bool_QTextEdit_bool, Return,
                "bool", Parameters, new Param(c, "this", "qt.QTextEdit"),
                new Param(c, "next", "bool"), End),
            _func[13] = new MemberFunction(
                c, "focusOutEvent", _n_focusOutEvent0, None, Compiled,
                qt_QTextEdit_focusOutEvent_void_QTextEdit_QFocusEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QTextEdit"),
                new Param(c, "e", "qt.QFocusEvent"), End),
            // MISSING: inputMethodEvent (void; QTextEdit this,
            // "QInputMethodEvent *" e) // protected
            _func[14] = new MemberFunction(
                c, "keyPressEvent", _n_keyPressEvent0, None, Compiled,
                qt_QTextEdit_keyPressEvent_void_QTextEdit_QKeyEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QTextEdit"),
                new Param(c, "e", "qt.QKeyEvent"), End),
            _func[15] = new MemberFunction(
                c, "keyReleaseEvent", _n_keyReleaseEvent0, None, Compiled,
                qt_QTextEdit_keyReleaseEvent_void_QTextEdit_QKeyEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QTextEdit"),
                new Param(c, "e", "qt.QKeyEvent"), End),
            _func[16] = new MemberFunction(
                c, "mouseDoubleClickEvent", _n_mouseDoubleClickEvent0, None,
                Compiled,
                qt_QTextEdit_mouseDoubleClickEvent_void_QTextEdit_QMouseEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QTextEdit"),
                new Param(c, "e", "qt.QMouseEvent"), End),
            _func[17] = new MemberFunction(
                c, "mouseMoveEvent", _n_mouseMoveEvent0, None, Compiled,
                qt_QTextEdit_mouseMoveEvent_void_QTextEdit_QMouseEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QTextEdit"),
                new Param(c, "e", "qt.QMouseEvent"), End),
            _func[18] = new MemberFunction(
                c, "mousePressEvent", _n_mousePressEvent0, None, Compiled,
                qt_QTextEdit_mousePressEvent_void_QTextEdit_QMouseEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QTextEdit"),
                new Param(c, "e", "qt.QMouseEvent"), End),
            _func[19] = new MemberFunction(
                c, "mouseReleaseEvent", _n_mouseReleaseEvent0, None, Compiled,
                qt_QTextEdit_mouseReleaseEvent_void_QTextEdit_QMouseEvent,
                Return, "void", Parameters,
                new Param(c, "this", "qt.QTextEdit"),
                new Param(c, "e", "qt.QMouseEvent"), End),
            _func[20] = new MemberFunction(
                c, "paintEvent", _n_paintEvent0, None, Compiled,
                qt_QTextEdit_paintEvent_void_QTextEdit_QPaintEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QTextEdit"),
                new Param(c, "event", "qt.QPaintEvent"), End),
            _func[21] = new MemberFunction(
                c, "resizeEvent", _n_resizeEvent0, None, Compiled,
                qt_QTextEdit_resizeEvent_void_QTextEdit_QResizeEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QTextEdit"),
                new Param(c, "e", "qt.QResizeEvent"), End),
            _func[22] = new MemberFunction(
                c, "scrollContentsBy", _n_scrollContentsBy0, None, Compiled,
                qt_QTextEdit_scrollContentsBy_void_QTextEdit_int_int, Return,
                "void", Parameters, new Param(c, "this", "qt.QTextEdit"),
                new Param(c, "dx", "int"), new Param(c, "dy", "int"), End),
            _func[23] = new MemberFunction(
                c, "showEvent", _n_showEvent0, None, Compiled,
                qt_QTextEdit_showEvent_void_QTextEdit_QShowEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QTextEdit"),
                new Param(c, "_p13", "qt.QShowEvent"), End),
            _func[24] = new MemberFunction(
                c, "wheelEvent", _n_wheelEvent0, None, Compiled,
                qt_QTextEdit_wheelEvent_void_QTextEdit_QWheelEvent, Return,
                "void", Parameters, new Param(c, "this", "qt.QTextEdit"),
                new Param(c, "e", "qt.QWheelEvent"), End),
            _func[25] = new MemberFunction(
                c, "setupViewport", _n_setupViewport0, None, Compiled,
                qt_QTextEdit_setupViewport_void_QTextEdit_QWidget, Return,
                "void", Parameters, new Param(c, "this", "qt.QTextEdit"),
                new Param(c, "viewport", "qt.QWidget"), End),
            _func[26] = new MemberFunction(
                c, "minimumSizeHint", _n_minimumSizeHint0, None, Compiled,
                qt_QTextEdit_minimumSizeHint_QSize_QTextEdit, Return,
                "qt.QSize", Parameters, new Param(c, "this", "qt.QTextEdit"),
                End),
            _func[27] = new MemberFunction(
                c, "sizeHint", _n_sizeHint0, None, Compiled,
                qt_QTextEdit_sizeHint_QSize_QTextEdit, Return, "qt.QSize",
                Parameters, new Param(c, "this", "qt.QTextEdit"), End),
            _func[28] = new MemberFunction(
                c, "viewportEvent", _n_viewportEvent0, None, Compiled,
                qt_QTextEdit_viewportEvent_bool_QTextEdit_QEvent, Return,
                "bool", Parameters, new Param(c, "this", "qt.QTextEdit"),
                new Param(c, "event", "qt.QEvent"), End),
            _func[29] = new MemberFunction(
                c, "viewportSizeHint", _n_viewportSizeHint0, None, Compiled,
                qt_QTextEdit_viewportSizeHint_QSize_QTextEdit, Return,
                "qt.QSize", Parameters, new Param(c, "this", "qt.QTextEdit"),
                End),
            _func[30] = new MemberFunction(
                c, "event", _n_event0, None, Compiled,
                qt_QTextEdit_event_bool_QTextEdit_QEvent, Return, "bool",
                Parameters, new Param(c, "this", "qt.QTextEdit"),
                new Param(c, "event_", "qt.QEvent"), End),
            // static functions
            EndArguments);
        globalScope()->addSymbols(EndArguments);
        scope()->addSymbols(EndArguments);

        const char** propExclusions = 0;

        populate(this, QTextEdit::staticMetaObject, propExclusions);
    }

} // namespace Mu
